Welcome

Welcome to Beyond Compare 4

Beyond Compare is a utility for comparing files and folders. It can help you find and reconcile differences in source code, folders, images and data, even if your files are contained in zip archive files or on remote services (e.g. FTP sites). It can synchronize your folders, and validate your copies.

Beyond Compare seamlessly coordinates the entire comparison job, from the folder structure down to individual differences in files. Specialized file views communicate difference info back to the folder session, helping you quickly concentrate on important differences. Beyond Compare remembers your various sessions so that you can come back to the same comparison job time after time.

This document describes both the Standard and Pro editions of Beyond Compare. Features that are only available in the Pro edition are indicated by this green icon:

Beyond Compare is available for computers running Windows, Mac and Linux. Items in this document that refer to a specific platform are indicated by these icons:


What's New

Here are some of the significant new features in Beyond Compare 4. Items flagged with [image] are only available in the Pro edition.

Mac version

Beyond Compare now runs natively on Mac.

BC for Mac has all the power and functionality you've come to expect from Beyond Compare, now with native look and feel, speed, and enhancements to make it feel at home.

Overhauled Home view

The new Home View adds session search and web resources. The layout is easier to manage with on-screen controls.

3-way Folder Merge

Three-way merging now extends to folders. Compare independent changes against a common ancestor to quickly merge your changes with someone else's. It makes merging your customizations into a new release a snap.

Ad hoc unimportant text

It is now easier to define unimportant text in your Text Compares. Define unimportant terms directly from the Session Settings dialog, rather than having to edit your file formats.

Amazon S3, Dropbox, OneDrive, Subversion and WebDAV support

In addition to FTP, you can access Amazon S3 cloud storage, Dropbox cloud storage, OneDrive cloud storage, Subversion repositories, and WebDAV resources directly from within Beyond Compare. Organize your remote service profiles with friendly names and folder hierarchies.

Overhauled Picture Compare

Picture Compare has a new look, with automatic zoom, pixel-level details, and simplified controls. Tolerance comparison mode uses grayscale to reveal the image along with the differences.

Overhauled Options dialog with search

The reorganized Options dialog includes a search feature for finding specific settings quickly. Commands for all comparison types can be customized without first having to open a view.

Other significant features

·Data Compare is now called Table Compare.

·Hex Compare wraps lines to fit the window, and adds in-line editing.

·New View Patch command shows diff/patch files as a text comparison.

·Added new text comparison algorithm choice based on Bram Cohen's Patience Diff.

·HTML folder comparison reports can now embed links to file comparisons.

·Improved appearance on high DPI (retina) displays.

·Version Compare now compares the fixed PE header in addition to the version resource.

·Zipx archives can be compared, complete with PPMd, LZMA, WavPack, and WinZip's JPEG compression.

·Added support for portable media devices (aka "MTP") including Android 4.0+ phones and cameras.


Standard vs. Pro Editions

The Standard edition of Beyond Compare is a powerful full-featured comparison tool, not a stripped-down "lite" version. The Standard edition has full-screen editing, full Unicode support, syntax highlighting and much more.

However, the Pro edition adds these advanced functions:

3-way merging

Compares independent changes against a common ancestor to create new merged content, for folders or individual files.

Text replacements

Specifies text as unimportant if it is changed to a specific value on the other side. For example, you can make apple found on the left when compared to orange on the right an unimportant difference.

Folder Compare alignment overrides

Overrides how files are aligned in a Folder Compare session. For example, you could compare your .gif files on one side with .png files of the same name on the other side.

Source control integration

Adds commands for checking files in or out of SCC-compliant version control systems.

SFTP support

Rather than relying on third-party solutions, Beyond Compare Pro has integrated support for secure FTP protocols (SFTP and FTP over SSL).

Registry Compare

Compares live registries, both local and remote, as well as registry files.

Note The trial download of Beyond Compare actually contains both Standard and Pro editions. You can disable Pro mode in the Help > About dialog in order to limit your trial to Standard functionality.

Your license key will unlock the appropriate edition for permanent use. If you choose the Standard Edition license, you can upgrade later to Pro for the difference in price.


Using Beyond Compare

Beyond Compare handles a wide variety of comparison tasks. It has specialized views for different kinds of files and different approaches to reconciling differences.

Each comparison task is called a Session. Sessions can be individualized, named and reused. Many of Beyond Compare's settings are managed and stored by session rather than as program-wide options, to give you greater flexibility. You can save different sessions with quite different settings, to accommodate differing tasks.

A Child Session is a file session that originated from a folder session.

Sessions can be opened in separate windows, or as multiple tabs on a single window. We refer to open sessions as Views. You can have multiple windows open, each with multiple tabs. You can drag a tab from one window to another, or right-click on a tab and pick Move Tab to New Window to move that tab onto its own window. (See Tab Options.)

You can save currently open sessions as a Workspace, and load them again later with the same configuration of windows and tabs. (See Managing Workspaces.)

The session settings that control how comparisons are performed are called Rules. Rules help you concentrate on important differences. Beyond Compare also maintains a list of File Formats to specify how various types of files are to be handled. You can modify the built-in file formats or create your own.

Credentials and other settings for remote services (FTP, WebDAV, Dropbox and others) are stored as named Profiles. (See Profile Management.)

This part of the documentation provides an overview of the various types of sessions and program concepts mentioned above.

See also

Glossary


Home View

Home View Overview

When you open a new window or tab, Beyond Compare displays the Home view:

Click to zoom

From the Home view, you can:

·Start a new comparison session of any type

·Open one of your previously saved sessions

·Open an auto-saved session

·Search for a session

·Manage the settings for your saved sessions

·Edit the default settings to use for new sessions

You can also drag and drop files or folders from a file manager such as Windows Explorer onto this view to compare them. Drag and drop onto one of the large buttons to start a session of that specific type.


Managing Sessions

Beyond Compare automatically saves your most recent sessions so you can come back to them easily. If you want to retain a session indefinitely, you can save it with a descriptive name. You can also organize your named sessions within session folders.

Use the Home view to manage all your sessions in one place. In the Sessions tree, you can right-click on a saved session and pick Edit to show the management panel. Click on the Pin Session Management Panel [image] button or mark View > Show Session Management to force it to always be shown in the Home view. Delete and Rename are also available in the right-click menu for saved sessions.

A named session can be locked to guard against accidental modifications. Right-click on it in the Sessions tree and pick Lock.

Once a session is opened in a view, the Session menu contains common commands for manipulating it. If you make a change to the primary parameters of a named session, you will be prompted to save it on exit.

To change default session settings

In the Home view's Sessions tree, under the New branch, select a session type. Right-click on it and pick Edit to show the management panel. Changes to these default settings will now be used for any newly created sessions of that type.

See also

Session Settings


Sharing Sessions

Multiple users can share sessions by using a shared sessions file.

To create a shared sessions file

1.Pick Tools > Export Settings to create a settings package (.bcpkg) with any subset of your sessions.

2.Place the package file in an appropriate shared folder.

To access a shared sessions file

1.Pick Tools > Options [image].

2.On the Tweaks page, in the Shared Sessions File section, enter the location of the package file.

Shared sessions will then appear as a new branch in the Sessions tree:

Note that shared sessions are read-only, and cannot be edited within Beyond Compare. To make changes to shared sessions, you need to recreate the package file as described above.


Folder Compare Overview

A Folder Compare session compares two folder structures side-by-side, in a variation of the familiar Windows Explorer style. The comparison may be of folders on your hard drive or network, but either side also may be a remote service (e.g. FTP site), an archive file, or a snapshot taken earlier. All of these have a structure – folders and subfolders containing files – and Beyond Compare treats them equivalently.

Click to zoom

See also

Folder Compare Commands

Folder Compare Settings

Archive Type Options


Understanding the Folder Compare Display

The Folder Compare display uses color cues to highlight the differences between the two base folders. By default, the color meanings are:

Gray | Unknown or older
Black | Same
Purple | Orphan (does not exist on other side)
Red | Newer or different

Pick View > Legend to display a guide to the various folder icon color combinations.

To change the default colors, pick Tools > Options [image], switch to the Colors, Fonts > Folder Views page, and find the Compare colors settings.

You can click on a column header to sort by that column, or right-click the header to pick different columns to display.

Files in the display

In the following example, the file on the right side is colored red to show that it is newer. The icon in the center column [image] shows that a content comparison has found differences.

The color spot to the left of a filename shows the difference color cue, even when a selection obscures the coloring of the other elements on the line.

The center column shows the results of a content comparison, if one has been performed.

The content comparison results can override the file colors. For example, the above line would change to all black if the content comparison determines the files match. To disable this behavior, pick Session > Session Settings [image], switch to the Comparison tab, and unmark the Override quick test results checkbox.

On Windows file systems, the filename may be followed by letters in parenthesis that represent the DOS attributes of read-only (r), hidden (h), archive (a), and system (s).

Some file types, such as zip archive files, can be a container for other files. Beyond Compare can handle these like regular folders. The following example shows our compiled help file with a newer version on the right side. Notice the special "zipper" icon.

You can double-click the file to expand it and compare each of the contained files.

Folders in the display

Folders are colored to give you hints about their contents. For instance, the comparison below lets you know that the folders contain at least one file that is newer on the right (red), and that both sides have at least one orphaned file (purple).

Folders may appear hollow when you first start the comparison. This happens when the background scanning process has not yet completed those folders. They will change color when the process is finished.

A folder will be yellow if auto-scan is turned off and you haven't opened the folder yet. Once you manually open the folder (and possibly its subfolders) it will be colored appropriately.

Folder icons will include a small arrow glyph if the folder is a junction point or symbolic link. Folder icons will include a small red "X" glyph if there was an error trying to open the folder. The following example shows a folder with both conditions.


How to Compare in the Folder Compare

How to Compare in the Folder Compare View

There are several ways to compare folders and files.

If you want a quick look at what has changed between two folders, it might be sufficient to just look at the dates and sizes of the files. If you are validating a CD copy, then a byte-by-byte comparison of every file is important. If you are comparing versions of source code, perhaps you want to consider only significant changes and ignore differences in whitespace or comments.

Session settings define how, overall, a Folder Compare session should compare folders when the session is loaded. Comparison criteria include file timestamps, sizes, attributes and contents. Once the session is loaded, you can selectively recompare files by picking Actions > Compare Contents [image] or by opening the files in a file session.

Generally, these criteria are used to compare files, and not folders directly. For instance, a folder's timestamp does not affect the comparison. A folder is classified as "newer" if it contains newer files. Folders are compared by aggregating the comparisons of files within them.

Certain facts about a file can be determined quickly while others take some time. In the Session Settings dialog, the Comparison tab is organized into Quick tests and Requires opening files. File systems typically provide fast access to file names, sizes, and timestamps (the date and time last modified). But to get the CRC of a file, the entire file will need to be read. Keep this in mind when selecting folder comparison criteria.

The display aligns files and subfolders of the same name, left and right. Pick View > Ignore Folder Structure [image] to align files regardless of what subfolder they are in.

You can modify the alignment by defining alignment overrides.

See also

Content Comparisons


Filtering the Folder Compare View

There are three overall type of filters you can use to control a Folder Compare session's scope: File Filters that include or exclude files based on their name or attributes, Display Filters that show or hide lines of the comparison based on comparison status, and Folder Display Filters that control when folders appear.

For instance, you can set the display filter to View > Show Left Newer [image] to display only those files that are newer on the left side of the comparison. Or you can set a file filter to exclude *.bak files if you don't want to see or manipulate them.

By default, commands that act on a selected folder's contents (such as Copy, Move, Delete, etc.) will respect the current filters. That is, if the selection includes a folder, the folder's filtered-out contents are skipped. To change this default behavior, pick Tools > Options [image], switch to the File Operations page, and mark the Include hidden items by default checkbox. In either case, action dialogs allow you to override the default behavior on a case-by-case basis.

Pick View > Suppress Filters [image] to temporarily suppress file filters and display filters. Files and folders that were hidden will appear colored teal (blue-green) and can be processed.

File Filters

You can specify the type of files you want to include in (or exclude from) the session. For instance, if you are comparing Delphi projects you could include file types such as *.pas, *.dfm, and *.dpr. Or, you could include all files except *.dcu and *.~* by excluding these file types.

To specify a simple "include these types" filter, use the Filters toolbar edit. Enter the file types separated by semicolons, or use the dropdown list to select from presets. Include a minus sign (-) in front of files to be excluded.

In addition to these simple wildcard filters, you can specify more complex filters that include or exclude files or folders by name. Pick Session > Session Settings [image], and switch to the Name Filters tab. Or, simply click the Filters [image] toolbar button.

Files can also be filtered based on their modified date, size, file attributes or text content. In the Session Settings dialog, switch to the Other Filters tab. (Folders are not directly filtered based on their attributes, but are affected by the filtering of their contents.)

Display Filters

Display filters limit the view to certain comparison results. The comparison results are determined by the session's comparison rules. For instance, you can pick View > Show Differences [image] to remove all the matching files so that you can concentrate on the mismatches.

Folder Display Filters

By default, folders only appear if at least one file they contain is visible. However, you can switch to one of the other folder display filters.

View > Always Show Folders [image] causes all folders to appear (unless they have been explicitly excluded by file filters), regardless of the other display filter selection.

View > Compare Files and Folder Structure [image] causes folders to respect the display filters. For example, if the main display filter is Show All [image] then all folders appear. If it is Show Orphans [image], only orphan folders and folders that contain orphan files are shown.

View > Only Compare Files [image] suppresses all empty folders, both truly empty folders and folders whose entire contents are hidden by other display or file filters.

View > Ignore Folder Structure [image] hides the folder tree and aligns files regardless of what subfolder they are in.

See also

Folder Compare Name Filters

Folder Compare Other Filters

Display Filters


Reconciling Differences in the Folder Compare

Reconciling Differences in the Folder Compare View

A Folder Compare session provides commands, such as Copy, Move, Delete and Synchronize, to help you reconcile differences on the folder level. It also is a platform for spawning file views to understand and reconcile differences within files.

Actions generally require a selection. You can select specific files or folders from either or both sides and then perform some action on them. (If you want to synchronize the entire contents of the base folders, consider using a Folder Sync session instead.)

To select items in the Folder Compare view

Click on an item on either side of the display to select it. You can click in the center column to select both sides at once. Hold down the Ctrl key and click to add items to your selection. To select a range of items, press the mouse button over the first, swipe to the last, and release the button. If your swipe crosses the middle column, entries on both sides will be selected.

To select all items on one side

Pick Edit > Select All [image] (or Edit > Select All Files [image]). Hold down the Shift key and press the left arrow key to limit the selection to the left side. Press the right arrow key instead to limit the selection to the right side.

To compare files with different names

Click the first file, hold down the Ctrl key and click the second one, and then pick Actions > Open. To use the keyboard instead, position on the first file and press the space bar, then position on the second one and press the space bar.


Folder Merge Overview

A Folder Merge session displays two or three folder structures side-by-side. The left and right panes hold two versions of a folder structure. Beyond Compare helps you combine changes from both versions into a specified output folder. The optional center pane holds an older version of the folder structure, a common ancestor of the left and right versions.

Click to zoom

See also

Folder Merge Commands

Folder Merge Settings

Archive Type Options


Understanding the Folder Merge Display

The Folder Merge display uses color cues to highlight the differences between the base folders. By default, the color meanings are:

Gray | Unknown or older
Black | Same
Teal | Left change
Magenta | Right change
Orange | Mergeable
Red | Conflict

Pick View > Legend to display a guide to the various folder icon color combinations.

To change the default colors, pick Tools > Options [image], switch to the Colors, Fonts > Folder Views page, and find the Merge colors settings.

You can temporarily hide the Center Pane [image] to give the left and right panes more room.

Merge actions

Regardless of merge target:

No action required

Automatic merge

Manual merge required

When merging to left:

Copy to left

Delete left

When merging to right:

Copy to right

Delete right

When merging to other:

Take left

Take center

Take right

Delete


Folder Sync Overview

A Folder Sync session is a specialized folder session that synchronizes folders by copying or deleting files. Once you set up a Folder Sync session you can save it for future use.

Click to zoom

See also

Folder Sync Commands

Folder Sync Settings

Archive Type Options


Understanding the Folder Sync Display

Sync actions

Right file will be copied to the left

Left file will be copied to the right

Left file will be deleted

Right file will be deleted

Files will be left alone unless you pick an override from the Actions menu

Right folder contains files that will be copied to the left

Left folder contains files that will be copied to the right

Left folder contains files that will be deleted

Right folder contains files that will be deleted

Left folder contains files that will be copied to the right and files that will be deleted

Right folder contains files that will be copied to the left and files that will be deleted


How to Sync in the Folder Sync

How to Sync in the Folder Sync View

Setting sync parameters

In the upper part of the view, specify the Left folder and Right folder involved. Either or both base folders may be on remote services. (You can use the Browse buttons to specify a remote service.)

Pick one of these standard sync methods from the dropdown list in the middle of the view:

Update Left

Copies newer and orphan files from right to left.

Update Right

Copies newer and orphan files from left to right.

Update Both

Copies newer and orphan files to the other side.

Mirror to Left

Replaces all different items on left, deletes any orphans on left, and copies any right side orphans to the left.

Mirror to Right

Replaces all different items on right, deletes any orphans on right, and copies any left side orphans to the right.

Click the Rules [image] button to define what constitutes a difference.

You can also specify Filters [image] to limit the scope of the sync.

Previewing the sync

Click the Accept [image] button if necessary to accept changes, and a preview of all copy and delete operations will appear in the lower part of the view.

You can double-click any file pair to examine the differences in detail. To skip selected operations, pick Actions > Exclude.

Starting the sync

Click the Sync Now [image] button to begin processing.


Text Compare Overview

A Text Compare session visually compares two text files, in a side-by-side or over-under layout. It helps you analyze and reconcile differences, with a variety of display, search, and editing functions available.

Click to zoom

In addition to files on your hard drive or network, you can specify files from a remote service, from within an archive file, or the content of a webpage. Example file specs:

C:\MyArchive.zip\MyFile.txt

/home/username/Desktop/MyFile

ftp://username@ftp.hostname.com/file.txt

http://www.scootersoftware.com/index.html

You can also compare against text on the clipboard by picking File > Open Clipboard.

The Text Compare view displays files in two editor panes that scroll together. Text is colored to highlight differences between the files. By default, the color scheme uses red to flag important differences (insertions, deletions, and changes) and blue for unimportant differences. The session's rules and file formats control how text is classified.

The display background is also colored to help you spot the differences. A light red background indicates an important difference somewhere on the line, while light blue indicates an unimportant difference. The light red background takes precedence over the light blue. This makes it easy to find differences, even if they are horizontally scrolled out of view. You can adjust these colors to suit your preferences. (See File View Color, Font Options.)

On the left edge of the display is the optional thumbnail. It represents each line of the comparison as a colored line, one pixel high. At a glance you can see the pattern of differences throughout the comparison. The white rectangle represents the main display's current view, and the small triangle represents the display's current line. Click on a line in the thumbnail to position the display at that location.

Below the main panes, the current line from each file is displayed using the entire width of the window. In the View menu, pick Text Details [image] for an editable text view, Hex Details [image] for a read-only hexadecimal view, or Alignment Details [image] for an editable view of the character alignment.

See also

Text Compare Commands

Text Compare Settings

Text Format Settings

Text Editing Options


Editing Text

Each pane of the Text Compare view is a full-featured text editor. You can enter and edit text like any other text editor, although as you do the comparison is continually updated to reflect differences between the panes.

Line mode vs. character mode

The Full Edit [image] command toggles the editor between Line Mode and Character Mode. In line mode, editing occurs on a line-by-line basis, so selection, cut, copy, paste, delete, etc. all affect entire lines. While in line mode you can edit individual lines using the Text Details area. Line mode supports disjointed selections. In character mode the main panes support editing text. Selection and editing commands all affect individual characters or spans of characters. Character mode can only have a single, continuous selection.

Visible whitespace

Enabling the Visible Whitespace [image] command allows you to see where spaces, tabs, and line endings occur in your files. The following example illustrates each of them.

Space

Tab

Windows line ending

Mac line ending

Unix line ending

Editing disabled

Beyond Compare disables editing of a file for any of the following reasons:

·The comparison encountered an error.

·The comparison was cancelled.

·The location of the file is read-only (e.g. 7zip/CHM/RAR archives, CD-ROMs, DVD-ROMs).

·The file format conversion doesn't support saving.

·Editing in the parent folder session has been disabled.

·Editing in the file session has been disabled.

·Command line switches have disabled editing.


Walking Through Differences

In the Search menu, the Next Difference Section [image] and Previous Difference Section [image] commands help you step through all the differences in your files, and all your files with differences. In the Text Compare session, pick Next Difference Section to position at the next range of lines with differences or Previous Difference Section to go back to the previous range of lines with differences.

The arrow icons will either be disabled or change color from bright yellow to dull yellow to indicate that there are no more differences in that direction. To configure what happens when there are no more differences, see File View Next Difference Options.

In Text Compare sessions, the current file format controls whether Next and Previous are on a line-by-line basis or a section-by-section basis. To access the current file format from a Text Compare session, pick Session > Session Settings [image], switch to the Importance tab, and click the Edit Grammar button. Then, on the Text Format dialog's Misc tab, toggle Lines are independent.

In the Search menu, pick Next Difference or Previous Difference to position on individual differences in long lines with multiple differences.

In the Search menu, pick Next Difference Files [image] or Previous Difference Files [image] to jump directly to the next files with differences in the associated folder view.


Searching for Text

To search for text in a Text Compare session, pick Search > Find [image]. Type the text or a regular expression pattern in the edit, or pick a previous search from the dropdown list. Click on the Insert Regular Expression Element [image] button to pick from a list of common regular expression terms. Pick one from the list to insert it in the edit.

Click the Next button to move the cursor to the next match. If the editor is in line mode, you can click the Select All button to select all the lines that contain a match.

The Find panel options are:

Option | Meaning
Regular expression | Interpret search text as a Perl compatible regular expression.
Match character case | Only match text with the same character case (uppercase or lowercase).
Whole words only | Searching for apple will not match on apples, applesauce or snapple.
Wrap search | When one end of the file is reached, continue searching at the other end.
Sides | Select which side(s) of the comparison to search.
Close automatically | Panel will hide after search is started.

Pick Find Next [image] or Find Previous [image] to continue searching for the same text.

To find and replace text, pick Replace [image].


Text Merge Overview

A Text Merge session contains two or three non-editable source panes and an editable output pane. The left and right panes hold two versions of a file. Beyond Compare helps you combine changes from both versions into the output pane. The optional center pane holds an older version of the file, a common ancestor of the left and right versions.

Click to zoom

You can temporarily hide the Center Pane [image] to give the left and right panes more room. You can also use the Detached Output Pane [image] to move the output into a separate window. If you have a second monitor, you can then move this window onto it.

The output content is constructed automatically as the comparison loads. You can manually edit the output, or use the Take commands to pull text from a specific source file, overriding the default merge.

It is important to note that any prior copy of the output file is ignored. If it existed before the merge session, or was changed during the session, the existing content will be lost if you save the merge session output.

See also

3-way Merge Concepts

Text Merge Commands

Text Merge Settings

Text Format Settings

Text Editing Options


Using Text Merge

Once Beyond Compare has completed the comparison it will show up to four panes: The left, center, and right panes at the top, with an output pane below it. If you include a center file Beyond Compare will be able to compare both files to it and mark changes as additions, modifications, or deletions on each specific side. Changes on the left are marked in teal and changes on the right are marked in magenta. Overlapping changes are considered conflicts and are marked in red. (You can change the color scheme if you like.)

Conflicts

Any time there are different changes in the left and right side that are on the same lines or within two lines of each other those sections will be considered a conflict and will be colored red in the three input panes. The output will be considered a conflict. If the same change is made in both the left and right side it isn't considered a conflict.

Display Filters

When merging, the display filters switch from Beyond Compare's traditional ones to new ones that check the merging status of each line. Using those filters you can limit the display to just conflicts or just changes on one side or the other.

Merging

You can navigate from difference to difference in both the input and output panes and the windows will stay synced up. When you are positioned on a difference you can use the Take Left [image], Take Center [image], and Take Right [image] commands to accept the changes from the left or right or keep the original from the center. The "Take" commands are available on the toolbar, in each edit's popup menu, and as buttons next to each section in the output pane. When it first loads, the output pane will match the center except when it can automatically take non-conflicting changes. Each change will be colored to match the pane it originally came from. While merging you can also edit the output pane directly, which will change the section to yellow. If you want to revert to one of the original inputs just use the "Take" command again.


Table Compare Overview

A Table Compare session compares text files containing tabular data, such as .csv (comma separated values) files, in a side-by-side or over-under layout. The files are displayed in two grids that scroll together and the data is compared cell-by-cell.

Click to zoom

The display shows comparison columns, not necessarily the columns as they are organized in the data files. For example, the first comparison column may be comparing the third column of the left data file against the fifth column of the right file. See Table Compare Column Settings.

By default, Table Compare sorts your files before comparing them and aligns rows with matching key columns. You can define any combination of comparison columns as the key. If you specify an unsorted alignment, Beyond Compare will not sort the files, but will still only align rows with matching keys.

The display uses color to highlight differences. A row with a light red background indicates an important difference somewhere on the line, while light blue indicates an unimportant difference. The light red background takes precedence over the light blue. This makes it easy to find differences, even if they are horizontally scrolled out of view. You can adjust these colors to suit your preferences. (See File View Color, Font Options.)

See also

Table Compare Commands

Table Compare Settings

Table Format Settings


Hex Compare Overview

A Hex Compare session visually compares the raw content of two files, either in a side-by-side or over-under layout. It displays file content byte-by-byte, using the hexadecimal notation typical of hex editors.

Click to zoom

See also

Hex Compare Commands

Hex Compare Settings

Hex Format Settings


Picture Compare Overview

A Picture Compare session compares a pair of image files visually, showing the differences between them.

Click to zoom

Supported image file types

By default, the file types associated with Picture Compare are:

GIF (*.gif)

Icons (*.ico)

JPEG (*.jpg)

Portable Network Graphics (*.png)

TIFF (*.tif)

Windows bitmap (*.bmp)

Depending on which version of the operating system and third-party codecs have been installed, Picture Compare could also handle:

Adobe PDF (*.pdf)

Alias/Wavefront (*.rla;*.rpf)

Apple Icons (*.icns)

Autodesk (*.cel;*.pic)

Camera RAW images (*.3fr;*.arw;*.cr2;*.crw;*.dcr;*.dng;*.erf;*.fff;*.fpix;*.fpx;*.mos;*.mpo;*.mrw;*.nef;*.nrf;*.orf;*.pef;*.raf;*.raw;*.rw2;*.rwl;*.sr2;*.srf;*.srw)

Dr. Halo (*.cut)

Encapsulated Postscript (*.eps)

FAX images (*.efx;*.fax;*.g3;*.jfax;*.jfx)

JPEG (*.jpeg;*.jpe;*.jfif;*.exif)

JPEG 2000 (*.jp2;*.jpf)

JPEG XR/HD Photo (*.jxr;*.wdp)

Kodak Photo-CD (*.pcd)

Macintosh PICT (*.pct;*.pic;*.pict)

MacPaint (*.mac;*.pnt;*.pntg)

Misc (*.cur;*.epi;*.exr;*.hdr;*.jps)

Netpbm (*.pbm;*.pgm;*.ppm)

Photoshop (*.psd;*.pdd)

Postscript (*.ps)

QuickTime image (*.qti;*.qtif)

SGI (*.bw;*.rgb;*.rgba;*.sgi)

TIFF (*.tiff)

Truvision (*.tga;*.icb;*.vda;*.vst;*.win)

Windows bitmap (*.dib;*.msk;*.rle)

Windows metafile (*.emf;*.wmf)

X PixMap (*.xpm)

ZSoft Paintbrush (*.pcc;*.pcx;*.scr)

See also

Picture Compare Commands

Picture Compare Settings

Picture Format Settings


How to Compare in the Picture Compare

How to Compare in the Picture Compare View

Aligning image content

You can compare images that have been resized, rotated, reflected or cropped.

Pick Auto Scale [image] to automatically enlarge the smaller image to match the scale of the larger one.

Pick Rotate Clockwise [image] or Rotate Counterclockwise [image] to rotate the current image ninety degrees to the right or to the left.

Pick Flip Horizontally [image] or Flip Vertically [image] to reflect the current image across its y-axis or x-axis.

If one image is a cropped version of the other, you can drag the mouse over the difference pane to adjust the position of the right image's top left corner. To reset the offset back to (0,0) pick Reset Difference Offset or simply click on the offset label. For finer control, use the arrow keys to nudge the offset one pixel at a time, or Ctrl+arrow keys to move by a larger amount. Note that the difference pane must be selected for the keyboard nudge function to work.

Tolerance Mode

Pick Tolerance Mode [image] to have difference pixels indicate matches, unimportant differences, and important differences. It uses a configurable Tolerance to define the greatest degree of difference that is considered unimportant. You can also define Replacements to ignore specific color changes between images. By default, shades of gray are used for matches, shades of blue are used for unimportant differences, and shades of red are used for important differences. You can adjust these colors to suit your preferences. (See Picture Compare Colors.)

Mark Ignore Unimportant Differences [image] to ignore any differences less than or equal to the tolerance. They will be handled the same as matching pixels.

Mismatch Range Mode

Pick Mismatch Range Mode [image] to have difference pixels represent the degree of difference between the images. Black pixels are used for matches and yellow ones are used for differences. Brightness represents the degree of difference.

Blend Mode

Pick Blend Mode [image] to use a configurable Blend percentage to combine the images. Decrease the percentage to make the right image more dominant.


Registry Compare Overview

A Registry Compare session compares live registries on your computer or other computers on your network, and .reg export files, either in a side-by-side or over-under layout.

Click to zoom

Keys and values are sorted and aligned based on their names. Keys will be colored based on whether they contain differences or orphans. Values will be colored to highlight character differences. Red indicates a difference and purple indicates an orphan.

Once the comparison is loaded, you can directly edit live registries. You can copy items between registries, delete or rename existing items, and add new items. Double-clicking on a value also allows you to change its type and data.

See also

Registry Compare Commands

Registry Compare Settings


Text Edit Overview

A Text Edit view is a single-pane text editor.

Click to zoom

See also

Text Edit Commands

Text Format Settings

Text Editing Options


Text Patch Overview

A Text Patch view recreates a comparison represented in a patch file. Patch files can be generated using a Text Compare report or a another diff program.

Click to zoom

See also

Text Patch Commands

Text Format Settings

Text Editing Options


Other View Types

MP3 Compare

An MP3 Compare session compares two MP3 files with differences in tag fields highlighted.

Click to zoom

See also

MP3 Compare Commands

MP3 Compare Settings

Version Compare

A Version Compare session compares version info in a pair of executable files.

Click to zoom

See also

Version Compare Commands

Version Compare Settings


Clipboard Compare Overview

Clipboard Compare runs in the background, keeping track of every time the Windows clipboard is updated with text. It appears in the Windows notification area.

Click on its icon to show a list of the most recent clipboard entries.

Click to zoom

You can right-click on a clipboard entry and pick Save As... to create a new text file. Delete and Open With Text Edit are also available.

You can configure Ctrl+Alt+C as the keyboard shortcut used to open a text comparison of the two most recent clipboard entries.

Note Deleting clipboard entries from the list does not affect the Windows clipboard.


File Formats

Beyond Compare uses file formats to specify how certain types of files are to be handled. For example, files with a .jpg or .png extension are associated with Picture Compare, while .c and .cpp files are recognized as having C/C++ syntax and are handled by Text Compare. You can modify the built-in file formats or create your own.

File formats determine:

·The type of view used for visual comparison

·What conversion, if any, should be performed before comparing or saving

·The syntax, or grammar, of the file's content

·Case sensitivity of grammar elements

·Tab stops

·Line weights to help the alignment process

File formats primarily control how the file views handle your files, but they can also affect how a folder session compares file contents. If you use rules-based content comparison, then the folder session can limit the display to only files with important differences.

See also

File Format Management

Rules vs. File Formats


Grammars

A file format specification can include a grammar definition, used for syntax highlighting, and to help define which differences are important.

For example, our standard file format for C/C++ source code includes a grammar that recognizes keywords, comments, and literal strings. By flagging differences in comments as unimportant, you can better concentrate on important differences.

A grammar definition in Beyond Compare is fairly simplistic. It does not support nested or context-specific definitions, so it doesn't handle tagged languages like HTML and PHP very well. On the other hand, it is a big step up from Beyond Compare 2's functionality.

To edit a grammar, pick Tools > File Formats [image] and find the appropriate file format. Switch to the Grammar tab and edit the grammar items.


Reports

Comparison reports allow you to save the information from a comparison to view later without re-running the comparison. These reports can be printed directly from Beyond Compare, or saved in HTML or plain text format.

The report feature is available on the Session menu in various types of sessions. For instance, in a Folder Compare session you would pick Session > Folder Compare Report [image].

The style of reports available differs for the various session types, but the options are much the same. You can output a report to any of these locations:

·Printer

·HTML report (file or clipboard)

·Plain text (file or clipboard)

The Printer and HTML choices support difference highlighting with color.

You can preview a Printer report with the Print Preview button, or an HTML report with the View in Browser button.


Specs

A Spec is the name of a folder or file. Beyond Compare supports several different types of specs.

Local and network drives are represented using the syntax native to each platform:

C:\MyFile.ext

\\MyServer

\\MyServer\MyFolder

/MyFolder

~/MyFolder

smb://MyServer/MyFolder

Portable media devices (Android phones, MP3 players, cameras) are represented using the MTP syntax:

mtp://MyDevice/MyFolder

Webpages are represented using the HTTP syntax. This support only works for individual files, and cannot be used for base folders:

http://www.example.com

Live registries are represented using the standard syntax:

reg:\\HKEY_LOCAL_MACHINE\MyKey

reg:\\MyComputer\HKEY_USERS\MyKey

The clipboard is represented using this syntax:

clipboard://

See also

Archive Files

Remote Services


Archive Files

Archives are files that contain other files, such as .zip. Beyond Compare displays them as folders, with a zipper icon, but by default treats them as files when copying or comparing them. Once you have expanded the archive by double-clicking on it, the files within will be compared. Many of the formats support both reading and writing, so you can use all of the usual file operations on the files within the archives, including comparing the content, copying, renaming, etc.

Common archive formats

7z archive (*.7z;*.7z.001)

BZip (*.bz;*.bz2)

BZipped Tar (*.tbz;*.tbz2;*.tar.bz2)

Beyond Compare Snapshot (*.bcss;*.bcs)

Compiled HTML Help (*.chm)

Deb archive (*.deb)

GZip (*.gz)

GZipped Tar (*.tgz;*.tar.gz)

Microsoft Cabinet (*.cab)

RAR (*.rar)

Rpm archive (*.rpm)

Tar (*.tar)

Zip (*.zip;*.zipx;*.jar;*.ear;*.war;*.bcpkg)

To view the full list of archive formats or change the file extensions associated with them, pick Tools > Options [image] and switch to the Archive Types page.

Beyond Compare snapshots

These files are similar to other archives, but only include the file names, dates, and sizes, without including the file content itself. Since they are so small, you can save a snapshot of an entire hard drive and compare against it later.

Total Commander "packer" plug-ins

Beyond Compare can also use Total Commander "packer" plug-ins to support additional archive formats. For example, there are plug-ins to support ISO disc images (.iso) and Microsoft Installer Packages (.msi).

To add one of these third-party plug-ins, on the Archive Types page, click the Add Plug-in button, and follow the instructions.


Remote Services

Remote services include FTP and Subversion.

FTP sites are represented using the standard syntax:

ftp://username@ftp.hostname.com

ftp://username:password@ftp.hostname.com

ftp://ftp.hostname.com

ftp://username@ftp.hostname.com/subfolder

ftp://username@ftp.hostname.com//subfolder

sftp://username@hostname.com

ftps://username@hostname.com

Subversion servers are represented using the standard syntax:

svn://hostname/subfolder

svn://hostname/subfolder@1234

svn+http://hostname/subfolder

svn+https://hostname/subfolder

svn+ssh://hostname/subfolder

Named profiles are necessary for Amazon S3, Dropbox, OneDrive, and WebDAV. The are represented using this syntax:

profile:MyProfile

profile:MyProfile?MyFolder/MyFile.ext


Snapshots

In the Tools menu, the Save Snapshot [image] command saves a compressed read-only listing of the specified folder and all of its subfolders, including each file's timestamp, size, and file attributes. Snapshots have a .bcss file extension.

Snapshots are useful for detecting changes over time. Snapshot files can be loaded at a later date and compared to a live folder. You can load a snapshot just like any other base folder. Binary and rules-based content comparisons do not work on snapshots, since the files in the snapshot do not really exist.

If CRCs of the files are included in the snapshot, then CRC comparisons can be used to determine whether the contents of files have changed. This can be useful for detecting data corruption and other subtle changes to your data.

A snapshot remembers the name of the base folder it was produced from. If you load a snapshot on the command line (or drag a snapshot file onto the Beyond Compare icon), the program will automatically compare the snapshot with the original folder.

See also

Saving Snapshots


Calling Beyond Compare from Other Applications

As you would expect, Beyond Compare's setup program creates shortcuts to the main executable file, such as:

C:\Program Files\Beyond Compare 3\BCompare.exe

However, if you call Beyond Compare from a batch file or a version control system, we recommend using "BComp" instead of "BCompare.exe". BComp is a helper program which launches Beyond Compare and waits until it is closed. For more technical details, see Command Line Reference.


Moving Beyond Compare to Another Computer

To copy or move Beyond Compare to a different computer

1.On the new computer, download and install the latest version of Beyond Compare.

2.Enter your registration key in the new installation.

3.Run Beyond Compare on the old computer and pick Tools > Export Settings to save all desired settings in a file.

4.Copy this settings file to the new computer.

5.Run Beyond Compare on the new computer and pick Tools > Import Settings to load the settings file.

Note If you have Beyond Compare version 2.0 or older on the old computer, you will not have an Export Settings command. You can contact Scooter Software for assistance in transferring your settings.

See also

Exporting Settings

Importing Settings


Scripts

Beyond Compare provides a script processing feature which allows you to automate routine tasks. A script is a simple text file containing a list of commands which can control the program and automatically perform file operations or produce reports. See Scripting Reference for a list of all scripting commands.

Scripts run without displaying the usual Beyond Compare user interface, but might require input for certain confirmations. Scripts essentially manipulate an invisible folder session: file operations require selections, the "display" can be limited with filters, and folders can be "expanded" to recurse into them. Any folder name argument can be a folder on your system, on the network or a remote service, or the name of an archive file such as .zip, .cab, or Beyond Compare Snapshot file.

Running a script

Specify the filename of the script on the command line with a leading "@" symbol, as in:

BCompare.exe @"C:\My Folder\My Script.txt"

bcompare @"My Folder/My Script"

Creating a script

Scripts are processed line by line, with a single command per line. Scripts are not case sensitive, and blank lines and comments (anything after a "#") are ignored. Arguments are separated by spaces. To include a space in an argument, surround the argument with quotes ("). To continue a long command on a second (or third) line, add an ampersand (&) at the end of every line but the last.

A parameter specified on the command line can be referenced by inserting a percent sign (%) followed by a single number from 1-9. The script name and command line switches starting with / are not included in the 1-9 list. Given the command line:

BCompare.exe @"My Script.txt" /silent "My Session"

the session named "My Session" can be loaded by adding the following to the script:

load "%1"

An environmental variable can be inserted by enclosing its name in percent signs. The character case of the environmental variable must be correct. The system's temporary folder can be loaded by adding the following to the script:

load "%TMP%"

There are several dynamic variables that Beyond Compare can fill in at each line of the script. The %date% variable fills in the current date in the format yyyy-mm-dd. The %time% variable's format depends on your computer's regional settings. The %fn_time% variable outputs the time as hh-mm-ss, which can be used for filenames.

Scripting command line switches

Note Mac and Linux users should prefix the switches with "-" instead of "/".

The command line switches that affect scripting are /closescript, /leftreadonly, /readonly, /rightreadonly, and /silent. Normally, script processing adds an entry on the Task Bar and displays a Scripting Status Window detailing its progress and any errors. The /silent switch bypasses the Task Bar entry and Scripting Status Window, allowing Beyond Compare to process the script invisibly.

Scripting options

To change the script processing options, pick Tools > Options [image], switch to the Tweaks page, and then scroll to find Scripts. Mark the Beep when finished checkbox to have Beyond Compare sound an audible beep when it completes script processing. This beep can alert you to check and close the Scripting Status window. Close when finished causes Beyond Compare to automatically close its Scripting Status window when it completes script processing. When used in conjunction with Beep when finished, the beep simply tells you the process has completed.

There is also a place to designate a Shared scripts folder. When you provide a script name argument on the command line with no path designation, and there is no file of that name in the current folder, Beyond Compare will look in the Shared scripts folder for that script.


Sample Scripts

The following are some sample scripts to show how Beyond Compare can use scripts. You can either use these scripts as is or model your own scripts after them.

Here is a basic script which copies all of the newer and orphaned files from one folder to another, using a previously created session:

load "Sync Laptop"

sync update:left->right

Syncing two folders

Here is a more advanced script which syncs two specific folders using advanced filters. This works the same as loading the folders in a Folder Compare session and performing a "Mirror Left to Right" folder synchronization.

# Turn logging on.

log normal "C:\My Log.txt"

# Load the default session and exclude all but certain file types.

load <default>

filter "*.html;*.htm;*.png;*.jpg"

# Load the base folders.

load "C:\My Folder" ftp://user@website.com/folder

# Copy different files left to right, delete orphans on right.

sync mirror:left->right

Comparing two files by name

This script compares two files by name.

file-report layout:side-by-side &

options:display-mismatches &

output-to:%3 %1 %2

A sample command line, calling the above script:

BCompare.exe @"My Script.txt" "My File.txt" "Your File.txt" "My Report.txt"

Note An ampersand (&) at the end of a line means that the command continues on the next line.

Note %1, %2, and %3 refer to the 1st, 2nd and 3rd command line argument, respectively.

Generating a report

This script compares two files by name and generates an html report showing differences with context:

text-report layout:side-by-side &

options:ignore-unimportant,display-context &

output-to:%3 output-options:html-color %1 %2

Keeping a web site in sync

This script keeps a web site in sync with development files.

# Turn verbose logging on.

log verbose append:"C:\My Log.txt"

# Set the comparison criteria.

criteria timestamp size

# Load source and target folders.

load "C:\My Folder" ftp://user@website.com/folder

# Filter to only include source files, ignore CVS subfolders.

filter "*.htm;*.html;*.php;*.jpg;*.gif;-CVS\"

# Sync the local files to the web site, creating empty folders.

sync create-empty mirror:left->right

Performing a rules-based comparison and logging results to a file

This script logs the script results to a file that uses the current date as part of the name. The variable %date% is expanded by the script in the format 2012-12-31 on U.S. English systems, on other systems it will match the system locale. It performs a rules-based comparison of Pascal source files and generates a report of mismatches.

# Log to a file of the form "C:\My Log 2012-12-31.txt".

# The exact format depends on your regional and language settings.

log verbose append:"C:\My Log %date%.txt"

# Compare the text contents of the files.

criteria rules-based

# Only compare Delphi source files, ignore the archive folder.

filter "*.pas;*.dfm;*.dpr;*.inc;-archive\"

load "C:\My Folder" "C:\Your Folder"

folder-report layout:summary &

options:display-mismatches,column-attributes,column-timestamp,column-size &

output-to:"My Report.txt"

Comparing current folder state to a snapshot

This script compares the current state of a folder to a snapshot from the last time updates were sent out. Then it copies the changed and new files to an archive file and updates the snapshot of the folder.

option confirm:yes-to-all

# Compare using crc.

criteria crc

# Load current files against snapshot from the last patch.

load "C:\My Folder" "C:\My Snapshot.bcss"

# Expand to affect subfolders and files.

expand all

# Select updated files.

select left.diff.files left.orphan.files

# Copy changes to an archive file.

copyto left path:relative "C:\My Archive.zip"

# Update the snapshot.

snapshot save-crc left output:"C:\My Snapshot.bcss"

Generating a report of differences

This script generates a report of only differences.

# Set up basic comparison features.

criteria timestamp:2sec

# Filter out log files.

filter "-*.log"

# Load first comparison.

load "C:\My Folder" "C:\Your Folder"

# Compare files with timestamp differences.

select newer.files older.files

# Generate a report of the differences.

folder-report layout:summary options:display-mismatches output-to:"C:\My Report.txt"


Scheduling a Script

You can use Beyond Compare's script processor to perform certain tasks, such as synchronizing folders, without interaction. For example, to automate a backup of "C:\My Folder", enter the following script commands into Notepad:

load "C:\My Folder" "C:\My Backups"

expand all

select left.newer.files left.orphan.files

copy left->right

Save this text file as "C:\My Scripts\Sync.txt".

To run a Beyond Compare script at any desired time:

1.In Windows Task Scheduler, pick Action > Create Basic Task to get a wizard.

2.In Action, pick Start a program.

3.In Program/script, pick the Beyond Compare 4 executable.

4.In Add arguments, add a reference to your script file:
@Sync.txt

5.In Start in, pick the script folder:
C:\My Scripts

We recommend including a log command in your script. If you have trouble with your script, check out the Scheduled Tasks error log: "SchedLgU.txt" in your Windows folder.


Settings Reference

Beyond Compare is highly configurable, and it sometimes can be hard to know where to go in the program to change a specific setting. Here's where to look:

Program Options

General user preferences are set in the Options dialog. Pick Tools > Options [image] to open it. From here you can set startup options, control confirmation messages, and customize display colors and fonts.

Session Settings

Most of the options that define the scope and rules of a comparison can be found in the Session Settings dialog. Each session type has its own session settings dialog. Pick Session > Session Settings [image] to open the dialog, or simply click the Rules [image] toolbar button.

Session settings are stored with your saved sessions.

File Formats

Specific file types can be configured in the File Formats dialog. Pick Tools > File Formats [image] to open it.

Profiles

Specific remote services can be configured in the Profiles dialog. Pick Tools > Profiles to open it.

Source Control Integration

Specific source control associations can be configured in the Source Control Integration dialog. Pick Tools > Source Control Integration to open it.


Program Options

Tools > Options

To set program preferences

1.Pick Tools > Options [image] to open the Options dialog.

2.In the list at the left, click the item containing the options you want to set:

Startup

Tabs

Colors, Fonts

Folder Views

File Views

Picture Compare

Text Editing

Next Difference

Backups

File Operations

Archive Types

Toolbars, etc.

Open With

Tweaks

3.Modify the desired settings, and then click the Apply button to accept the changes, or the OK button to apply and close.


Startup Options

Tools > Options > Startup

Startup options

When Beyond Compare starts up, it normally shows the Home view. To have the program automatically start up with the same sessions that were open the last time you used Beyond Compare, specify the same workspace name in the Load workspace and On Exit, save workspace as edits. In the Session menu, you can also use the Save Workspace As and Load Workspace commands for further control.

When you start Beyond Compare with a pair of files specified, the program can display a dialog with a comparison summary, rather than taking the time to display the entire side-by-side comparison. To preface a file comparison with the Quick Compare dialog:

1.Mark the When starting with file comparison, show quick compare dialog checkbox.

2.Pick Binary quick compare to perform a byte-by-byte comparison, or Rules-based quick compare to use the file format settings appropriate for the specified files.

3.Mark the Open view automatically if files are different checkbox if you want the dialog to only appear when the files match.

To run Clipboard Compare on Windows startup

Mark the Run Clipboard Compare on Windows startup checkbox. The Clipboard Compare is a small system tray application that can be used to compare recent Windows clipboard entries.

To add Beyond Compare to Explorer's right-click menu

Mark the Include Beyond Compare in Explorer context menu checkbox.

Pick any of the optional commands listed in the table and pick Main menu or Submenu to include it in the context menu. Enable Compare Using to add a submenu that lists specific views, such as the Table Compare view and the Hex Compare view. This allows you to override the view that would normally be selected via the file formats list. Enable Merge to add 3-way merge support to the context menu. Enable Sync to support synchronizing folders from Explorer. Enable Edit to support editing a single file from Explorer. Enable Compare to Registry to support comparing a registry file to the live registry.


Tab Options

Tools > Options > Tabs

When working with multiple sessions simultaneously, Beyond Compare can open them in independent windows, or under tabs in a single window. These options control that behavior.

To control new sessions

Pick either A new window or A new tab for newly created sessions.

To control child sessions

Pick either A new window or A new tab for newly created file sessions that are opened directly from a folder session.

To control miscellaneous tab behavior

Set the various options to reflect your preferences.

If you unmark both the Closing last remaining tab closes the window and Hide tab bar if single tab checkboxes then closing the last tab will return to the Home view.


Color, Font Options

Tools > Options > Colors, Fonts

Click the item containing the options you want to set:

Folder Views

File Views

Picture Compare


Folder View Color, Font Options

Tools > Options > Colors, Fonts > Folder Views

These options allow you to customize overall colors and fonts used in folder views.

Font

By default, the font used for folder displays is the same as what the operating system uses. To change it, unmark the Use system font checkbox and click the Font button.

Selection

The Selection element controls the treatment of selected text. By default, Beyond Compare uses a medium blue color for selections so that difference coloring is not obscured. If you prefer the operating system's standard treatment for selections, mark the Use system checkbox. Selected files will then lose difference coloring, although the color spot to the left of each filename will still be colored appropriately.

Miscellaneous

Pick the colors to be used for Filtered out items (when Suppress Filters [image] is used), and for items whose comparison state is Unknown. Mark the Use Stripes checkbox to tint the background on every other line of the comparison.


File View Color, Font Options

Tools > Options > Colors, Fonts > File Views

These options allow you to customize visual aspects of the various types of file views.

Pick an element from the list to change its visual treatment. You can change the Text color and Background color of each element on the list. For some elements you can change the font Style to bold and/or italic.

Lower elements in the list override higher ones. Pick Default to leave unchanged a color set by an element higher on the list.

Mark the Use stripes checkbox to tint the background on every other line of the comparison.

The Selection element controls the treatment of selected text. By default, Beyond Compare uses a medium blue color for selections so that difference coloring is not obscured. If you prefer the operating system's standard treatment for selections, mark the Use system checkbox. Selected text will then lose difference and syntax coloring, although the statusbar will still describe the current position's comparison and grammar type.

The Important difference and Unimportant difference settings control the treatment of differences. The Background color affects the entire line, allowing you to spot lines with differences even when the actual differences are scrolled off-screen. The Text background color can be used to further highlight text that is different.

The list also includes syntax highlighting elements.

Click one of the font buttons to change the overall font used to display text. The Editor Font is used in Text Compare, Text Merge and Table Compare views. The Hex Font is used in Hex Compare views, as well as the optional hex details display at the bottom of other views. The Listing Font is used in all other views.

See also

Tweak Options > Editor Display


Picture Compare Color Options

Tools > Options > Colors, Fonts > Picture Compare

These options allow you to customize colors used in Picture Compare views.

Set the Background colors used in Tolerance mode for same, different, and similar pixels.


Text Editing Options

Tools > Options > Text Editing

These options apply to Text Compare and Text Merge sessions.

Auto indent

When marked and a new line is created, it is automatically indented to match the leading whitespace on the previous line.

Backspace unindents

When marked and the edit cursor is positioned immediately after the leading whitespace of the line, pressing the Backspace key deletes enough whitespace to match the previous indentation level, as defined by preceding lines.

Allow positioning beyond end of line

When marked, the edit cursor is not constrained by the end of text on a line.

Initialize "Text to find" to be current word

When marked and there is no selection, the current word is filled in as the search text for the Find [image] command.

Show filtered line counts

When marked, a summary of lines hidden by display filters is shown:

Number of context lines

Defines the number of matching lines to display before and after a difference section when Show Context [image] is used.


Next Difference Options

Tools > Options > Next Difference

Set these options to reflect your preferences concerning how to peruse differences.

When loading new files, go to first difference

When marked, position at the first difference when a new file comparison starts.

Go to next difference in files after copying to other side

When marked, position at the next difference item after copying the current item to the other side.

Limit "Next Difference Files" to current folder

When marked, the Next Difference Files [image] command will only find files with the same parent folder.

Wrap around to first difference

When marked, position back at the first difference in the comparison after the end is reached.

Show message panel

When unmarked, suppress the message panel (and beep) when a difference is not found.


Backup Options

Tools > Options > Backups

Beyond Compare can create a backup of your files before overwriting them during a copy or move operation, or before saving an edited file. Set these options to control how backup files are named and where they are stored.


File Operation Options

Tools > Options > File Operations

Confirmations

By default, Beyond Compare prompts for confirmation before performing various actions. Unmark any of these checkboxes to suppress the confirmation dialogs.

Synchronize confirmations

Pick Prompt, Yes to All or No to All to control confirmations that might appear during a Folder Compare session's synchronize command.

How filters affect file actions

By default, file filters and display filters are respected during file actions (such as Copy, Move and Delete), unless Suppress Filters [image] is on. To change the default behavior, mark the Include hidden items by default checkbox.


Archive Type Options

Tools > Options > Archive Types

Specify the file types to be associated with each of the supported archive formats. Pick a format and enter the associated file types separated by semicolons in the Mask column. You can leave it blank to drop support for that format. You can add support for additional archive formats by clicking the Add Plug-in button and following the instructions. For more information, see Archive Files.


Toolbar, Shortcut, Menu Options

Tools > Options > Toolbars, etc.

These options allow you to control which commands appear in menus and on toolbars, and allow you to set keyboard shortcuts for commands. Since the menus and toolbars change depending on the type of window, you need to pick the appropriate session view.

In the [image] search edit, type the name or description of the command you are looking for in order to limit the list of commands.

Pick a command in the list to edit. The command's description will appear below the list.

Checkboxes in the Menu and Toolbar columns control where commands are shown.

To change the keyboard shortcut, focus on the Shortcut edit and press the desired keystroke. Click the Remove button to remove an assigned shortcut or the Default button to revert it to the factory default setting. If a keyboard shortcut is already assigned elsewhere, a warning appears and you have the option of reassigning it.

Most session types have display filter commands available. The Display filter mode can be changed to DropDown, Favorites or Toggles. It can also be changed by right-clicking on the view's toolbar.

Large buttons with text labels can also be changed by right-clicking on the view's toolbar.

For documentation of specific commands, see Commands Reference.


"Open With" Application Options

Tools > Options > Open With

You can configure external applications to appear in the Open With submenu.

Click the New button to add an "Open With" Application.


Tweak Options

Tools > Options > Tweaks

Tweaks are advanced or obscure program options that we group here to avoid cluttering other areas.

Check for Updates

By default, Beyond Compare checks our website for new versions of the software. You can change the number of days between checks or unmark the Check every checkbox to never check.

Editor Display

Most of the display settings for text views are found on the File View Colors, Fonts page of the Options dialog. Settings specific to the text editors are here.

Syntax highlighting is normally suppressed on difference lines so that it doesn't interfere with difference coloring schemes. Mark the Show syntax highlighting on difference lines checkbox to change this behavior.

Use crosshatching for lines beyond the end of file helps identify the end of your text files, particularly when comparing a longer file with a shorter one.

Right side gutter for left editor (compare only) positions the copy buttons close together in the center of the view, and keeps the scrollbars at the outer edges. It has no effect if you are using the View > Over-under layout [image].

Enable font linking in editors allows the text editor to use additional fonts in order to support characters from multiple languages.

Use orphan color causes file views to use a separately configurable color for items that are only on one side of the comparison.

You can add or subtract pixels from Extra line spacing to change the density of text in the view.

To show a vertical line at a specific column position, set Show column line at to the desired value. Set it to zero (0) to hide the line. If you use a proportionally spaced font, the column position will be determined by the width of the space character.

Dim inactive pane by darkens the non-active side of the comparison in order to help you focus on the active side.

To use an alternate font for the narrower input panes in a Text Merge session, mark the Use different font for merge input panes checkbox.

File Operations

Beep after long file operations causes an audible sound when file operations such as copy and move are completed, unless they take less than 3 seconds.

The read-only attribute is normally preserved when copying files. On read-only media such as CDs or DVDs, all files will still be marked read-only when they are copied to another location. To avoid this, mark the Remove read-only flag when copying from a CD or DVD checkbox.

Mark the Check for files changed on disk checkbox to check for a newer copy of a file when returning focus to a file view. If found, Beyond Compare will prompt "File changed on disk, reload?" Mark the Automatically reload unless changes will be discarded checkbox to have Beyond Compare automatically load the newer file as long as you haven't made changes to the displayed file.

Comparison priority can be changed to affect the order in which background work is performed.

Buffer size for binary compare can be changed to affect speed.

Home View

Sticky session selection can be set to remember the last session picked from a Home view instead of the last session updated in the application.

Interface

Here is what a toolbar looks like when the Show hints for toolbar buttons, etc. and Show keyboard shortcut in hints checkboxes are marked:

ESC key closes file views applies to all file view types, such as Text Compare, Table Compare and Picture Compare. It does not affect folder views.

Single vertical scrollbar can be marked to save horizontal space by hiding a redundant vertical scrollbar.

Sticky splitter position can be marked to have the size of the panes in file views be user defined instead of automatically determined.

Pick Compress to fit to compress the thumbnail to the available vertical space. Pick Allow scrolling to show a vertical scrollbar instead.

Log Panel

Operation summaries

Log a summary of each operation.

Operation details

Log details of each operation, including each file affected.

Warnings

Log warnings and errors.

FTP trace

Log messages to and from FTP site.

Debug messages

Log messages useful to Scooter Software's technical support staff.

Display up to defines how many messages the log can handle before it starts deleting the oldest ones.

If a file is entered for Automatically save messages to file, it will be created when necessary.

Metrics

Max auto-saved sessions

Defines how many sessions can automatically be saved before the oldest one will be automatically deleted. Enter zero (0) to disable the auto-save sessions feature.

Max most recently used items

Defines how many items can automatically be remembered before the oldest one will be automatically deleted. For example, it affects how base folder dropdown lists.

Milliseconds before help hint appears

Defines how long to wait before showing a popup hint.

Milliseconds before help hint disappears

Defines how long a popup hint remains visible.

Milliseconds before incremental search resets

Defines how long to wait for the user to type in the next character for an incremental search.

Name Filter Presets

Specify the preset name filter choices, available on the folder view's toolbar. Use simple wildcard definitions separated by semicolons for the mask. Example:

*.htm;*.html;*.jpg

Scripts

Mark the Beep when finished checkbox for an audible cue that a script has finished.

Mark the Close when finished checkbox to exit the program when the script has finished.

Specify a Shared scripts folder to be the location for shared scripts. If a script filename is not found in the current folder, Beyond Compare will look for it there.

Shared Sessions File

If a Shared sessions file is specified, shared sessions will appear in your sessions tree. You can use but not modify them. Use Tools > Export Settings to create a shared sessions file.


Session Settings

To edit session settings

1.Pick Session > Session Settings [image].

2.Modify the desired settings on each tab.

3.The dropdown list at the bottom of the dialog controls the scope of your changes. Pick Use for this view only to affect the current session, or Update session defaults to apply your changes to all new sessions of this type.

Additional choices are shown for child sessions, comparisons spawned from a folder session. Use for these files within parent session causes the current folder session to remember these settings and use them whenever this particular pair of files is compared. Use for all files within parent session causes these settings to be used for any new sessions of this type spawned from the current folder session.

4.Click OK.

Specific settings for session types

Folder Compare

Folder Merge

Folder Sync

Text Compare

Text Merge

Table Compare

Hex Compare

MP3 Compare

Picture Compare

Registry Compare

Version Compare


Folder Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Comparison

Handling

Name Filters

Other Filters

Misc


Folder Compare Spec Settings

Session > Session Settings > Specs

Specify the base folders to be compared.

Mark Disable editing to protect content from being changed on disk. New child sessions will be affected as well.

The Description can include any text you want.


Folder Compare Comparison Settings

Session > Session Settings > Comparison

These settings control what is considered a difference in a folder session.

Quick tests

These comparison tests can be performed simply by reading folders and are much quicker than tests that require reading individual files.

Compare file size

Marks files as different if file sizes differ.

Compare timestamps

Compares files' date and time last modified. Timestamps must differ by more seconds than the second tolerance to be considered mismatches.

Ignore daylight saving difference ignores exact hour differences. This is useful for dealing with the way that different file systems handle Daylight Savings Time.

Ignore timezone differences ignores timestamp differences that are multiples of an exact hour.

Compare filename case

Marks files as different if character capitalizations differ.

Compare file attributes

Archive compares files' archive attribute. Since merely copying a file can change its archive attribute, you should normally disable this option.

System compares files' system attribute.

Hidden compares files' hidden attribute.

Read-only compares files' read-only attribute.

Align filenames with different extensions

Lines up files whose filenames are the same except for the extensions.

Align filenames with different Unicode normalization forms

Lines up files whose filenames are Unicode equivalent.

Tests that require reading files

Compare contents

Enables size or content-related comparisons.

CRC comparison compares files using their CRC values.

Binary comparison compares files byte-by-byte.

Rules-based comparison compares files based on their file format associations. Allows you to ignore differences in line endings, whitespace, or source code comments.

Skip if quick tests indicate files are the same improves comparison speed by only performing the slower, more thorough tests when timestamps are different.

Compare versions

Compares version information, typically stored in application files (.exe, .dll, .ocx, etc).

Override quick test results

Marks files as matching if a content comparison determines they match even if there are differences in timestamps or other quick tests.


Folder Compare Handling Settings

Session > Session Settings > Handling

Folder handling

Automatically scan subfolders in background causes folders to be read in the background when a comparison is loaded. This way, folders can be colored appropriately before you open them. Top-level orphan folders can usually be colored and filtered without scanning, since they can only contain other orphans. Automatically scan top-level orphan subfolders causes these orphan folders to be scanned anyway, so that the folder's size is accurately reported.

Expand subfolders when loading session opens all folders automatically when a comparison is loaded. Only expand subfolders with differences limits auto expansion to folders that are found to have mismatches.

Archive handling (e.g. zip files)

As files always treats archive files like other files. They will sort with files and not show a folder icon.

As folders once opened sorts and compares archive files like other files, but with a zip folder icon. Once you open the zip folder, its comparison status changes to reflect its contents, like other folders do.

As folders always treats archive files like regular folders.

File handling

Touch local files when copying to an FTP site

Many FTP sites do not allow Beyond Compare to control file timestamps, so when a file is copied to the FTP site, its date will not match the local copy. This option changes the local file timestamp to match the FTP copy.

Follow symbolic links

Displays symbolic links and NTFS junction points as if they were their target. This includes whether they will be shown as files or folders, their size, their last modified time, and their attributes.

Maintain DOS 8.3 aliases

Tries to keep the same short (DOS 8.3) filenames when copying files.

Copy NTFS file permissions

Copies security descriptors of files on NTFS file systems under Windows 2000 or newer. This feature does not preserve permissions of files edited from Text Compare sessions.

Copy creation dates

Preserves original creation date of a local file when making a copy.

Automatic refresh

Set this option to periodically refresh the folder comparison.


Folder Compare Name Filter Settings

Session > Session Settings > Name Filters

You can include or exclude folders and files based on their names by using one or more file masks.

To set a name filter

Add a file mask to the appropriate list. Each file mask must be on its own line.

·Include Files Files to include in this session.

·Exclude Files Files to exclude from this session.

·Include Folders Folders to include in this session.

·Exclude Folders Folders to exclude from this session.

For examples, see File Masks.

To clear all name filters

Click the Clear button to clear all the filter settings on this tab.

To make the current name filter a preset

Click the Add To Presets button, optionally enter a Name, optionally edit the Mask, and click OK.


Folder Compare Other Filter Settings

Session > Session Settings > Other Filters

You can exclude files from a folder session based on criteria other than their names. Click the New button to add an Other Filter Item.

Note Whenever a other filter items are defined, a comment bar appears near the bottom of the folder view. You can click the Other Filters [image] button on it to edit these filters.

Note If a file filter determines that a file on one side of the comparison should be hidden but the corresponding file on the other side should be visible, both are made visible and the one that should be hidden will be colored teal (blue-green).

The Exclude protected operating system files checkbox is marked by default.


Folder Compare Miscellaneous Settings

Session > Session Settings > Misc

To force a different alignment

By default, a folder session aligns files and subfolders by name, left and right. Click the New button to add an Alignment Override.

Note The easiest way to manually align two items in a folder session is to right-click the first item, pick Align With, then click the second item.

To override file format associations

The Enabled file formats list lets you override which file formats will be used by this folder session. A file format is listed in bold if its enabled state in this session is different from its global enabled state. You can create a custom file format that is enabled for use in this session but disabled in the global list.


Folder Merge Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Comparison

Handling

Name Filters

Other Filters

Misc


Folder Merge Spec Settings

Session > Session Settings > Specs

Specify the base folders to be merged.

Merge to defines the destination folder of the merge results.

The Description can include any text you want.


Folder Merge Comparison Settings

Session > Session Settings > Comparison

These settings control what is considered a difference in a folder session.

Quick tests

These comparison tests can be performed simply by reading folders and are much quicker than tests that require reading individual files.

Compare file size

Marks files as different if file sizes differ.

Compare timestamps

Compares files' date and time last modified. Timestamps must differ by more seconds than the second tolerance to be considered mismatches.

Ignore daylight saving difference ignores exact hour differences. This is useful for dealing with the way that different file systems handle Daylight Savings Time.

Ignore timezone differences ignores timestamp differences that are multiples of an exact hour.

Compare filename case

Marks files as different if character capitalizations differ.

Compare file attributes

Archive compares files' archive attribute. Since merely copying a file can change its archive attribute, you should normally disable this option.

System compares files' system attribute.

Hidden compares files' hidden attribute.

Read-only compares files' read-only attribute.

Tests that require reading files

Compare contents

Enables size or content-related comparisons.

CRC comparison compares files using their CRC values.

Binary comparison compares files byte-by-byte.

Rules-based comparison compares files based on their file format associations. Allows you to ignore differences in line endings, whitespace, or source code comments.

Skip if quick tests indicate files are the same improves comparison speed by only performing the slower, more thorough tests when timestamps are different.

Compare versions

Compares version information, typically stored in application files (.exe, .dll, .ocx, etc).

Override quick test results

Marks files as matching if a content comparison determines they match even if there are differences in timestamps or other quick tests.


Folder Merge Handling Settings

Session > Session Settings > Handling

Folder handling

Automatically scan subfolders in background causes folders to be read in the background when a comparison is loaded. This way, folders can be colored appropriately before you open them. Top-level orphan folders can usually be colored and filtered without scanning, since they can only contain other orphans. Automatically scan top-level orphan subfolders causes these orphan folders to be scanned anyway, so that the folder's size is accurately reported.

Expand subfolders when loading session opens all folders automatically when a comparison is loaded. Only expand subfolders with differences limits auto expansion to folders that are found to have mismatches.

Archive handling (e.g. zip files)

As files always treats archive files like other files. They will sort with files and not show a folder icon.

As folders once opened sorts and compares archive files like other files, but with a zip folder icon. Once you open the zip folder, its comparison status changes to reflect its contents, like other folders do.

As folders always treats archive files like regular folders.

File handling

Touch local files when copying to an FTP site

Many FTP sites do not allow Beyond Compare to control file timestamps, so when a file is copied to the FTP site, its date will not match the local copy. This option changes the local file timestamp to match the FTP copy.

Follow symbolic links

Displays symbolic links and NTFS junction points as if they were their target. This includes whether they will be shown as files or folders, their size, their last modified time, and their attributes.

Maintain DOS 8.3 aliases

Tries to keep the same short (DOS 8.3) filenames when copying files.

Copy NTFS file permissions

Copies security descriptors of files on NTFS file systems under Windows 2000 or newer. This feature does not preserve permissions of files edited from Text Merge sessions.

Copy creation dates

Preserves original creation date of a local file when making a copy.

Automatic refresh

Set this option to periodically refresh the folder comparison.


Folder Merge Name Filter Settings

Session > Session Settings > Name Filters

You can include or exclude folders and files based on their names by using one or more file masks.

To set a name filter

Add a file mask to the appropriate list. Each file mask must be on its own line.

·Include Files Files to include in this session.

·Exclude Files Files to exclude from this session.

·Include Folders Folders to include in this session.

·Exclude Folders Folders to exclude from this session.

For examples, see File Masks.

To clear all name filters

Click the Clear button to clear all the filter settings on this tab.

To make the current name filter a preset

Click the Add To Presets button, optionally enter a Name, optionally edit the Mask, and click OK.


Folder Merge Other Filter Settings

Session > Session Settings > Other Filters

You can exclude files from a folder session based on criteria other than their names. Click the New button to add an Other Filter Item.

Note Whenever a other filter items are defined, a comment bar appears near the bottom of the folder view. You can click the Other Filters [image] button on it to edit these filters.

Note If a file filter determines that a file on one side of the comparison should be hidden but the corresponding file on the other side should be visible, both are made visible and the one that should be hidden will be colored teal (blue-green).

The Exclude protected operating system files checkbox is marked by default.


Folder Merge Miscellaneous Settings

Session > Session Settings > Misc

To override file format associations

The Enabled file formats list lets you override which file formats will be used by this folder session. A file format is listed in bold if its enabled state in this session is different from its global enabled state. You can create a custom file format that is enabled for use in this session but disabled in the global list.


Folder Sync Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Sync

Comparison

Handling

Name Filters

Other Filters

Misc


Folder Sync Spec Settings

Session > Session Settings > Specs

Specify the base folders to be synced.

Mark Disable editing to protect content from being changed on disk. New child sessions will be affected as well.

The Description can include any text you want.


Folder Sync Synchronize Settings

Session > Session Settings > Sync

Operations

Presets

You can use one of the predefined sync methods described in the overview or create a custom one.


Folder Sync Comparison Settings

Session > Session Settings > Comparison

These settings control what is considered a difference in a folder session.

Quick tests

These comparison tests can be performed simply by reading folders and are much quicker than tests that require reading individual files.

Compare file size

Marks files as different if file sizes differ.

Compare timestamps

Compares files' date and time last modified. Timestamps must differ by more seconds than the second tolerance to be considered mismatches.

Ignore daylight saving difference ignores exact hour differences. This is useful for dealing with the way that different file systems handle Daylight Savings Time.

Ignore timezone differences ignores timestamp differences that are multiples of an exact hour.

Compare filename case

Marks files as different if character capitalizations differ.

Compare file attributes

Archive compares files' archive attribute. Since merely copying a file can change its archive attribute, you should normally disable this option.

System compares files' system attribute.

Hidden compares files' hidden attribute.

Read-only compares files' read-only attribute.

Align filenames with different extensions

Lines up files whose filenames are the same except for the extensions.

Align filenames with different Unicode normalization forms

Lines up files whose filenames are Unicode equivalent.

Tests that require reading files

Compare contents

Enables size or content-related comparisons.

CRC comparison compares files using their CRC values.

Binary comparison compares files byte-by-byte.

Rules-based comparison compares files based on their file format associations. Allows you to ignore differences in line endings, whitespace, or source code comments.

Skip if quick tests indicate files are the same improves comparison speed by only performing the slower, more thorough tests when timestamps are different.

Compare versions

Compares version information, typically stored in application files (.exe, .dll, .ocx, etc).

Override quick test results

Marks files as matching if a content comparison determines they match even if there are differences in timestamps or other quick tests.


Folder Sync Handling Settings

Session > Session Settings > Handling

Folder handling

Sync empty folders will affect folders without content or whose entire contents have been filtered out.

Expand subfolders when loading session opens all folders automatically when a comparison is loaded.

Sync within archives treats archive files like regular folders.

File handling

Delete to recycle bin if possible

Moves files and folders stored on a local drive to the recycle bin instead of permanently deleting them. This option is ignored for deletions from network drives, remote services and within archive files.

Touch local files when copying to an FTP site

Many FTP sites do not allow Beyond Compare to control file timestamps, so when a file is copied to the FTP site, its date will not match the local copy. This option changes the local file timestamp to match the FTP copy.

Follow symbolic links

Displays symbolic links and NTFS junction points as if they were their target. This includes whether they will be shown as files or folders, their size, their last modified time, and their attributes.

Maintain DOS 8.3 aliases

Tries to keep the same short (DOS 8.3) filenames when copying files.

Copy NTFS file permissions

Copies security descriptors of files on NTFS file systems under Windows 2000 or newer. This feature does not preserve permissions of files edited from Text Compare sessions.

Copy creation dates

Preserves original creation date of a local file when making a copy.

Automatic refresh

Set this option to periodically refresh the folder comparison.


Folder Sync Name Filter Settings

Session > Session Settings > Name Filters

You can include or exclude folders and files based on their names by using one or more file masks.

To set a name filter

Add a file mask to the appropriate list. Each file mask must be on its own line.

·Include Files Files to include in this session.

·Exclude Files Files to exclude from this session.

·Include Folders Folders to include in this session.

·Exclude Folders Folders to exclude from this session.

For examples, see File Masks.

To clear all name filters

Click the Clear button to clear all the filter settings on this tab.

To make the current name filter a preset

Click the Add To Presets button, optionally enter a Name, optionally edit the Mask, and click OK.


Folder Sync Other Filter Settings

Session > Session Settings > Other Filters

You can exclude files from a folder session based on criteria other than their names. Click the New button to add an Other Filter Item.

Note Whenever a other filter items are defined, a comment bar appears near the bottom of the folder view. You can click the Other Filters [image] button on it to edit these filters.

Note If a file filter determines that a file on one side of the comparison should be hidden but the corresponding file on the other side should be visible, both are made visible and the one that should be hidden will be colored teal (blue-green).

The Exclude protected operating system files checkbox is marked by default.


Folder Sync Miscellaneous Settings

Session > Session Settings > Misc

To force a different alignment

By default, a folder session aligns files and subfolders by name, left and right. Click the New button to add an Alignment Override.

Note The easiest way to manually align two items in a folder session is to right-click the first item, pick Align With, then click the second item.

To override file format associations

The Enabled file formats list lets you override which file formats will be used by this folder session. A file format is listed in bold if its enabled state in this session is different from its global enabled state. You can create a custom file format that is enabled for use in this session but disabled in the global list.


Text Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Format

Importance

Alignment

Replacements


Text Compare Spec Settings

Session > Session Settings > Specs

Specify the files to be compared.

Mark Disable editing to protect content from being changed on disk.

The Description can include any text you want.


Text Compare File Format Settings

Session > Session Settings > Format

Specify the file format to be used when reading the left and/or right files. The default selection is Detected, which means the file format will be selected based on file masks.

Encoding overrides allow this session to override the character encoding to be used for each file, normally controlled by the selected file format. The default is None, which means the file format's encoding choice will be used.


Text Compare Importance Settings

Session > Session Settings > Importance

These settings control which differences you consider important in the current session. Important differences will be colored red in the comparison. Unimportant differences will be blue (or not highlighted at all if View > Ignore Unimportant Differences [image] is marked).

Unimportance

Text that matches items defined in this list are considered unimportant.

Grammar elements

Mark the boxes in the list of items that are important to the comparison.

Leading whitespace controls whether whitespace at the start of the line is important.

Embedded whitespace controls whether whitespace in the middle of the line is important.

Trailing whitespace controls whether whitespace at the end of the line is important.

Everything else refers to non-whitespace text not already defined as a grammar element.

Mark the Character case checkbox if the "everything else" text is case-sensitive. (The case sensitivity of grammar elements is controlled by the file format's grammar.)

Click the Edit Grammar button to examine or change the grammar definitions in the selected file format.

Miscellaneous

To consider an extra blank line (or an inserted line with only unimportant text) an important difference, mark the Orphan lines are always important checkbox.

Beyond Compare normally ignores differences in line ending style, such as CR+LF in Windows text files vs. LF only in Unix files. To find differences in line endings on a line-by-line basis, mark the Compare line endings (PC/Mac/Unix) checkbox. (To examine the line endings, mark View > Visible Whitespace [image].)

See also

Rules vs. File Formats


Text Compare Alignment Settings

Session > Session Settings > Alignment

The Alignment tab settings control the algorithm for aligning lines in the comparison.

Mark the Never align differences checkbox to show lines with important differences as blocks of added and deleted text rather than changed text.

Pick Unaligned to compare files without aligning lines based on their content.

Pick Standard alignment to align the files by comparing successively smaller sections of each file. Parts of the alignment can be shown before the entire comparison is finished.

Pick Myers O(ND) alignment to align the files using a common LCS (Longest Common Subsequence) algorithm. This can give better matches in certain cases, such as large inserts or when the files contain a lot of repeating text. Since files are compared all at once, larger file scans take much longer than the standard method, and the files are not displayed until the comparison is complete. It does not support similarity comparisons, so mismatches will be grouped in blocks.

Pick Patience Diff alignment to align the files using Bram Cohen's algorithm.

The Skew tolerance specifies the maximum number of lines that the algorithm will check when looking for a match to a particular line. Increasing it can improve the alignment, especially if there are large gaps. Of course, the comparison may also require more time.

Mark the Use closeness matching checkbox to attempt to align the remaining mismatched lines based on their similarity.

Note Regardless of these settings, the alignment algorithm will sometimes produce undesirable results. To manually align two lines, right-click one line and pick Align With and then click the second line.


Text Compare Replacement Settings

Session > Session Settings > Replacements

Replacements identify repetitive changes that should be considered unimportant. You can specify the text to match on one side and the text that replaces it on the other side. Click the New button to add a Replacement Item.


Text Merge Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Format

Importance

Alignment


Text Merge Spec Settings

Session > Session Settings > Specs

Specify the files to be merged.

Merge to defines the destination file of the merge results.

The Description can include any text you want.


Text Merge File Format Settings

Session > Session Settings > Format

Specify the file format to be used when reading the input files. The default selection is Detected, which means the file format will be selected based on file masks.

Encoding overrides allow this session to override the character encoding to be used for each file, normally controlled by the selected file format. The default is None, which means the file format's encoding choice will be used.


Text Merge Importance Settings

Session > Session Settings > Importance

These settings control which differences you consider important in the current session. Important differences will be colored red in the comparison. Unimportant differences will be blue (or not highlighted at all if View > Ignore Unimportant Differences [image] is marked).

Unimportance

Text that matches items defined in this list are considered unimportant.

Grammar elements

Mark the boxes in the list of items that are important to the comparison.

Leading whitespace controls whether whitespace at the start of the line is important.

Embedded whitespace controls whether whitespace in the middle of the line is important.

Trailing whitespace controls whether whitespace at the end of the line is important.

Everything else refers to non-whitespace text not already defined as a grammar element.

Mark the Character case checkbox if the "everything else" text is case-sensitive. (The case sensitivity of grammar elements is controlled by the file format's grammar.)

Click the Edit Grammar button to examine or change the grammar definitions in the selected file format.

Miscellaneous

To consider an extra blank line (or an inserted line with only unimportant text) an important difference, mark the Orphan lines are always important checkbox.

Beyond Compare normally ignores differences in line ending style, such as CR+LF in Windows text files vs. LF only in Unix files. To find differences in line endings on a line-by-line basis, mark the Compare line endings (PC/Mac/Unix) checkbox. (To examine the line endings, mark View > Visible Whitespace [image].)

See also

Rules vs. File Formats


Text Merge Alignment Settings

Session > Session Settings > Alignment

The Alignment tab settings control the algorithm for aligning lines in the comparison.

Mark the Never align differences checkbox to show lines with important differences as blocks of added and deleted text rather than changed text.

Pick Unaligned to compare files without aligning lines based on their content.

Pick Standard alignment to align the files by comparing successively smaller sections of each file. Parts of the alignment can be shown before the entire comparison is finished.

Pick Myers O(ND) alignment to align the files using a common LCS (Longest Common Subsequence) algorithm. This can give better matches in certain cases, such as large inserts or when the files contain a lot of repeating text. Since files are compared all at once, larger file scans take much longer than the standard method, and the files are not displayed until the comparison is complete. It does not support similarity comparisons, so mismatches will be grouped in blocks.

Pick Patience Diff alignment to align the files using Bram Cohen's algorithm.

The Skew tolerance specifies the maximum number of lines that the algorithm will check when looking for a match to a particular line. Increasing it can improve the alignment, especially if there are large gaps. Of course, the comparison may also require more time.

Mark the Use closeness matching checkbox to attempt to align the remaining mismatched lines based on their similarity.

Note Regardless of these settings, the alignment algorithm will sometimes produce undesirable results. To manually align two lines, right-click one line and pick Align With and then click the second line.

A merge conflict is

These settings define the scope of conflicts. A conflict occurs when the same section of text has changes on both left and right sides.

Pick Only different change lines to limit conflicts to where each line has changes on both sides. Pick Left change and right change separated by lines to specify the maximum number of lines between changes that should be considered conflicts. This way, left and right changes that are close to each other can be flagged for review along with direct conflicts.


Table Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Format

Columns

Alignment


Table Compare Spec Settings

Session > Session Settings > Specs

Specify the files to be compared.

Mark Disable editing to protect content from being changed on disk.

The Description can include any text you want.


Table Compare File Format Settings

Session > Session Settings > Format

Specify the file format to be used when reading the left and/or right files. The default selection is Detected, which means the file format will be selected based on file masks.

Encoding overrides allow this session to override the character encoding to be used for each file, normally controlled by the selected file format. The default is None, which means the file format's encoding choice will be used.


Table Compare Column Settings

Session > Session Settings > Columns

Each line in the display represents a comparison column, and shows:

·Comparison [image] if key, column number, column name

·Left file column number, sample data if available

·Right file column number, sample data if available

·Handling summary of column comparison

To control the alignment of rows

Define as many columns as keys as necessary to uniquely identify each row. By default, the first column is the only one defined as a key. To define a column as a key, position on the appropriate line, click the Edit button, mark the Key checkbox, and click OK. If multiple keys are defined, precedence follows the order in the comparison. If no keys are defined, the alignment will use all of the columns to uniquely identify each row.

To control the alignment of columns

By default, the comparison assumes the columns of the files are in the same order. To change the comparison order of a column in the left file, position on the appropriate line under Left file, and click the Move Up [image] or Move Down [image] button as necessary. If you position under Comparison instead, those buttons will change the position of the comparison column itself. To prevent a column in the left file from being compared at all, position on the appropriate line under Left file, and click the Remove button. If you position under Comparison instead, this button will prevent its file columns from being compared and delete this comparison column definition. To restore a removed column from the left file, position under Left file, click the Insert button, mark items in the Insert Columns dialog and click OK. Click the Tidy button to remove any blank lines from the list.

To control the names of columns

By default, column names are automatically determined from the left or right file. To give a column a specific name, position on the appropriate line, click the Edit button, change the Name, and click OK. To revert all columns to automatic naming, pick Reset Names from the list's right-click menu. If left file data is available, you can pick Fill Names Using Left File from the list's right-click menu to force the names to be those found in the left file. Fill Names Using Comparison will force the names to be those that would be automatically determined.

To control how column data is compared

Position on the appropriate line and click the Edit button to open the Column Handling dialog. To change the default Handling settings, click the Edit Default button.


Table Compare Alignment Settings

Session > Session Settings > Alignment

The Alignment tab settings control the algorithm for aligning rows in the comparison.

Pick Sorted alignment to reorder the rows based on their keys before aligning them.

Pick Unaligned to compare files without aligning rows based on their content.

Pick Standard alignment to align the files by comparing successively smaller sections of each file. Parts of the alignment can be shown before the entire comparison is finished.

Pick Myers O(ND) alignment to align the files using a common LCS (Longest Common Subsequence) algorithm. This can give better matches in certain cases, such as large inserts or when the files contain a lot of repeating text. Since files are compared all at once, larger file scans take much longer than the standard method, and the files are not displayed until the comparison is complete. It does not support similarity comparisons, so mismatches will be grouped in blocks.

Pick Patience Diff alignment to align the files using Bram Cohen's algorithm.

Mark the Use closeness matching checkbox to attempt to align the remaining mismatched rows based on their similarity.


Hex Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Format

Comparison


Hex Compare Spec Settings

Session > Session Settings > Specs

Specify the files to be compared.

Mark Disable editing to protect content from being changed on disk.

The Description can include any text you want.


Hex Compare File Format Settings

Session > Session Settings > Format

Specify the file format to be used when reading the left and/or right files. The default selection is Detected, which means the file format will be selected based on file masks.


Hex Compare Comparison Settings

Session > Session Settings > Comparison

These settings control how the files are compared.

Complete will align the bytes using a complex algorithm. Fast will perform a simpler but quicker alignment that is ideal for really large files. None will just align the bytes one by one.

Files up to this size are loaded without file locks allows smaller files to be edited in other programs.


MP3 Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Importance


MP3 Compare Spec Settings

Session > Session Settings > Specs

Specify the files to be compared.

The Description can include any text you want.


MP3 Compare Importance Settings

Session > Session Settings > Importance

These settings control which differences you consider important.


Picture Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Format

Replacements


Picture Compare Spec Settings

Session > Session Settings > Specs

Specify the files to be compared.

The Description can include any text you want.


Picture Compare File Format Settings

Session > Session Settings > Format

Specify the file format to be used when reading the left and/or right files. The default selection is Detected, which means the file format will be selected based on file masks.


Picture Compare Replacement Settings

Session > Session Settings > Replacements

Replacements identify changes that should be considered unimportant. You can specify the color to match on one side and the color that replaces it on the other side.


Registry Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs


Registry Compare Spec Settings

Session > Session Settings > Specs

Specify the files to be compared.

The Description can include any text you want.


Version Compare Settings

Session > Session Settings

Click the tab containing the settings you want to edit:

Specs

Importance


Version Compare Spec Settings

Session > Session Settings > Specs

Specify the files to be compared.

The Description can include any text you want.


Version Compare Importance Settings

Session > Session Settings > Importance

These settings control which differences you consider important.


File Format Management

Tools > File Formats

Pick Tools > File Formats [image] to see and manage the entire list of file formats.

The order of the list is important. When Beyond Compare looks for a file format to use on a file, it scans this list from top to bottom, stopping on the first enabled item whose mask matches the filename. To change the order of the list, highlight an item and click the Move Up [image] or Move Down [image] button. To enable or disable an item, mark or unmark its checkbox.

An item is colored red if any filename it could match is already matched by an item higher in the list. A disabled item is colored gray. An item with an empty mask cannot match any filename. To use any of these file formats, you must manually pick them in file sessions.

Note A specific session can independently enable or disable file formats. (See Folder Compare Miscellaneous Settings.) This way you can have a special file format that is used only by one session.

See also

Text Format Settings

Table Format Settings

Hex Format Settings

Picture Format Settings

External Format Settings


Text Format Settings

Text formats are file formats used by the Text Compare and Text Merge session types.

Click the tab containing the settings you want to edit:

General

Conversion

Grammar

Misc


Text Format General Settings

Text Format > General

The Mask is a set of file types to be associated with this file format.

The Description can include any text you want. The built-in file format descriptions include any limitations or requirements for using them.


Text Format Conversion Settings

Text Format > Conversion

The Conversion tab defines how files should be loaded and saved.

Text Compare sessions can compare plain text files, such as programming source files, directly. To compare files with structured or proprietary formats, it may be necessary to first extract the plain text content from the file. For example, Microsoft Word documents are binary files, but Beyond Compare can extract and compare their textual content. Beyond Compare can highlight differences in words and sentences but cannot identify differences in formatting or embedded images.

Pick a Conversion method. When using External program methods, you will need to specify a conversion program with the appropriate path and command line switches in the Loading edit. In order to support filenames with extended characters, make sure to pick the appropriate filename encoding (Unicode or ANSI). The following variables will be replaced with the indicated information:

%s source file

%t target file

%o original file

Conversion programs are only considered successful if they return a zero exit code and generate a non-empty file.

If you have a conversion program you want to use before saving, you can unmark the Disable editing checkbox and in the Saving edit specify that conversion program's path and command line switches. The above variables apply.

The Encoding of most text files can be detected automatically, but you can specify a specific code page to use.

Mark the Ctrl+Z indicates end of file checkbox for if your file type uses the hex value 1A as an EOF marker.

The characters per line limit setting will break long lines at the indicated length. Those artificial line breaks are removed when saving an edited file.

Trim trailing whitespace and Convert leading spaces to tabs are edits that can be performed before saving files.


Text Format Grammar Settings

Text Format > Grammar

The Grammar tab defines the syntax of a file. Grammar elements such as comments and keywords are defined here. Each grammar element can be described by one or more grammar items which appear in the list. The order of the list is significant. Items higher on the list take precedence over lower items. Click the New button to add a Grammar Item.

Line weights are used to improve alignment in a comparison. The alignment algorithm will try to line up matching lines with higher line weights.


Text Format Miscellaneous Settings

Text Format > Misc

Insert spaces instead of tabs

When unmarked, pressing the Tab key inserts a tab character into the file. When marked, an appropriate number of spaces is inserted instead.

The Tab stop setting determines the interval between tab stops. Pressing the Tab key advances the cursor to the next tab stop.

Mark the Lines are independent checkbox when each line is an independent record and it is not useful to manipulate consecutive difference lines as a Section.

Mark the Column-based data checkbox when the position of each character on a line is important and lines should be compared column-by-column.


Table Format Settings

Table formats are file formats used by the Table Compare session type.

Click the tab containing the settings you want to edit:

General

Conversion

Type

Regional


Table Format General Settings

Table Format > General

The Mask is a set of file types to be associated with this file format.

The Description can include any text you want. The built-in file format descriptions include any limitations or requirements for using them.


Table Format Conversion Settings

Table Format > Conversion

The Conversion tab defines how files should be loaded and saved.

Table Compare sessions can compare plain text files, such as comma separated value files, directly. To compare files with structured or proprietary formats, it may be necessary to first extract the plain text content from the file. For example, Microsoft Excel spreadsheets are binary files, but Beyond Compare can extract and compare their textual content. Beyond Compare can highlight differences in words and sentences but cannot identify differences in formatting or embedded images.

Pick a Conversion method. When using External program methods, you will need to specify a conversion program with the appropriate path and command line switches in the Loading edit. In order to support filenames with extended characters, make sure to pick the appropriate filename encoding (Unicode or ANSI). The following variables will be replaced with the indicated information:

%s source file

%t target file

%o original file

Conversion programs are only considered successful if they return a zero exit code and generate a non-empty file.

If you have a conversion program you want to use before saving, you can unmark the Disable editing checkbox and in the Saving edit specify that conversion program's path and command line switches. The above variables apply.

The Encoding of most text files can be detected automatically, but you can specify a specific code page to use.

Mark the Ctrl+Z indicates end of file checkbox for if your file type uses the hex value 1A as an EOF marker.


Table Format Type Settings

Table Format > Type

The Type tab defines the syntax of the data file.

Delimited text files

Pick Delimited if the fields are separated by a delimiter character such as a tab or comma.

Mark the Detect checkbox to have the program automatically determine the delimiter. Otherwise, pick the Delimiters that separate the fields and pick the Text qualifier that optionally surrounds fields (necessary for data that contains the delimiter characters).

Mark the Treat consecutive delimiters as one checkbox if a delimiter can consist of multiple delimiter characters. For example, if the data file contains columns separated by whitespace, you should enable this option and pick Space as the delimiter character.

Unmark the Treat surrounding whitespace as part of delimiter checkbox if any whitespace next to a delimiter should be considered part of the data field.

Fixed position text files

Pick Fixed for files where fields are defined by position on the line.

Enter the Column widths in a list separated by semicolons.

All types

Pick the First line contains option to control whether the first line in the file is treated as cell data or as column names. Normally, Table Compare tries to detect this but you can override it here.


Table Format Regional Settings

Table Format > Regional

Mark the Use system checkbox to use your system's Regional Settings. Otherwise, pick the Decimal separator and Thousands separator to be used when interpreting numeric fields.


Hex Format Settings

Hex formats are file formats used by the Hex Compare session type.

Click the tab containing the settings you want to edit:

General

Conversion


Hex Format General Settings

Hex Format > General

The Mask is a set of file types to be associated with this file format.

The Description can include any text you want. The built-in file format descriptions include any limitations or requirements for using them.


Hex Format Conversion Settings

Hex Format > Conversion

The Conversion tab defines how files should be loaded and saved.

Pick a Conversion method. When using External program methods, you will need to specify a conversion program with the appropriate path and command line switches in the Loading edit. In order to support filenames with extended characters, make sure to pick the appropriate filename encoding (Unicode or ANSI). The following variables will be replaced with the indicated information:

%s source file

%t target file

%o original file

Conversion programs are only considered successful if they return a zero exit code and generate a non-empty file.

If you have a conversion program you want to use before saving, you can unmark the Disable editing checkbox and in the Saving edit specify that conversion program's path and command line switches. The above variables apply.


Picture Format Settings

Picture formats are file formats used by the Picture Compare session type.

Click the tab containing the settings you want to edit:

General

Conversion


Picture Format General Settings

Picture Format > General

The Mask is a set of file types to be associated with this file format.

The Description can include any text you want. The built-in file format descriptions include any limitations or requirements for using them.


Picture Format Conversion Settings

Picture Format > Conversion

The Conversion tab defines how files should be loaded.

Pick a Conversion method. When using External program methods, you will need to specify a conversion program with the appropriate path and command line switches in the Loading edit. In order to support filenames with extended characters, make sure to pick the appropriate filename encoding (Unicode or ANSI). The following variables will be replaced with the indicated information:

%s source file

%t target file

%o original file

Conversion programs are only considered successful if they return a zero exit code and generate a non-empty file.


External Format General Settings

External Format > General

To compare files using another application, define an external format.

The Mask should be the set of file types it handles.

The Quick compare command line will be used whenever rules-based comparison results are needed. The return code should be 0 for a match and 1 for a mismatch.

The Compare view command line will be used whenever a comparison view is needed.

The Quick merge command line will be used whenever rules-based merge results are needed. The return code should be 0 for a match and 1 for a mismatch.

The Merge view command line will be used whenever a merge view is needed.

The Description can include any text you want.


Profile Management

Tools > Profiles

Pick Tools > Profiles to see and manage the entire list of profiles.

In addition to the named profiles, there is the <default> FTP profile whose settings can be used by named FTP profiles.

See also

FTP Profile Settings

Amazon S3 Profile Settings

Dropbox Profile Settings

OneDrive Profile Settings

Subversion Profile Settings

WebDAV Profile Settings


FTP Profile Settings

Click the tab for the settings you wish to edit:

Global

Login

Server

Connection

Proxy

Listing

Transfer


FTP Profile Global Settings

FTP Default Profile > Global

Anonymous logins

Email address

When connecting to anonymous FTP sites, it is customary to include your email address as the password. Specify the email address (real or fictitious) to use for anonymous logins.

SSH public key authentication

These settings are used to authenticate against an SSH server using a public/private key pair. Keys stored using OpenSSH's ssh-agent and PuTTY's pageant SSH agents will be used automatically.

SSH private key file

Specify the path to the SSH private key. OpenSSH, SSH.COM, PuTTY, and PGP key formats are supported.

Create Keys

Click to create a new SSH key pair.

SSL authentication

These settings are used to authenticate against an SSL FTP server using an SSL client certificate.

SSL client certificate

Specify the path to the SSL client certificate file.

Create Certificate

Click to create a new self-signed SSL client certificate.

ASCII types

To change which files get transferred as ASCII, add and remove extensions from this list.

Note If you need help with the settings on this page, consult your system administrator.


FTP Profile Login Settings

FTP Profile > Login

Protocol

Specify FTP or one of the secure FTP options: SSL or SSH.

Port

Override if you don't want to use the standard value for the specified protocol.

Host, Username, Password

Specify login parameters for your account.

Save password

Mark to weakly encrypt your password and store it along with other FTP profile settings.

The Description can include any text you want.

Note If you need help with the settings on this page, consult your system administrator.


FTP Profile Server Settings

FTP Profile > Server

Filenames are case sensitive

Mark to require filename character case to be the same in order to line up in the comparison.

Encoding

Specify the character encoding the server uses for directory listings and commands.

Time zone

Specify the time zone of the server. Timestamps will be converted to local time automatically.

Custom login commands

Specify any additional commands to send to the server upon connection. Not supported by SFTP (SSH) connections.

Note If you need help with the settings on this page, consult your system administrator.


FTP Profile Connection Settings

FTP Profile > Connection

These settings control how the connection is made to the remote server.

Simultaneous connections

Specify the maximum number of concurrent connections (from 1 to 10) that Beyond Compare can create to this server.

Read timeout (seconds)

Specify the timeout for downloading files. The operation will fail if no bytes are received within this time.

Passive transfers (PASV)

Some firewall configurations require this setting, which modifies the methods used to transfer data back and forth between your computer and the FTP server. Not all FTP servers support PASV mode. If the connection hangs, try turning this on.

Limit ports used for active transfers (PORT)

Specify a range of ports that the FTP server will connect to when uploading/downloading files using active transfers (The Passive transfers checkbox is unmarked). Use this if you need to configure your firewall to allow incoming connections.

Use HOST before login

Controls whether the HOST command should be sent before sending the username and password to log in. This is required to connect to some virtual FTP hosts. Disable it if the connection is being dropped before the username is sent.

Clear control channel (SSL only)

After sending encrypted login details, control channel communication is unencrypted. Try turning this on if the initial SSL connection succeeds but file transfers or directory listings hang.

Clear data channel (SSL only)

Send file content and directory listings unencrypted. This can provide a speedup when transferring lots of files after sending encrypted login details.

Note If you need help with the settings on this page, consult your system administrator.


FTP Profile Proxy Settings

FTP Profile > Proxy

Use proxy

Mark if connections should use FTP Proxy protocol. If you are not on a Local Area Network (LAN) or Wide Area Network (WAN), leave this option unmarked.

Proxy type

Specify the type of firewall.

Host, Port, Username, Password

Specify login parameters for your firewall / proxy.

Note If you need help with the settings on this page, consult your system administrator.


FTP Profile Listing Settings

FTP Profile > Listings

Beyond Compare parses the plain text directory listings sent from the FTP server in order to determine the remote folder structure. Unfortunately, there is no one standard for these listings.

These settings help Beyond Compare understand the conventions and capabilities of the FTP server.

Link resolution

FTP sites can connect files together using symbolic "links" which point from one area of the site to another. These links do not specify whether they point to files or folders, so the following methods of resolving are available:

Fast

Mark to treat any link which has an extension (e.g. ".txt") as a file and all others as folders. This requires no extra transfers.

Simple

Mark to attempt to change folders into every link as it encounters it. If it succeeds the link is considered a folder, otherwise it is considered a file.

LIST options

Use MLSD command

Mark to request high-resolution timestamps from the server. If successful, the following settings are ignored. Soft links will be listed as plain files and folders, and listings won't be recursive.

Show hidden [-a]

Mark to make the FTP server include files that it wouldn't normally include, such as Unix filenames that begin with a period.

Force long format [-l]

Mark to attempt to change the output of the FTP server list command. Try this option if Beyond Compare doesn't list any files when it loads.

Complete timestamps [-T]

Mark to expand the timestamps that the FTP server returns to include a full date and time, including seconds.

Resolve links [-L]

Mark to make the FTP server list soft links as plain files and folders with the timestamp and size of the link's target.

Recursive [-R]

Mark to make directory listings recursive, including contents of the subfolders in response to a single FTP list command. Recursive listings may be slower initially, but save time overall if subfolders will need to be examined eventually.

Miscellaneous settings

Hide VMS versions

Mark to only include the most recent version of a file and align it with a local file. Otherwise, all versions of the file are included with their version numbers.

Fetch incomplete timestamps

Mark to try to fetch the file's last modified time in cases where the directory listing only reports the date. This will provide more accurate timestamp comparisons at the cost of some performance. Not supported on all FTP servers.

Note If you need help with the settings on this page, consult your system administrator.


FTP Profile Transfer Settings

FTP Profile > Transfer

These settings control how files are transferred to and from the FTP server.

Transfer type

FTP sites can transfer data in two ways: ASCII and Binary. ASCII is used to transfer text files which don't have any special characters. The FTP server will automatically make any adjustments to line endings needed in ASCII mode. ASCII mode also handles transfers from mainframes by converting from EBCDIC to ANSI and adding line terminators to the end of records. Binary is used to transfer all other files, including pictures, music, Word documents, etc. In Binary mode, no changes are made to the file during the transfer.

Setting the transfer type to either ASCII or Binary will force all files to transfer that way. If the transfer type is Auto, Beyond Compare will automatically switch back and forth based on the file's extension.

Copy timestamps on upload

Mark to force the remote timestamp to match the source timestamp. Only unmark if it causes problems with the server.

Copy Unix permissions on upload

Mark to force the remote Unix permissions to match the source Unix permissions. Only unmark if it causes problems with the server.

Compress transfers (MODE Z)

Mark to use compression to speed up transfers when supported by the server. This may actually slow down transfers on fast connections.

Limit download (Kbps), Limit upload (Kbps)

Specify how much bandwidth Beyond Compare can consume for each connection.

Force faster uploads to older OpenSSH servers

Mark to use larger transfer buffers and pipelining on OpenSSH servers prior to OpenSSH 3.9. This can substantially increase transfer speed, but is not compatible with all servers, and failures may not be obvious. Use a binary content comparison to verify the first transfers you do after enabling this.

Note If you need help with the settings on this page, consult your system administrator.


Amazon S3 Profile Settings

Amazon S3 Profile > General

Access key ID, Secret access key

Specify parameters for your account.

The Description can include any text you want.


Dropbox Profile Settings

Dropbox Profile > General

The Description can include any text you want.


OneDrive Profile Settings

OneDrive Profile > General

The Description can include any text you want.


Subversion Profile Settings

Subversion Profile > General

URL of repository, Revision

Specify parameters for your account.

The Description can include any text you want.


WebDAV Profile Settings

WebDAV Profile > General

URL, Username, Password, Recursive listings

Specify parameters for your account.

The Description can include any text you want.


Source Control Integration

Tools > Source Control Integration

You can associate folders with your SCC-compatible source control application so that Beyond Compare can offer check out and check in services.


Where Settings are Stored on your Computer

Beyond Compare stores your sessions, customized file formats and other preferences as .xml files in its settings folder. A quick way of finding this location is to pick Help > Support and click the Explore settings folder link at the bottom of the dialog.

Standard installation

In Windows, the settings folder is inside your Application Data folder. The location depends on your version of Windows. For instance, under Windows Vista the settings folder is:

C:\Users\<username>\AppData\Roaming\Scooter Software\Beyond Compare 4

Notice that this location differs for different users on the same computer.

In Mac, the settings folder is:

~/Library/Application Support/Beyond Compare

If you want to install multiple major versions, you can rename this folder to:

~/Library/Application Support/Beyond Compare 4

In Linux, the settings folder is:

~/$XDG_CONFIG_HOME/bcompare

If $XDG_CONFIG_HOME is not defined, the settings folder is:

~/.config/bcompare

If an older version of Beyond Compare has been installed, the settings folder is:

~/.beyondcompare

If you want to install multiple major versions, you can append the major version to the settings folder name like this:

~/$XDG_CONFIG_HOME/bcompare4

Portable installation

If you prefer a more portable installation with the program and settings all in one location, you can copy your settings files to the same folder as the program. Portable installs allow you to share one set of settings for all users on a computer, or take your settings with you. If you don't have existing settings files to copy, you can create an empty file named BCState.xml in the folder.


Commands Reference

This part of the documentation describes the commands available in menus and on the toolbar for each view type.

Commands that are common to all views

Home Commands

Folder Compare Commands

Folder Merge Commands

Folder Sync Commands

Text Compare Commands

Text Merge Commands

Table Compare Commands

Hex Compare Commands

MP3 Compare Commands

Picture Compare Commands

Registry Compare Commands

Version Compare Commands

Text Edit Commands

Text Patch Commands


Common Commands

The main menu changes depending on what kind of view is active. However, the commands listed below are common across different view types.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

New Session | Opens a new view with an empty session of the specified type.
New Tab | Opens a new tab in the current window and displays the Home view.
New Window | Opens a new window and displays the Home view.
Open Session | Opens a new view and displays the Home view.
Load Workspace | Lists saved workspaces. Picking one closes any open views and restores the selected configuration.
Load Workspace > Manage Workspaces | Lets you rename or delete saved workspaces.
Save Workspace As | Saves the current configuration of windows and tabs as a named workspace.
Close Tab | Closes the current tab.
Exit | Quits Beyond Compare, prompting to save any edits. All of the instance's windows will close.

The Tools menu

Options | Opens the Options dialog to set program preferences.
File Formats | Opens the File Formats dialog to manage file format settings.
Profiles | Opens the Profiles dialog to manage profile settings.
Source Control Integration | Opens the Source Control Integration dialog. Available in Windows version only.
Export Settings | Opens the Export Settings dialog to selectively save settings and sessions to a file.
Import Settings | Opens the Import Settings dialog to selectively load settings and sessions from a file.
Restore Factory Defaults | Opens the Restore Factory Defaults dialog to selectively reset settings to defaults.
Save Snapshot | Opens the Save Snapshot dialog to create a snapshot of a folder structure.
Edit Text File | Opens a new Text Edit view.
View Patch | Opens a new Text Patch view.

The Help menu

Contents | Displays help contents.
Context Sensitive Help | Displays help contents page relevant to what you are focused on.
Scooter Software on the Web | Opens the Scooter Software website in your browser.
Check for Updates | Checks to see if a newer version of Beyond Compare is available.
Support | Opens the Support dialog which lists instructions for reporting problems.
Enter Key | Opens the Register dialog to accept your license key.
About Beyond Compare | Displays the About box with program version and license information.


Home Commands

Following is a description of the Home commands, in addition to the common commands.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The View menu

Show Session Management | Shows or hides management panel.
Maximize Session Management | Maximizes or restores down management panel.
Show Web Resources | Shows or hides web panel.


Folder Compare Commands

Following is a description of the Folder Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Folder Compare Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Folder Compare.
Swap Sides | Exchanges the left and right base folders.
Back | Goes back to (earlier) compared base folders.
Forward | Goes forward to (later) compared base folders.
Browse for Folder > Left Side / Right Side | Browses for an existing folder on the specified side.
Up One Level > Left Side / Right Side / Both Sides | Changes either or both base folders to their parent folders.
Folder Compare Report | Produces a Folder Compare report.
Folder Compare Info | Displays comparison statistics.
Merge Base Folders | Opens a new Folder Merge session based on the current base folders.
Sync Base Folders | Opens a new Folder Sync session based on the current base folders.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the current base folders.

The Actions menu

Open Folder / Close Folder | Opens or closes the selected folder in the comparison.
Open Subfolders | Opens the selected folders and all their subfolders.
Close Subfolders | Closes the selected folders and all their subfolders.
Set as Base Folder | Sets the selected folder as the base folder on its side of the comparison.
Set as Base on Other Side | Sets the selected folder as the base folder on the other side of the comparison.
Set as Base Folders | Sets the two selected folders as the left and right base folders in this comparison view. (To open them in a new view use Open in New View instead.)
Open | Opens selected items in a new comparison view. If the items are files, the view type is determined by the file format list. If exactly two items are selected, they will be compared to each other (whether or not they are across from each other) in the new view. If only one item is selected it will be compared to the item across from it, if it exists.
Open With | Opens selected files in a new view using a specified type of file session, or opens the selected items in an external application, as defined in "Open With" Applications. Note that the Folder Compare view is not automatically updated if the items are modified by the external application.
Open With > Associated Application | Opens selected files with the associated application.
Open With > Text Edit | Opens selected files with the built-in text editor.
Open With > Text Patch | Opens selected files with the built-in patch view.
Quick Compare | Displays the Quick Compare dialog for the selected files. If exactly two files are selected, they will be compared to each other (whether or not they are across from each other). If only one file is selected, it will be compared to the file across from it.
Compare To | Allows you to select one item, and then click on a second item to compare them in a new view.
Align | Forces selected items to be side-by-side. Items' parent folders must be side-by-side.
Align With | Allows you to select one item, and then click on a second item to force them to be side-by-side.
Compare Contents | Compares contents of the selected items using one of three methods.
Copy to Right / Copy to Left * | Copies selected files, folders to the explicitly indicated side. Normally associated with Ctrl+R, Ctrl+L keyboard shortcuts.
Copy to Side * | Prompts which side to copy selected files, folders to.
Copy to Other Side | Dynamic command that copies selected files, folders to the opposite side. The caption and icon appear as Copy to Right, Copy to Left or Copy to Side depending on which side(s) are selected.
Move to Right / Move to Left * | Moves selected files, folders to the explicitly indicated side.
Move to Side * | Prompts which side to move selected files, folders to.
Move to Other Side | Dynamic command that moves selected files, folders to the opposite side. The caption and icon appear as Move to Right, Move to Left or Move to Side depending on which side(s) are selected.
Exchange * | Moves selected files, folders on both sides to the opposite side.
Copy to Folder | Copies selected files, folders to another folder.
Move to Folder | Moves selected files, folders to another folder.
Delete | Deletes selected files, folders.
Rename | Renames selected files, folders.
Attributes | Changes file attributes on selected files, folders.
Touch | Changes timestamps on selected files, folders.
Exclude | Excludes selected file, or type of file, from the current session.
New Folder | Creates a new folder.
Copy Filename | Copies a list of the selected items' paths to the clipboard.
Ignored | Suppresses differences in selected items.
Refresh Selection | Refreshes the selected items.
File Compare Report | Produces a File Compare report for the selected files.
Synchronize > Update Right | Copies newer and orphan items from left to right.
Synchronize > Update Left | Copies newer and orphan items from right to left.
Synchronize > Update Both | Performs a bidirectional update by copying newer and orphan items from left to right and from right to left.
Synchronize > Mirror to Right | Replaces all different items on right, deletes any right-side orphans, and copies any left-side orphans to the right.
Synchronize > Mirror to Left | Replaces all different items on left, deletes any left-side orphans, and copies any right-side orphans to the left.
Source Control | Displays a submenu of source control actions (see below). Only appears if a source control provider has been configured and all selected items are under source control.
Explorer | Displays the file manager's context menu for the selected item(s).

Source Control Submenu

Add to Source Control | Adds the file to the project.
Remove from Source Control | Removes the file from the project.
Get Latest Version | Gets the latest version from the source control repository.
Get * | Gets a particular version from the source control repository.
Check In | Takes your changes and applies them to the project.
Check Out | Checks the file out from the source control repository and makes your local copy writable.
Undo Check Out | Removes any changes you have made to the local copy and sets it back to read-only.
Show Differences | Tells the version control system to display the comparison of the file with the one in version control. The version control system will only use Beyond Compare if it is set up to do so.
Show History | Shows the history of the file in the version control system.
Show Properties | Shows version control-specific properties.
Run Source Control Application | Runs the source control application.

The Edit menu

Expand All | Opens all folders in view.
Collapse All | Closes all folders in view.
Select All | Selects all visible items.
Select All Files | Selects all visible files.
Select Newer > Left Side / Right Side / Both Sides | Selects all visible files that are newer on the specified side.
Select Orphans > Left Side / Right Side / Both Sides | Selects all visible orphan files on the specified side.
Invert Selection | Selects all items not currently selected, and deselects all items currently selected.
Refresh | Refreshes open folders.
Full Refresh | Refreshes entire comparison.

The Search menu

Next Difference | Positions at next difference.
Previous Difference | Positions at previous difference.
Find Filename | Finds filename matching search string.
Find Next Filename | Finds next filename matching search string.
Find Previous Filename | Finds previous filename matching search string.

The View menu

Show All | Uses no display filter on either side.
Show Differences | Filters out matches, based on file status, from both sides.
Show Same | Filters out older, newer or different, and orphans from both sides.
Show No Orphans | Filters out orphans from both sides.
Show Differences but No Orphans | Filters out matches and orphans from both sides.
Show Orphans | Filters out matches, older, and newer or different from both sides.
Show Left Newer | Filters out matches, orphans, older on left (newer or different on right) from both sides.
Show Right Newer | Filters out matches, orphans, newer or different on left (older on right) from both sides.
Show Left Newer and Left Orphans | Filters out matches and older on left (newer or different on right) from both sides and orphans on the right side.
Show Right Newer and Right Orphans | Filters out matches and newer or different on left (older on right) from both sides and orphans from the left side.
Show Left Orphans | Filters out matches, older, and newer or different from both sides and orphans on the right side.
Show Right Orphans | Filters out matches, older, and newer or different from both sides and orphans on the left side.
Show None * | Hides all files. Useful in conjunction with Always Show Folders [image] to copy folder structures.
Always Show Folders | Shows all folders, except those excluded by file filters.
Compare Files and Folder Structure | Shows folders containing files or folders that match the current display filter. Orphan folders will follow the same filtering rules as orphan files.
Compare Files Only | Shows only folders containing files to be shown.
Ignore Folder Structure | Compares filenames regardless of which subfolder they may be in. (Also called Flatten Folders.)
Ignore Unimportant Differences | Treats unimportant differences as same.
Suppress Filters | Temporarily suppresses file filters and display filters.
Columns | Shows or hides view columns.
Legend | Displays a window that lists what the different folder colors mean.
Log | Shows or hides the log panel.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Folder Merge Commands

Following is a description of the Folder Merge commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Folder Merge Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Folder Merge.
Swap Sides | Exchanges the left and right base folders.
Back | Goes back to (earlier) compared base folders.
Forward | Goes forward to (later) compared base folders.
Browse for Folder > Left Side / Center Side / Right Side / Output Side | Browses for an existing folder on the specified side.
Up One Level > Left Side / Center Side / Right Side / Output Side / All Sides | Changes specified base folders to their parent folders.
Folder Merge Info | Displays merge statistics.
Compare to Output > Left Side / Center Side / Right Side | Opens the base folder on the indicated side and the output base folder in a new Folder Compare session.
Merge Parent Folders | Opens a new Folder Merge session based on the parent folders of the current base folders.

The Actions menu

Open Folder / Close Folder | Opens or closes the selected folder in the comparison.
Open Subfolders | Opens the selected folders and all their subfolders.
Close Subfolders | Closes the selected folders and all their subfolders.
Set as Base Folder | Sets the selected folder as the base folder on its side of the comparison.
Set as Base Folders | Sets the two or three selected folders as the left and right or left, right and center base folders in this comparison view. (To open them in a new view use Open in New View instead.)
Open | Opens selected items in a new comparison view. If the items are files, the view type is determined by the file format list. If exactly two items are selected, they will be compared to each other (whether or not they are across from each other) in the new view. If only one item is selected it will be compared to the item across from it, if it exists.
Open With | Opens selected files in a new view using a specified type of file session, or opens the selected items in an external application, as defined in "Open With" Applications. Note that the Folder Merge view is not automatically updated if the items are modified by the external application.
Open With > Associated Application | Opens selected files with the associated application.
Open With > Text Edit | Opens selected files with the built-in text editor.
Open With > Text Patch | Opens selected files with the built-in patch view.
Quick Compare | Displays the Quick Compare dialog for the selected files. If exactly two files are selected, they will be compared to each other (whether or not they are across from each other). If only one file is selected, it will be compared to the file across from it.
Compare To | Allows you to select one item, and then click on a second item to compare them in a new view.
Compare Contents | Compares contents of the selected items using one of three methods.
Merge | Performs automated merge of selected items.
Copy to Right / Copy to Left * | Copies selected files, folders to the explicitly indicated side. Normally associated with Ctrl+R, Ctrl+L keyboard shortcuts.
Copy to Side * | Prompts which side to copy selected files, folders to.
Copy to Other Side | Dynamic command that copies selected files, folders to the opposite side. The caption and icon appear as Copy to Right, Copy to Left or Copy to Side depending on which side(s) are selected.
Copy to Output | Copies selected files, folders to the output folder.
Delete | Deletes selected files, folders.
Rename | Renames selected files, folders.
Attributes | Changes file attributes on selected files, folders.
Touch | Changes timestamps on selected files, folders.
Exclude | Excludes selected file, or type of file, from the current session.
New Folder | Creates a new folder.
Copy Filename | Copies a list of the selected items' paths to the clipboard.
Ignored | Suppresses differences in selected items.
Refresh Selection | Refreshes the selected items.
Source Control | Displays a submenu of source control actions (see below). Only appears if a source control provider has been configured and all selected items are under source control.
Explorer | Displays the file manager's context menu for the selected item(s).

Source Control Submenu

Add to Source Control | Adds the file to the project.
Remove from Source Control | Removes the file from the project.
Get Latest Version | Gets the latest version from the source control repository.
Get * | Gets a particular version from the source control repository.
Check In | Takes your changes and applies them to the project.
Check Out | Checks the file out from the source control repository and makes your local copy writable.
Undo Check Out | Removes any changes you have made to the local copy and sets it back to read-only.
Show Differences | Tells the version control system to display the comparison of the file with the one in version control. The version control system will only use Beyond Compare if it is set up to do so.
Show History | Shows the history of the file in the version control system.
Show Properties | Shows version control-specific properties.
Run Source Control Application | Runs the source control application.

The Edit menu

Expand All | Opens all folders in view.
Collapse All | Closes all folders in view.
Select All | Selects all visible items.
Select All Files | Selects all visible files.
Select Newer > Left Side / Right Side / Both Sides | Selects all visible files that are newer on the specified side.
Select Orphans > Left Side / Right Side / Both Sides | Selects all visible orphan files on the specified side.
Invert Selection | Selects all items not currently selected, and deselects all items currently selected.
Refresh | Refreshes open folders.
Full Refresh | Refreshes entire comparison.

The Search menu

Next Difference | Positions at next difference.
Previous Difference | Positions at previous difference.
Find Filename | Finds filename matching search string.
Find Next Filename | Finds next filename matching search string.
Find Previous Filename | Finds previous filename matching search string.

The View menu

Show All | Uses no display filter on either side.
Show Changes | Shows left add, right add, left delete, right delete, left change, right change and conflict items.
Show Conflicts | Shows conflict items.
Show Left Changes | Shows left add, left delete, and left change items.
Show Right Changes | Shows right add, right delete, and right change items.
Show Mergeable | Shows same change and difference change items.
Show Unchanged | Shows unchanged items.
Show None * | Hides all files. Useful in conjunction with Always Show Folders [image] to copy folder structures.
Always Show Folders | Shows all folders, except those excluded by file filters.
Compare Files and Folder Structure | Shows folders containing files or folders that match the current display filter. Orphan folders will follow the same filtering rules as orphan files.
Compare Files Only | Shows only folders containing files to be shown.
Ignore Folder Structure | Compares filenames regardless of which subfolder they may be in. (Also called Flatten Folders.)
Ignore Unimportant Differences | Treats unimportant differences as same.
Ignore Same Changes | Treats same changes as same.
Suppress Filters | Temporarily suppresses file filters and display filters.
Center Pane | Shows or hides the center pane.
Columns | Shows or hides view columns.
Legend | Displays a window that lists what the different folder colors mean.
Log | Shows or hides the log panel.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Folder Sync Commands

Following is a description of the Folder Sync commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Folder Sync Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Folder Sync.
Swap Sides | Exchanges the left and right base folders.
Folder Sync Info | Displays sync statistics.
Run Sync | Performs all sync actions.
Compare Base Folders | Opens a new Folder Compare session based on the current base folders.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the current base folders.

The Actions menu

Leave Alone | Changes sync operation to leave alone.
Copy Right to Left | Changes sync operation to copy right to left.
Copy Left to Right | Changes sync operation to copy left to right.
Delete Left | Changes sync operation to delete left.
Delete Right | Changes sync operation to delete right.
Open Folder / Close Folder | Opens or closes the selected folder in the comparison.
Open Subfolders | Opens the selected folders and all their subfolders.
Close Subfolders | Closes the selected folders and all their subfolders.
Set as Base Folder | Sets the selected folder as the base folder on its side of the comparison.
Set as Base on Other Side | Sets the selected folder as the base folder on the other side of the comparison.
Set as Base Folders | Sets the two selected folders as the left and right base folders in this comparison view. (To open them in a new view use Open in New View instead.)
Open | Opens selected items in a new comparison view. If the items are files, the view type is determined by the file format list. If exactly two items are selected, they will be compared to each other (whether or not they are across from each other) in the new view. If only one item is selected it will be compared to the item across from it, if it exists.
Open With | Opens selected files in a new view using a specified type of file session, or opens the selected items in an external application, as defined in "Open With" Applications. Note that the Folder Sync view is not automatically updated if the items are modified by the external application.
Open With > Associated Application | Opens selected files with the associated application.
Open With > Text Edit | Opens selected files with the built-in text editor.
Open With > Text Patch | Opens selected files with the built-in patch view.
Exclude | Excludes selected file, or type of file, from the current session.
Copy Filename | Copies a list of the selected items' paths to the clipboard.
Refresh Selection | Refreshes the selected items.
Explorer | Displays the file manager's context menu for the selected item(s).

The Edit menu

Expand All | Opens all folders in view.
Collapse All | Closes all folders in view.
Select All | Selects all visible items.
Invert Selection | Selects all items not currently selected, and deselects all items currently selected.
Refresh | Refreshes open folders.
Full Refresh | Refreshes entire comparison.

The Search menu

Next Conflict | Positions at next conflict.
Previous Conflict | Positions at previous conflict.
Find Filename | Finds filename matching search string.
Find Next Filename | Finds next filename matching search string.
Find Previous Filename | Finds previous filename matching search string.

The View menu

Ignore Unimportant Differences | Treats unimportant differences as same.
Suppress Filters | Temporarily shows items that will not be affected by the sync.
Columns | Shows or hides view columns.
Legend | Displays a window that lists what the different folder colors mean.
Log | Shows or hides the log panel.
Toolbar | Shows or hides the toolbar.


Text Compare Commands

Following is a description of the Text Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Text Compare Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Text Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files, prompting to save first if necessary.
Recompare Files | Recompares the displayed files, preserving edits, but not undoability.
Text Compare Report | Produces the Text Compare report.
Text Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file view.
Merge Files | Opens a new Text Merge session based on the currently loaded files.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu

Open File | Opens an existing file into the picked pane.
Open File on File System * | Opens an existing local file into the picked pane.
Open File Using Profile * | Opens an existing file into the picked pane using a profile.
Open Clipboard | Loads the Clipboard contents into the picked pane.
Open With | Opens the picked pane's file in one of the external Open With applications.
Open With > Associated Application | Opens the picked pane's file with its associated application.
Open With > Text Edit | Opens the picked pane's file with the built-in text editor.
Open With > Text Patch | Opens the picked pane's file with the built-in patch view.
Save File | Saves the modified file from the picked pane.
Save File As | Saves the file from the picked pane with a new name.
Save File on File System As * | Saves the file from the picked pane with a new name on the file system.
Save File Using Profile As * | Saves the file from the picked pane with a new name using a profile.
Explorer | Displays the file manager's context menu for the file in the picked pane.
Check In | Appears if a source control provider has been configured and the file is under source control.
Check Out |
Undo Check Out |

The Edit menu

Undo | Undoes previous action.
Redo | Redoes previously undone action.
Align With | Allows you to select one or more lines, and then click on a line on the other side to force them to be side-by-side.
Isolate | Realigns comparison so that selected lines are by themselves.
Replacement | Adds item to the replacement list based on the current difference.
Copy to Right / Copy to Left * | Copies selected lines or current section to indicated side.
Copy to Other Side | Copies selected lines or current section to opposite side. The caption and icon appear as Copy to Right or Copy to Left depending on the current side.
Copy Line to Right / Copy Line to Left * | Copies current line to indicated side.
Copy Line to Other Side | Copies current line to other side. The caption and icon appear as Copy Line to Right or Copy Line to Left depending on the current side.
Increase Indent | Increases indentation of selected lines.
Decrease Indent | Decreases indentation of selected lines.
Cut / Copy / Paste / Delete | Standard editing commands.
Delete Line * | Deletes the current line.
Delete to Start of Line * | Deletes text from the current position to the beginning of the line.
Delete to End of Line * | Deletes text from the current position to the end of the line.
Delete Word * | Deletes the word at the current position.
Delete to Start of Word * | Deletes from the current position to the beginning of the word.
Delete to End of Word * | Deletes from the current position to the end of the word.
Insert Line Before * | Inserts a new blank line before the current line.
Insert Line After * | Inserts a new blank line after the current line.
Select All | Selects all visible lines in the current pane.
Select Section | Selects all lines in the current section.
Compare Selection to Clipboard | Compares the selected text with the contents of the clipboard in a new view.
Convert File > Trim Trailing Whitespace | Strips off spaces and tab characters at end of lines.
Convert File > Leading Spaces to Tabs | Replaces spaces at the beginning of lines with the appropriate number of tab characters (based on current tab stop setting).
Convert File > Tabs To Spaces | Replaces all tab characters with the appropriate number of space characters (based on current tab stop setting).
Convert File > Line Endings | Changes the line ending style on all lines.
Full Edit | Toggles between full character mode editing (marked) and Beyond Compare 2-like line mode (unmarked) in the main file panes.

The Search menu

Next Difference | Positions at next difference text.
Previous Difference | Positions at previous difference text.
Next Difference Section | Positions at next difference section.
Previous Difference Section | Positions at previous difference section.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Next Replacement | Positions at next replacement text.
Previous Replacement | Positions at previous replacement text.
Next Edit | Positions at the next edited line beyond the cursor.
Previous Edit | Positions at previous edited line before the cursor.
Find | Searches for matching text.
Replace | Replaces matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Go To | Positions at specified line and column.
Toggle Bookmark | Places a numbered marker on the current line of the comparison, numbered from 0 to 9.
Go To Bookmark | Repositions at the specified bookmark.
Clear Bookmarks | Removes all bookmarks from the comparison.

The View menu

Show All | Shows all lines, with or without differences.
Show Differences | Shows only lines with differences.
Show Same | Shows only lines without differences.
Show None * | Hides all lines.
Show Context | Shows lines surrounding differences. The number of context lines can be set in Text View Options.
Ignore Unimportant Differences | Treats unimportant differences as same.
Ignored | Suppresses differences in selected lines or current section.
Visible Whitespace | Shows or hides visible spaces, tabs.
Line Numbers | Shows or hides line numbers.
Syntax Highlighting | Shows or hides syntax highlighting.
Display Font * | Selects the font to use in editor panes.
Increase Display Font Size * | Increases editor font size.
Decrease Display Font Size * | Decreases editor font size.
Reset Display Font Size * | Resets editor font size.
Side-by-side Layout | Arranges editor panes left and right of each other.
Over-under Layout | Arranges editor panes above and below each other.
Webpages | Shows or hides web browser panels that display the current files as webpages.
Thumbnail | Shows or hides the thumbnail summary of changes at left of view.
Text Details | Shows or hides the text details panel at bottom of view.
Hex Details | Shows or hides the hexadecimal details panel at bottom of view.
Alignment Details | Shows or hides the alignment details panel at bottom of view.
Ruler | Shows or hides the line details ruler.
File Info | Shows or hides file information panels at the top of editor panes.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Text Merge Commands

Following is a description of the Text Merge commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Text Merge Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Text Merge.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files, prompting to save first if necessary.
Recompare Files | Recompares the displayed files, preserving edits, but not undoability.
Text Merge Info | Displays merge statistics.
Compare to Output > Left Side / Center Side / Right Side | Opens the file on the indicated side and the output file in a new Text Compare session.
Merge Parent Folders | Opens a new Folder Merge session based on the parent folders of the currently loaded files.

The File menu

Open File | Opens an existing file into the picked pane.
Open File on File System * | Opens an existing local file into the picked pane.
Open File Using Profile * | Opens an existing file into the picked pane using a profile.
Open Clipboard | Loads the Clipboard contents into the picked pane.
Open With | Opens the picked pane's file in one of the external Open With applications.
Open With > Associated Application | Opens the picked pane's file with its associated application.
Open With > Text Edit | Opens the picked pane's file with the built-in text editor.
Open With > Text Patch | Opens the picked pane's file with the built-in patch view.
Save File | Saves the modified file from the picked pane.
Save File As | Saves the file from the picked pane with a new name.
Save File on File System As * | Saves the file from the picked pane with a new name on the file system.
Save File Using Profile As * | Saves the file from the picked pane with a new name using a profile.
Explorer | Displays the file manager's context menu for the file in the picked pane.

The Edit menu

Undo | Undoes previous action.
Redo | Redoes previously undone action.
Align With | Allows you to select one line, and then click on a second line to force them to be side-by-side.
Isolate | Realigns comparison so that selected lines are by themselves.
Conflict | Clears or sets conflict for selected lines or current section.
Take Left / Take Center / Take Right | Takes selected lines or current section from indicated side.
Take Left Then Right / Take Right Then Left | Takes selected lines or current section from left and right in the indicated order.
Take Left Line / Take Center Line / Take Right Line | Takes current line from indicated side.
Increase Indent | Increases indentation of selected lines.
Decrease Indent | Decreases indentation of selected lines.
Cut / Copy / Paste / Delete | Standard editing commands.
Delete Line * | Deletes the current line.
Delete to Start of Line * | Deletes text from the current position to the beginning of the line.
Delete to End of Line * | Deletes text from the current position to the end of the line.
Delete Word * | Deletes the word at the current position.
Delete to Start of Word * | Deletes from the current position to the beginning of the word.
Delete to End of Word * | Deletes from the current position to the end of the word.
Insert Line Before * | Inserts a new blank line before the current line.
Insert Line After * | Inserts a new blank line after the current line.
Select All | Selects all visible lines in the current pane.
Select Section | Selects all lines in the current section.
Compare Selection to Clipboard | Compares the selected text with the contents of the clipboard in a new view.
Full Edit | Toggles between full character mode editing (marked) and Beyond Compare 2-like line mode (unmarked) in the main file panes.

The Search menu

Clear Conflict Section, Next | Clears conflict for current section and positions at next conflict section.
Next Conflict Section | Positions at next conflict section.
Previous Conflict Section | Positions at previous conflict section.
Next Difference | Positions at next difference text.
Previous Difference | Positions at previous difference text.
Next Difference Section | Positions at next difference section.
Previous Difference Section | Positions at previous difference section.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Take Left File and Open Next Difference | Takes the entire left-side file and opens the folder session's next different files. (Child sessions only.)
Take Right File and Open Next Difference | Takes the entire right-side file and opens the folder session's next different files. (Child sessions only.)
Next Left Taken / Next Right Taken | Positions at next range of lines where indicated side was taken.
Previous Left Taken / Previous Right Taken | Positions at previous range of lines where indicated side was taken.
Next Edit | Positions at the next edited line beyond the cursor.
Previous Edit | Positions at previous edited line before the cursor.
Find | Searches for matching text.
Replace | Replaces matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Go To | Positions at specified line and column.
Toggle Bookmark | Places a numbered marker on the current line of the comparison, numbered from 0 to 9.
Go To Bookmark | Repositions at the specified bookmark.
Clear Bookmarks | Removes all bookmarks from the comparison.

The View menu

Show All | Shows unchanged, same change, left change, right change, different change and conflict lines.
Show Changes | Shows same change, left change, right change, different change and conflict lines.
Show Conflicts | Shows conflict lines.
Show Left Changes | Shows same change, left change, different change and conflict lines.
Show Right Changes | Shows same change, right change, different change and conflict lines.
Show Mergeable | Shows same change, left change, right change, and different change lines.
Show Unchanged | Shows unchanged lines.
Show None * | Shows no lines.
Show Context | Shows lines surrounding differences. The number of context lines can be set in Text View Options.
Ignore Unimportant Differences | Treats unimportant differences as same.
Ignore Same Changes | Treats same changes as same.
Favor Left Changes | Suppresses highlighting of left-only changes in output.
Favor Right Changes | Suppresses highlighting of right-only changes in output.
Ignored | Ignores (or unignores) differences in selected lines or current section.
Visible Whitespace | Shows or hides visible spaces, tabs.
Line Numbers | Shows or hides line numbers.
Syntax Highlighting | Shows or hides syntax highlighting.
Display Font * | Selects the font to use in editor panes.
Increase Display Font Size * | Increases editor font size.
Decrease Display Font Size * | Decreases editor font size.
Reset Display Font Size * | Resets editor font size.
Side-by-side Layout | Arranges editor panes left and right of each other.
Over-under Layout | Arranges editor panes above and below each other.
Detached Output Pane | Shows output pane in separate window.
Webpages | Shows or hides web browser panels that display the current files as webpages.
Thumbnail | Shows or hides the thumbnail summary of changes at left of view.
Center Pane | Shows or hides center pane.
Text Details | Shows or hides the text details panel at bottom of view.
Hex Details | Shows or hides the hexadecimal details panel at bottom of view.
Ruler | Shows or hides the line details ruler.
File Info | Shows or hides file information panels at the top of editor panes.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Table Compare Commands

Following is a description of the Table Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Table Compare Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Table Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files, prompting to save first if necessary.
Recompare Files | Recompares the displayed files, preserving edits, but not undoability.
Table Compare Report | Produces the Table Compare report.
Table Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file view.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu

Open File | Opens an existing file into the picked pane.
Open File on File System * | Opens an existing local file into the picked pane.
Open File Using Profile * | Opens an existing file into the picked pane using a profile.
Open Clipboard | Loads the Clipboard contents into the picked pane.
Open With | Opens the picked pane's file in one of the external Open With applications.
Open With > Associated Application | Opens the picked pane's file with its associated application.
Open With > Text Edit | Opens the picked pane's file with the built-in text editor.
Save File | Saves the modified file from the picked pane.
Save File As | Saves the file from the picked pane with a new name.
Save File on File System As * | Saves the file from the picked pane with a new name on the file system.
Save File Using Profile As * | Saves the file from the picked pane with a new name using a profile.
Explorer | Displays the file manager's context menu for the file in the picked pane.

The Edit menu

Undo | Undoes previous action.
Redo | Redoes previously undone action.
Copy to Right / Copy to Left * | Copies selected rows to indicated side.
Copy to Other Side | Copies selected rows to opposite side. The caption and icon appear as Copy to Right or Copy to Left depending on the current side.
Cut / Copy / Paste / Delete | Standard editing commands.
Insert | Inserts new row.
Edit | Toggles edit mode on current cell.
Select All | Selects all visible rows in the current pane.

The Search menu

Next Difference Row | Positions at next difference row.
Previous Difference Row | Positions at previous difference row.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Next Edit | Positions at the next edited row beyond the cursor.
Previous Edit | Positions at previous edited row before the cursor.
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Go To | Positions at specified row and column.

The View menu

Show All | Shows all rows, with or without differences.
Show Differences | Shows only rows with differences.
Show Same | Shows only rows without differences.
Show None * | Hides all rows.
Ignore Unimportant Differences | Treats unimportant differences as same.
Resize Columns to Fit | Makes columns wide enough for data to be fully visible.
Columns | Shows or hides columns.
Visible Whitespace | Shows or hides visible spaces, tabs.
Row Numbers | Shows or hides row numbers.
Display Font * | Selects the font to use to display file data.
Increase Display Font Size * | Increases editor font size.
Decrease Display Font Size * | Decreases editor font size.
Reset Display Font Size * | Resets editor font size.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Thumbnail | Shows or hides the thumbnail summary of changes at left of view.
Text Details | Shows or hides the text details panel at bottom of view.
File Info | Shows or hides file information panels at the top of panes.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Hex Compare Commands

Following is a description of the Hex Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Hex Compare Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Hex Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files, prompting to save first if necessary.
Recompare Files | Recompares the displayed files, preserving edits, but not undoability.
Hex Compare Report | Produces the Hex Compare report.
Hex Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file view.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu

Open File | Opens an existing file into the picked pane.
Open File on File System * | Opens an existing local file into the picked pane.
Open File Using Profile * | Opens an existing file into the picked pane using a profile.
Open Clipboard | Loads the Clipboard contents into the picked pane.
Open With | Opens the picked pane's file in one of the external Open With applications.
Open With > Associated Application | Opens the picked pane's file with its associated application.
Open With > Text Edit | Opens the picked pane's file with the built-in text editor.
Save File | Saves the modified file from the picked pane.
Save File As | Saves the file from the picked pane with a new name.
Save File on File System As * | Saves the file from the picked pane with a new name on the file system.
Save File Using Profile As * | Saves the file from the picked pane with a new name using a profile.
Explorer | Displays the file manager's context menu for the file in the picked pane.

The Edit menu

Undo | Undoes previous action.
Redo | Redoes previously undone action.
Copy to Right / Copy to Left * | Copies selected bytes to indicated side.
Copy to Other Side | Copies selected bytes to opposite side. The caption and icon appear as Copy to Right or Copy to Left depending on the current side.
Cut / Copy / Paste / Delete | Standard editing commands.
Select All | Selects all visible bytes in the current pane.

The Search menu

Next Difference Bytes | Positions at next difference bytes.
Previous Difference Bytes | Positions at previous difference bytes.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Find | Searches for matching text.
Replace | Replaces matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Go To | Positions at specified byte.

The View menu

Show All | Shows all bytes, with or without differences.
Show Differences | Shows only bytes with differences.
Show Same | Shows only bytes without differences.
Current Byte Address | Shows current byte address.
Little Endian Values | Lists values treating the first byte as the least significant one.
Big Endian Values | Lists values treating the first byte as the most significant one.
Byte Addresses | Shows or hides byte addresses.
Display Font * | Selects the font to use to display file data.
Increase Display Font Size * | Increases hex font size.
Decrease Display Font Size * | Decreases hex font size.
Reset Display Font Size * | Resets hex font size.
Layout | Configures layout options.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Thumbnail | Shows or hides the thumbnail summary of changes at left of view.
File Info | Shows or hides file information panels at the top of panes.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


MP3 Compare Commands

Following is a description of the MP3 Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the MP3 Compare Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty MP3 Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files.
Recompare Files | Recompares the displayed files without reloading.
MP3 Compare Report | Produces the MP3 Compare report.
MP3 Compare Info | Displays comparison statistics.
Play Both | Plays both audio tracks.
Compare Files Using | Opens the displayed files in a new session using a different class of file view.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu

Open File | Opens an existing file into the picked pane.
Open File on File System * | Opens an existing local file into the picked pane.
Open File Using Profile * | Opens an existing file into the picked pane using a profile.
Play | Plays audio track.
Open With | Opens the picked pane's file in one of the external Open With applications.
Open With > Associated Application | Opens the picked pane's file with its associated application.
Explorer | Displays the file manager's context menu for the file in the picked pane.

The Edit menu

Copy | Copies selection to the Clipboard.
Select All | Selects all visible items in the current pane.

The Search menu

Next Difference Item | Positions at next difference item.
Previous Difference Item | Positions at previous difference item.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.

The View menu

Show All | Shows all items, with or without differences.
Show Differences | Shows only items with differences.
Show Same | Shows only items without differences.
Show None * | Hides all items.
Ignore Unimportant Differences | Treats unimportant differences as same.
Item Is Important | Marks selected item as important or unimportant.
Visible Whitespace | Shows or hides visible spaces, tabs.
Display Font * | Selects the font to use to display file data.
Increase Display Font Size * | Increases listing font size.
Decrease Display Font Size * | Decreases listing font size.
Reset Display Font Size * | Resets listing font size.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Text Details | Shows or hides the text details panel at bottom of view.
File Info | Shows or hides file information panels at the top of panes.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Picture Compare Commands

Following is a description of the Picture Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Picture Compare Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Picture Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files.
Recompare Files | Recompares the displayed files without reloading.
Picture Compare Report | Produces the Picture Compare report.
Picture Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file view.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu

Open File | Opens an existing file into the picked pane.
Open File on File System * | Opens an existing local file into the picked pane.
Open File Using Profile * | Opens an existing file into the picked pane using a profile.
Open Clipboard | Loads the Clipboard contents into the picked pane.
Open With | Opens the picked pane's file in one of the external Open With applications.
Open With > Associated Application | Opens the picked pane's file with its associated application.
Explorer | Displays the file manager's context menu for the file in the picked pane.

The Edit menu

Copy

Copies selection to the Clipboard.

The Search menu

Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)

The View menu

Tolerance Mode | Detects pixel differences greater than configurable tolerance.
Mismatch Range Mode | Measures degree of pixel difference.
Blend Mode | Blends pictures based on configurable percentage.
Ignore Unimportant Differences | Treats unimportant differences as same.
Auto Scale | Forces pictures to have same height or width.
Rotate Clockwise | Spins current picture to right by 90 degrees.
Rotate Counterclockwise | Spins current picture to left by 90 degrees.
Flip Horizontally | Swaps pixels of current picture relative to its horizontal center.
Flip Vertically | Swaps pixels of current picture relative to its vertical center.
Reset Difference Offset | Realigns top left corner of both pictures.
Compare Metadata | Compares or ignores metadata.
Visible Whitespace | Shows or hides visible spaces, tabs.
Display Font * | Selects the font to use to display file data.
Increase Display Font Size * | Increases listing font size.
Decrease Display Font Size * | Decreases listing font size.
Reset Display Font Size * | Resets listing font size.
Blend Toggle | Switches between left and right pictures.
File Info | Shows or hides file information panels at the top of panes.
Full Screen | Displays the picked pane full screen. Press ESC to exit full screen mode.
Zoom > Zoom In | Makes pictures appear to be larger.
Zoom > Zoom Out | Makes pictures appear to be smaller.
Zoom > Actual Size | Makes pictures appear at actual size.
Zoom > Fit to Window | Makes pictures appear to fill panes.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Registry Compare Commands

Following is a description of the Registry Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Registry Compare Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Registry Compare.
Swap Sides | Exchanges the left and right registries.
Up One Level > Left Side / Right Side / Both Sides | Changes either or both base keys to their parent keys.
Reload | Reloads the displayed registries.
Recompare | Recompares the displayed registries without reloading.
Registry Compare Report | Produces the Registry Compare report.
Registry Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file view.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu

Open | Opens a registry into the picked pane.
Open Registry * | Opens a live registry into the picked pane.
Open Registry File on File System * | Opens an existing local registry file into the picked pane.
Open Registry File Using Profile * | Opens an existing registry file into the picked pane using a profile.
Open With | Opens the picked pane's file in one of the external Open With applications.
Open With > Associated Application | Opens the picked pane's file with its associated application.
Open With > Text Edit | Opens the picked pane's file with the built-in text editor.
Explorer | Displays the file manager's context menu for the file in the picked pane.

The Edit menu

Set as Base Keys | Sets selected keys as base keys.
Set Both as Base Keys | Sets selected key and key on other side as base keys.
Set as Base Key on Other Side | Sets selected key as base key on other side.
Undo | Undoes previous action.
Redo | Redoes previously undone action.
Copy to Right / Copy to Left * | Copies selected items to indicated side.
Copy to Other Side | Copies selected items to opposite side. The caption and icon appear as Copy to Right or Copy to Left depending on the current side.
Copy | Copies selection to the Clipboard.
Delete | Deletes selected items.
Rename | Renames current item.
New Key | Adds a new key.
New Value | Adds a new value.
Modify | Modifies current value.
Copy Key Name | Copies current key's name to Clipboard.
Export | Saves current key as registry file.
Export All | Saves all keys as registry file.
Select All | Selects all visible items in the current pane.

The Search menu

Next Difference Item | Positions at next difference item.
Previous Difference Item | Positions at previous difference item.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.

The View menu

Show All | Shows all items, with or without differences.
Show Differences | Shows only items with differences.
Show Same | Shows only items without differences.
Show None * | Hides all items.
Expand All | Opens all items.
Collapse All | Closes all items.
Visible Whitespace | Shows or hides visible spaces, tabs.
Display Font * | Selects the font to use to display file data.
Increase Display Font Size * | Increases listing font size.
Decrease Display Font Size * | Decreases listing font size.
Reset Display Font Size * | Resets listing font size.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Text Details | Shows or hides the text details panel at bottom of view.
Hex Details | Shows or hides the hexadecimal details panel at bottom of view.
File Info | Shows or hides file information panels at the top of panes.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Version Compare Commands

Following is a description of the Version Compare commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The Session menu

Save Session | Saves the current session.
Save Session As | Saves the current session under a new name.
Session Settings | Opens the Version Compare Session Settings dialog.
Locked | Locks or unlocks current session.
Clear Session | Replaces the current view with an empty Version Compare.
Swap Sides | Exchanges the left and right files.
Reload Files | Reloads the displayed files.
Recompare Files | Recompares the displayed files without reloading.
Version Compare Report | Produces the Version Compare report.
Version Compare Info | Displays comparison statistics.
Compare Files Using | Opens the displayed files in a new session using a different class of file view.
Compare Parent Folders | Opens a new Folder Compare session based on the parent folders of the currently loaded files.

The File menu

Open File | Opens an existing file into the picked pane.
Open File on File System * | Opens an existing local file into the picked pane.
Open File Using Profile * | Opens an existing file into the picked pane using a profile.
Open With | Opens the picked pane's file in one of the external Open With applications.
Open With > Associated Application | Opens the picked pane's file with its associated application.
Explorer | Displays the file manager's context menu for the file in the picked pane.

The Edit menu

Copy | Copies selection to the Clipboard.
Select All | Selects all visible items in the current pane.

The Search menu

Next Difference Item | Positions at next difference item.
Previous Difference Item | Positions at previous difference item.
Next Difference Files | Opens the parent folder session's next pair of files with differences. (Child sessions only.)
Previous Difference Files | Opens the parent folder session's previous pair of files with differences. (Child sessions only.)
Copy File to Right and Open Next Difference | Copies the entire left-side file to the right and opens the folder session's next different files. (Child sessions only.)
Copy File to Left and Open Next Difference | Copies the entire right-side file to the left and opens the folder session's next different files. (Child sessions only.)
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.

The View menu

Show All | Shows all items, with or without differences.
Show Differences | Shows only items with differences.
Show Same | Shows only items without differences.
Show None * | Hides all items.
Ignore Unimportant Differences | Treats unimportant differences as same.
Item Is Important | Marks selected item as important or unimportant.
Visible Whitespace | Shows or hides visible spaces, tabs.
Display Font * | Selects the font to use to display file data.
Increase Display Font Size * | Increases listing font size.
Decrease Display Font Size * | Decreases listing font size.
Reset Display Font Size * | Resets listing font size.
Side-by-side Layout | Arranges panes left and right of each other.
Over-under Layout | Arranges panes above and below each other.
Text Details | Shows or hides the text details panel at bottom of view.
File Info | Shows or hides file information panels at the top of panes.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Text Edit Commands

Following is a description of the Text Edit commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The File menu

Open File | Opens an existing file.
Open File on File System * | Opens an existing local file.
Open File Using Profile * | Opens an existing file using a profile.
Open With | Opens the file in one of the external Open With applications.
Open With > Associated Application | Opens the file with its associated application.
Open With > Text Patch | Opens the file with the built-in patch view.
Save File | Saves the modified file.
Save File As | Saves the file with a new name.
Save File on File System As * | Saves the file with a new name on the file system.
Save File Using Profile As * | Saves the file with a new name using a profile.
Explorer | Displays the file manager's context menu for the file.
Check In | Appears if a source control provider has been configured and the file is under source control.
Check Out |
Undo Check Out |

The Edit menu

Undo | Undoes previous action.
Redo | Redoes previously undone action.
Increase Indent | Increases indentation of selected lines.
Decrease Indent | Decreases indentation of selected lines.
Cut / Copy / Paste / Delete | Standard editing commands.
Delete Line * | Deletes the current line.
Delete to Start of Line * | Deletes text from the current position to the beginning of the line.
Delete to End of Line * | Deletes text from the current position to the end of the line.
Delete Word * | Deletes the word at the current position.
Delete to Start of Word * | Deletes from the current position to the beginning of the word.
Delete to End of Word * | Deletes from the current position to the end of the word.
Insert Line Before * | Inserts a new blank line before the current line.
Insert Line After * | Inserts a new blank line after the current line.
Select All | Selects all visible lines.
Convert File > Trim Trailing Whitespace | Strips off spaces and tab characters at end of lines.
Convert File > Leading Spaces to Tabs | Replaces spaces at the beginning of lines with the appropriate number of tab characters (based on current tab stop setting).
Convert File > Tabs To Spaces | Replaces all tab characters with the appropriate number of space characters (based on current tab stop setting).
Convert File > Line Endings | Changes the line ending style on all lines.

The Search menu

Next Edit | Positions at the next edited line beyond the cursor.
Previous Edit | Positions at previous edited line before the cursor.
Find | Searches for matching text.
Replace | Replaces matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Find in Files | Finds search string in multiple files.
Go To | Positions at specified line and column.
Toggle Bookmark | Places a numbered marker on the current line of the comparison, numbered from 0 to 9.
Go To Bookmark | Repositions at the specified bookmark.
Clear Bookmarks | Removes all bookmarks from the comparison.

The View menu

Visible Whitespace | Shows or hides visible spaces, tabs.
Line Numbers | Shows or hides line numbers.
Syntax Highlighting | Shows or hides syntax highlighting.
Display Font * | Selects the font to use in editor pane.
Increase Display Font Size * | Increases editor font size.
Decrease Display Font Size * | Decreases editor font size.
Reset Display Font Size * | Resets editor font size.
Webpages | Shows or hides web browser panel that displays the current file as a webpage.
File Info | Shows or hides file information panels at the top of editor panes.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Text Patch Commands

Following is a description of the Text Patch commands, in addition to the common commands. Most of these commands are available as toolbar buttons.

Pick Tools > Options [image] and switch to the Toolbars, etc. page to define your own keyboard shortcuts, and hide or expose commands on the menus and toolbars.

The File menu

Open With | Opens the file in one of the external Open With applications.
Open With > Associated Application | Opens the file with its associated application.
Open With > Text Edit | Opens the file with the built-in text editor.
Apply Patch | Applies the patch file.

The Edit menu

Copy | Copies selection to the Clipboard.
Select All | Selects all visible lines in the current pane.
Select Section | Selects all lines in the current section.

The Search menu

Next Difference | Positions at next difference text.
Previous Difference | Positions at previous difference text.
Next Difference Section | Positions at next difference section.
Previous Difference Section | Positions at previous difference section.
Next Difference Files | Opens the next pair of files with differences.
Previous Difference Files | Opens the previous pair of files with differences.
Find | Searches for matching text.
Find Next | Finds next occurrence of search string.
Find Previous | Finds previous occurrence of search string.
Go To | Positions at specified line and column.
Toggle Bookmark | Places a numbered marker on the current line of the comparison, numbered from 0 to 9.
Go To Bookmark | Repositions at the specified bookmark.
Clear Bookmarks | Removes all bookmarks from the comparison.

The View menu

Visible Whitespace | Shows or hides visible spaces, tabs.
Line Numbers | Shows or hides line numbers.
Syntax Highlighting | Shows or hides syntax highlighting.
Display Font * | Selects the font to use in editor panes.
Increase Display Font Size * | Increases editor font size.
Decrease Display Font Size * | Decreases editor font size.
Reset Display Font Size * | Resets editor font size.
Side-by-side Layout | Arranges editor panes left and right of each other.
Over-under Layout | Arranges editor panes above and below each other.
Thumbnail | Shows or hides the thumbnail summary of changes at left of view.
Text Details | Shows or hides the text details panel at bottom of view.
Hex Details | Shows or hides the hexadecimal details panel at bottom of view.
Alignment Details | Shows or hides the alignment details panel at bottom of view.
Ruler | Shows or hides the line details ruler.
Toolbar | Shows or hides the toolbar.

* Hidden by default.


Command Line Reference

Command line executable files

Executable | Meaning
BCompare.exe bcompare | This is the main application. Only one copy will run at a time, regardless of how many windows you have open. If you launch a second copy it will tell the existing copy to start a comparison and exit immediately.
BComp.exe | This is a Win32 GUI program. If launched from a version control system, it should work just fine. If launched from a console window, the console (or batch file) will not wait for it.
BComp.com | This is a Win32 console program. It has to have a console. If you launch it from one (or a batch file) that console will wait for the comparison to complete before returning. If you launch it from a version control system interactively, it will show a console window while it's waiting.
bcomp | Launch this program from a version control system because it will wait for the comparison to complete before returning.

Command line parameters

Notice that each parameter should be enclosed in quotation marks if it might contain a space.

Note Mac and Linux users should use "bcompare" instead of "BCompare.exe".

Parameter | Meaning
Named Session | Opens the specified session in the appropriate view. For example: BCompare.exe "My Session"
Named Workspace | Opens the specified saved workspace. (see also Managing Workspaces) For example: BCompare.exe "My Special Workspace"
Pair of folders | Opens a new Folder Compare view with the specified base folders. For example: BCompare.exe "C:\Left Folder" "C:\Right Folder"
Pair of files | Opens the specified files in the associated file view. For example: BCompare.exe "C:\Left File.ext" "C:\Right File.ext"
3 files | Opens a Text Merge view with the specified files in the left, right, and center panes. For example: BCompare.exe C:\Left.ext C:\Right.ext C:\Center.ext
4 files | Opens a Text Merge view with the specified files in the left, right, center, and output panes. For example: BCompare.exe C:\Left.ext C:\Right.ext C:\Center.ext C:\Output.ext
Script file | Automatically executes a list of commands without using a view. For example: BCompare.exe "@C:\My Script.txt"
Settings package (.bcpkg) | Imports settings from package.
Patch file (.diff or .patch) | Opens the specified file in the Text Patch view.
- | Opens stdin in the appropriate view. For example: dir | BCompare.exe -

Command line switches

Note Mac and Linux users should prefix the switches with "-" instead of "/".

Switch | Meaning
/?, /h, /help | Opens the help file to the "Command Line Reference" page. Writes usage information to the console.
/automerge | Automatically merges files without user interaction unless conflicts are found.
/center=<filename> | Explicitly specifies the merge center file.
/closescript | Closes the script window on completion. Overrides the Close when finished setting in Tools > Options > Tweaks > Scripts.
/edit | Opens a Text Edit view.
/expandall | Expands all subfolders during the initial folder comparison.
/favorleft /favorright | Draws non-conflicting changes in the output from the "favored" side without coloring or section lines. For ignored unimportant conflicts, changes are automatically taken from the "favored" side instead of the center.
/filters=<file masks> | Uses the specified name filter for the initial folder comparison. Separate multiple file masks with semi-colons. Surround the name filter with quotes if it contains spaces.
/force | Writes conflicts to the output with CVS-style markers if /automerge is present.
/fv=<type>, /fileviewer=<type> | Opens a new view of the specified type which can be any of: "Text Compare" "Text Merge" "Table Compare" "Hex Compare" "MP3 Compare" "Picture Compare" "Registry Compare" "Version Compare" "Folder Compare" "Folder Merge" "Folder Sync" "Text Edit" "Text Patch"
/iu, /ignoreunimportant | Turns on Ignore Unimportant Differences if /automerge is present.
/mergeoutput=<filename> | Explicitly specifies the merge output file.
/nobackups | Prevents the creation of backup files.
/qc=<type>, /quickcompare=<type> | Performs a quick comparison of two files and sets the DOS error level on exit. The specified type can be size, crc, or binary. If a type is not specified, a rules-based comparison will be performed. Error levels are documented below.
/reviewconflicts | Opens a Text Merge view if /automerge is present and conflicts are found.
/ro, /readonly | Disables editing on all sides.
/ro1, /lro, /leftreadonly /ro2, /rro, /rightreadonly | Disables editing on the respective side.
/savetarget=<filename> | Overwrites the specified file instead of original file when the file view's Save command is used.
/silent | Causes all interaction to be suppressed. No Task Bar entry or window will be shown. For settings packages, all settings will be imported. For scripts, any unresolved issue that would normally show a dialog will log an error instead.
/solo | Forces a new instance of the program.
/sync | Opens a Folder Sync view.
/title1=<title>, /lefttitle=<title> /title2=<title>, /righttitle=<title> /title3=<title>, /centertitle=<title> /title4=<title>, /outputtitle=<title> | Shows the specified description in the respective path edit.
/vcs1=<path>, /vcsleft=<path> /vcs2=<path>, /vcsright=<path> /vcs3=<path>, /vcscenter=<path> /vcs4=<path>, /vcsoutput=<path> | Shows the specified version control system path in the respective path edit unless a title has been provided. For a file view, the specified path is also used to pick the appropriate file format.

Return codes

Code | Meaning
0 | Success
1 | Binary same
2 | Rules-based same
11 | Binary differences
12 | Similar
13 | Rules-based differences
14 | Conflicts detected
100 | Unknown error
101 | Conflicts detected, merge output not written
102 | BComp.exe unable to wait until BCompare.exe finishes
103 | BComp.exe cannot find BCompare.exe
104 | Trial period expired
105 | Error loading script file
106 | Script syntax error
107 | Script failed to load folders or files


Scripting Reference

A script is a simple text file containing a list of commands which can control the program and automatically perform file operations or produce reports. See also Scripts and Sample Scripts.

Notation | Meaning
| | delimits the possible choices
() | surrounds a required expression
[] | surrounds an optional expression
<> | surrounds the description of required user text
[...] | follows an expression that can be repeated

You can use lt in place of left or rt in place of right in any of the commands.

These are the script commands (in alphabetical order):

ATTRIB BEEP COLLAPSE COMPARE COPY COPYTO CRITERIA DATA-REPORT DELETE EXPAND FILE-REPORT FILTER FOLDER-REPORT HEX-REPORT LOAD LOG MOVE MOVETO MP3-REPORT OPTION PICTURE-REPORT REGISTRY-REPORT RENAME SELECT SNAPSHOT SYNC TEXT-REPORT TOUCH VERSION-REPORT

ATTRIB

Usage:

attrib (+|-)<attribute set 1> [(+|-)<attribute set 2> [...]]

Where <attribute set> is:

[a][s][h][r]

The Mac and Linux versions do not support attrib.

Sets (+) or clears (-) the DOS file attributes in the current selection. Use a for archive, s for system, h for hidden and r for read-only.

Examples:

attrib +h

attrib +sh -a

BEEP

Usage:

beep

Beeps the PC speaker. The beep occurs regardless of the /silent command line switch.

COLLAPSE

Usage:

collapse all

collapse <path 1> [<path 2> [...]]

Collapses all folders or folders with specified paths. Paths are relative to the base folder and can not have wildcards.

Example:

collapse "My Folder 1" "My Folder 2"

COMPARE

Usage:

compare [CRC|binary|rules-based]

Compares the contents of the current selection using the compare type. By default, the most recent compare type is used.

This command only compares files once. To change how files are compared after modification, use CRITERIA.

COPY

Usage:

copy (left->right|right->left)

Copies the selected files/folders in the direction indicated.

COPYTO

Usage:

copyto [left|right|all] [path:(relative|base|none)] <path>

Copies the selected files/folders on the specified side to the specified path using the path option.

·base keeps the entire folder structure relative to the base folders of all selected items.

·relative keeps the minimum relative folder structure of all selected items.

·The defaults are all and path:none.

CRITERIA

Usage:

criteria [attrib:<attribute set>] [version] [timestamp[:[<number of seconds>sec][;IgnoreDST]]] [size|CRC|binary|rules-based] [timezone:(ignore|(left|right)(+|-)<0..12>)] [follow-symlinks] [ignore-unimportant]

Where <attribute set> is:

[a][s][h][r]

The Mac and Linux versions do not support attrib.

Sets all comparison criteria settings.

·attrib enables comparisons of the specified DOS file attributes. Use a for archive, s for system, h for hidden and r for read-only.

·version enables comparisons of version information common in exes and dlls.

·timestamp enables timestamp comparisons.

o<number of seconds>sec considers differences within a tolerance of seconds as matches.

oIgnoreDST considers differences of exactly 1 hour as matches.

·size, CRC, binary and rules-based are the possible ways to compare contents.

·timezone ignores timezone differences or applies timezone offset to the specified side.

·follow-symlinks treats symbolic links and NTFS junctions as the target file or folder, rather than the link itself.

·ignore-unimportant treats unimportant differences as matches.

Example:

criteria attrib:sh timestamp:2sec;IgnoreDST rules-based timezone:left+6

DATA-REPORT

Usage:

data-report layout:<layout> [options:<options>] [title:<report title>] output-to:(printer|clipboard|<filename>) [output-options:<options>] [<comparison>]

Generates a Table Compare report of the currently selected files.

·layout controls the report's appearance and can be side-by-side, summary or interleaved.

·options is optional and is used differently for each layout.

oignore-unimportant treats differences in unimportant text as matches and is available in all layouts.

odisplay-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.

oline-numbers includes row numbers in the side-by-side layout.

·title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

DELETE

Usage:

delete [recyclebin=(yes|no)] (left|right|all)

Deletes the currently selected files/folders on the specified side(s). The recyclebin argument only has effect where supported by the operating system. Network drives, remote services and archive files do not support it.

EXPAND

Usage:

expand all

expand <path 1> [<path 2> [...]]

Expands specified subfolders or all subfolders. Paths are relative to the base folder and can not have wildcards. Subfolders must be expanded in order for their contents to be used by other commands, like SELECT. expand all will not expand subfolders that have been excluded from the comparison by File Filter settings.

FILE-REPORT

Usage:

file-report layout:<layout> [options:<options>] [title:<report title>] output-to:(printer|clipboard|<filename>) [output-options:<options>] [<comparison>]

Generates a report of the currently selected files based on the type of files processed. For example, it will produce a DATA-REPORT for file types associated with a Table Compare file format.

·layout controls the report's appearance and can be side-by-side or summary.

·options is optional and is used differently for each layout.

oignore-unimportant treats differences in unimportant text as matches and is available in all layouts.

odisplay-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.

oline-numbers includes line numbers in the side-by-side layout.

·title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

Example:

file-report layout:side-by-side options:display-mismatches &

output-to:printer output-options:print-color,wrap-word

FILTER

Usage:

filter <file masks>

filter cutoff:([<|>](<timestamp>|<number of days>[days])|none)

filter attrib:((+|-)<attribute set>|none)

filter size:([<|>]<number>[KB|MB|GB|TB]|none)

filter exclude-protected

filter include-protected

Where <attribute set> is:

[a][s][h][r]

The Mac and Linux versions do not support attrib, exclude-protected or include-protected.

Controls which folders and types of files are compared by using name filtering (file masks), date filtering (cutoff) or other filtering (attrib, size, exclude-protected or include-protected).

·Name filters include and exclude files and folders based on their names and paths. Multiple masks can be separated by semicolons. To indicate that a mask is an exclude mask use a leading minus (-). To indicate that a mask affects folders use a trailing backslash (\).

·cutoff excludes all files older (<) or newer (>) than a timestamp or a number of days from the current system date (<number of days>days). By default, cutoff:< is used. none can be used to remove date filtering. The date parsing is fairly lenient but if you want to be sure it parses correctly, use the format specified by the operating system's regional settings. (See Control Panel > Regional and Language Settings.) The time is optional and should follow the date (cutoff:"12/31/2012 12:00pm"). Remember to use quotation marks (" ") whenever a term contains a space.

·attrib limits the comparison to files which have an included DOS file attribute (+) and don't have an excluded attribute (-). Use a for archive, s for system, h for hidden and r for read-only. none can be used to remove attribute filtering.

·size excludes all files smaller (<) or larger (>) than the given size. By default the size is given in bytes but you can add KB, MB, GB or TB to the end to indicate that the value is in kilobytes, megabytes, gigabytes or terabytes, respectively. none can be used to remove size filtering.

·exclude-protected excludes files and folders that have both system and hidden attributes set.

·include-protected includes files and folders that have both system and hidden attributes set.

Examples:

filter "*.pas;*.dpr;*.dfm"

filter cutoff:<7days

filter cutoff:>"Dec 31, 2012"

filter cutoff:"12/31/2012 12:00pm"

filter attrib:-sh

filter "*.txt;-My Folder\" attrib:+r

FOLDER-REPORT

Usage:

folder-report layout:<layout> [options:<options>] [title:<report title>] output-to:(printer|clipboard|<filename>) [output-options:<options>]

Generates a folder comparison report of the currently loaded base folders. Folders are shown in their current state. To include subfolders add an expand all command before this.

·layout controls the report's appearance and can be side-by-side, summary or xml.

·options is optional.

oDisplay filter flags control which files are included in the report. The possible values are display-all, display-mismatches, display-no-orphans, display-mismatches-no-orphans, display-orphans, display-left-newer, display-right-newer, display-left-newer-orphans, display-right-newer-orphans and display-matches. By default, display-all is used.

oOptional columns can be included, separated by commas, in the report by using the flags column-version, column-size, column-crc, column-timestamp, column-attributes, column-group, column-owner and column-vcs. By default, column-size and column-timestamp are included. column-none can be used by itself to clear the default columns.

oUse the flag include-file-links to generate file reports and include links to them in the folder report. Only a folder report that is both side-by-side and HTML can use this flag.

·title, output-to and output-options arguments are documented under Common Report Arguments.

Examples:

folder-report layout:side-by-side &

options:column-size,column-version,column-timestamp &

output-to:clipboard output-options:html-color

folder-report layout:xml output-to:"C:\My Report.xml"

HEX-REPORT

Usage:

hex-report layout:<layout> [options:<options>] [title:<report title>] output-to:(printer|clipboard|<filename>) [output-options:<options>] [<comparison>]

Generates a Hex Compare report of the currently selected files.

·layout controls the report's appearance and can be side-by-side, summary or interleaved.

·options is optional and is used differently for each layout.

odisplay-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.

oline-numbers includes byte addresses in the side-by-side layout.

·title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

LOAD

Usage:

load <session>

load [create:(all|left|right)] <left path> [<right path>]

load <default>

Loads the specified Folder Compare session, the specified base folders or a new Folder Compare session with default settings (load <default>). Failure to load a base folder will cause the script to terminate.

·Loading a session causes all that session's settings, except the display filter (show all, only mismatches, only matches, etc.), to be used.

·Loading base folders uses the currently active settings. By default, the program defaults are used.

·The optional create parameter creates a base folder if it doesn't already exist.

Examples:

load "My Session"

load "C:\My Folder" "X:\Your Folder"

load <default>

LOG

Usage:

log [none|normal|verbose] [[append:]<filename>]

Controls how detailed the log is and where the log is stored.

·none, normal and verbose determine the amount of detail used in the log. Logging is initially disabled and begins when the mode is changed from none.

·append: causes logging to add to the file instead of replace it. By default, the log is output as Log.txt in the current folder (e.g. the Windows "Start In" folder in shortcut properties).

MOVE

Usage:

move (left->right|right->left)

Moves the selected files/folders in the direction specified.

MOVETO

Usage:

moveto [left|right|all] [path:(relative|base|none)] <path>

Moves the selected files/folders on the specified side to the specified path using the path option.

·base keeps the entire folder structure relative to the base folders of all selected items.

·relative keeps the minimum relative folder structure of all selected items.

·The defaults are all and path:none.

MP3-REPORT

Usage:

mp3-report layout:<layout> [options:<options>] [title:<report title>] output-to:(printer|clipboard|<filename>) [output-options:<options>] [<comparison>]

Generates an MP3 Compare report of the currently selected files.

·layout controls the report's appearance and can be side-by-side or summary.

·options is optional and is used differently for each layout.

oignore-unimportant treats differences in unimportant text as matches and is available in all layouts.

odisplay-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.

·title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

OPTION

Usage:

option stop-on-error

option confirm:(prompt|yes-to-all|no-to-all)

Adjusts script processing options.

·stop-on-error makes the script watch for various error conditions, including file operation errors, and, when one occurs, prompts the user before continuing.

·confirm can use prompt, yes-to-all or no-to-all to handle confirmation dialogs that occur due to file operations. By default, prompt is used.

PICTURE-REPORT

Usage:

picture-report layout:<layout> [options:<options>] [title:<report title>] output-to:(printer|clipboard|<filename>) [output-options:<options>] [<comparison>]

Generates a Picture Compare report of the currently selected files.

·layout controls the report's appearance and can be side-by-side or summary.

·options is optional and is used differently for each layout.

oignore-unimportant treats differences in unimportant text as matches in the summary layout.

·title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

REGISTRY-REPORT

Usage:

registry-report layout:<layout> [options:<options>] [title:<report title>] output-to:(printer|clipboard|<filename>) [output-options:<options>] [<comparison>]

Generates a Registry Compare report of the currently selected files.

·layout controls the report's appearance and can be side-by-side or summary.

·options is optional and is used differently for each layout.

odisplay-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.

·title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

RENAME

Usage:

rename [regexpr <old mask>] <new mask>

Performs a multi-file rename on the current selection using the specified new mask. regexpr uses an old mask to perform a regular expression rename. By default, a DOS-style rename is performed.

Examples:

rename *.bak

rename regexpr (...)(...)\.txt $2$1.txt

SELECT

Usage:

select <selection mask 1> [<selection mask 2> [...]]

Where <selection mask> is one of the following:

all

[(left|right|all).][(exact|diff|newer|older|orphan|all).][(files|folders|all)]

empty.folders

Select controls which files and folders can be operated on. Only files and folders that match at least one of the selection masks are part of the selection.

·left, right or all limits the selection to the specified side. By default, all is used.

·exact, diff, newer, older, orphan or all limits the selection based on results of comparison. diff refers to differences in criteria other than timestamps. To compare timestamps use newer or older instead. Folders must contain only the specified result type to be affected. By default, all is used.

·files, folders or all limits the selection to files, folders or both. By default, all is used.

·empty.folders is a special selection mask that will select empty folders.

Examples:

select all

select left

select exact

select files

select right.diff

select left.folders

select newer.files right.older.files

SNAPSHOT

Usage:

snapshot [save-crc] [save-version] [expand-archives] [follow-symlinks] [include-empty] [no-filters] left|right|path:<path> [output:<target>]

Saves a read-only snapshot of the specified folder.

·save-crc calculates CRC's for all files and stores them as part of the snapshot.

·save-version stores version information for executable files.

·expand-archives stores the contents of archive files in an expanded format.

·follow-symlinks stores files and folders pointed to by symbolic links.

·include-empty stores folders that are empty or contain only excluded files.

·no-filters stores all files regardless of the active filename filters.

·left, right and path indicate which folder is stored. left or right will save a snapshot of one of the loaded base folders and path will save a snapshot of a specified path.

·output is optional and determines where the snapshot will be saved. By default, it will be saved in the current folder.

oIf target is a fully qualified filename, that will be the name of the snapshot. If target doesn't have an extension, .bcss will be used.

oIf the target isn't included or refers to a folder a filename will be generated based on the source folder's name and the current system date, eg folder_2012-12-31.bcss. If necessary an additional number will be added to the generated name to keep it from overwriting existing snapshots.

Examples:

snapshot save-crc save-version no-filters path:C:\ output:D:\

snapshot left output:"My Snapshot.bcss"

SYNC

Usage:

sync [visible] [create-empty] (update|mirror):(left->right|right->left|all)

Synchronizes folders by copying and deleting files. This command does not use the current selection.

·visible enables "Only affect visible files" behavior. Only files in expanded folders will be affected.

·create-empty enables the "Create empty folders" behavior.

·update copies newer and orphan files in the indicated direction, leaving orphans and newer files on the opposite side unchanged. Using all as the direction indicates a bidirectional sync and copies newer and orphan files in both directions.

·mirror makes the target folder identical to the source one. Newer, older, different and orphaned files are all copied to the destination. Orphans in the destination are deleted. The all direction doesn't apply in this context and is not valid.

Example:

sync create-empty mirror:left->right

TEXT-REPORT

Usage:

text-report layout:<layout> [options:<options>] [title:<report title>] output-to:(printer|clipboard|<filename>) [output-options:<options>] [<comparison>]

Generates a Text Compare report of the currently selected files.

·layout controls the report's appearance and can be side-by-side, summary, interleaved, patch, statistics or xml. Deprecated layouts over-under and composite have been replaced by interleaved.

·options is optional and is used differently for each layout.

oignore-unimportant treats differences in unimportant text as matches and is available in all layouts.

odisplay-all, display-mismatches, display-context or display-matches can be used to control which lines of the comparison are included in all layouts except summary, patch and statistics. By default, display-all is used.

oline-numbers includes line numbers in the side-by-side layout.

ostrikeout-left-diffs crosses out left difference lines in the interleaved layout.

ostrikeout-right-diffs crosses out right difference lines in the interleaved layout.

opatch-normal, patch-context or patch-unified formats are available in the patch layout. By default, patch-normal is used.

·title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

The deprecated stats-descriptive option will generate a summary report instead and post a warning to the log. The deprecated stats-tabular option is ignored in the statistics layout: the statistics layout is always tabular (CSV) now.

Examples:

text-report layout:interleaved options:display-context &

output-to:printer output-options:print-color,wrap-word

text-report layout:patch options:patch-unified &

output-to:"My Report.txt"

TOUCH

Usage:

touch (left->right|right->left)

touch (left|right|all):(now|<timestamp>)

Copies the timestamps from files on one side to the other or sets the timestamps of all files on a specified side to the current system time (now) or a specified timestamp. You must select files before you can touch them.

VERSION-REPORT

Usage:

version-report layout:<layout> [options:<options>] [title:<report title>] output-to:(printer|clipboard|<filename>) [output-options:<options>] [<comparison>]

Generates a Version Compare report of the currently selected files.

·layout controls the report's appearance and can be side-by-side or summary.

·options is optional and is used differently for each layout.

oignore-unimportant treats differences in unimportant text as matches and is available in all layouts.

odisplay-all, display-mismatches or display-matches can be used to control which lines of the comparison are included in all layouts except summary. By default, display-all is used.

·title, output-to, output-options and <comparison> arguments are documented under Common Report Arguments.

Common report arguments

The report commands (data-report, file-report, folder-report, hex-report, mp3-report, picture-report, registry-report, text-report and version-report) must include information on where the report should be sent and may include additional information on the output format.

·title controls the title that appears at the top of the report.

·output-to controls the output target. It can be printer, clipboard or a filename.

·output-options is optional and is used differently for each output target.

oprint-color or print-mono color schemes are available for printer output. By default, print-mono is used.

oprint-portrait or print-landscape orientations are available for printer output. By default, print-portrait is used.

owrap-none, wrap-character or wrap-word control whether long lines are wrapped. printer output can use all three options. HTML output can use wrap-none and wrap-word. By default, wrap-none is used.

ohtml-color, html-mono or html-custom are required to output as HTML instead of plain text. These options are available for clipboard and file outputs. html-custom requires the filename or URL of an external style sheet.

·<comparison> can either be a session name or a pair of filenames. The file report will use the specified comparison instead of the files that have been selected within the script. When using a saved session, the comparison type must match the report type (e.g. a Table Compare session must use data-report or file-report).

Examples:

data-report layout:interleaved output-to:printer &

output-options:print-color,print-landscape

file-report layout:summary output-to:clipboard &

output-options:wrap-word,html-color

text-report layout:patch options:patch-unified &

output-to:"My Report.txt"


Regular Expression Reference

Regular Expressions are a powerful way to define patterns for searching and matching. Beyond Compare allows you to use regular expressions when searching through text, and when specifying rules for classifying text. The regular expression support in Beyond Compare is a subset of the Perl Compatible Regular Expression (PCRE) syntax.

While Regular Expressions can be a complex topic, there are several excellent resources about them. One such resource is a book called Mastering Regular Expressions. Another excellent resource is Steve Mansour's A Tao of Regular Expressions, a copy of which can be found at:

www.scootersoftware.com/RegEx.html

A regular expression is composed of two types of characters: normal characters and metacharacters. When performing a match, metacharacters take on special meanings, controlling how the match is made and serving as wildcards. Normal characters always match against only themselves. To match against a metacharacter, escape it, by prefixing it with a backslash "\". There are multiple types of metacharacters, each detailed below.

Metacharacters - Escape sequences

Escape sequence | Meaning
\xnn | character with the hex code nn
\x{nnnn} | character with the hex code nnnn
\x{F000} | character with a null value
\t | tab (0x09)
\f | form feed (0x0C)
\a | bell (0x07)
\e | escape (0x1B)

Metacharacters - Predefined classes

Predefined character classes match any of a certain subset of characters. The following classes are already defined for you.

Class | Meaning
. | match any character
\w | any alphanumeric character or _
\W | any non-alphanumeric character
\d | any numeric character (0-9)
\D | any non-numeric character
\s | any whitespace (space, tab)

You can also construct your own character classes by surrounding a group of characters in brackets "[]". The predefined classes (except ".") can be used in the brackets, and if a dash "-" appears between two characters, it represents a range. Thus [a-z] would represent all lowercase letters, and [a-zA-Z] would represent both lower and uppercase letters. To include a "-" as part of the class, place it at the beginning or end of the string.

If the first character within the brackets is a caret "^", then the class represents everything except the specified characters. [^a-z] matches on any character that isn't a lower-case alphabetic character.

Metacharacters - Alternatives

By placing an "|" between two groups of items, alternative matches can be represented. a|b will match either a or b. ab|cd will match "ab" or "cd", but not "ac". "|" groups characters from pattern delimiter ("(", "[", or the start of the pattern) to itself and then again to the end of the pattern. Alternatives can be placed within parenthesis "()" to make it obvious what is being matched against, as in a(bc|de)f. Alternatives are matched left to right. bey|beyond will match on bey, even if the string is "beyond".

Metacharacters - Position

The following metacharacters control where the match can occur on a line. Note: \A and \Z match the start and end of text respectively, but since Beyond Compare performs the search on a line by line basis, these have the same effect as ^ and $.

Metacharacter | Meaning
^ | match only at start of line
$ | match only at end of line

Metacharacters - Iterators

Anything in a regular expression can be followed by an iterator metacharacter, which refers to the item before it. There are two kinds of iterators - greedy and non-greedy. Greedy iterators match as many as they can, non-greedy match as few as they can.

Greedy:

Metacharacter | Meaning
* | match zero or more of the preceding character (equivalent to {0,})
+ | match one or more of the preceding character (equivalent to {1,})
? | matches zero or one times (equivalent to {0,1})
{n} | matches exactly n times (equivalent to {n,n})
{n,} | matches n or more times
{n,m} | matches at least n but no more than m times

Non-greedy:

Metacharacter | Meaning
*? | matches zero or more times
+? | matches one or more times
?? | matches zero or one time
{n}? | matches exactly n times
{n,}? | matches at least n times
{n,m}? | matches at least n but no more than m times

Metacharacters - Subexpressions

Parenthesis "()" can also be used to group characters for use with iterators and backreferences (discussed below). (bey){4,5} will match between 4 and 5 instances of "bey". (abc|[0-9])* will match any combination of "abc" and the digits 0 to 9 (e.g. "abc5", "679abc" and "abc77abc").

Metacharacters - Back references

Each sequence of characters which is matched within a "()" will be saved as a subexpression, which you can refer to later with \1 to \9, which refer to the subexpressions from left to right. b(.)\1n will match "been" and "boon", but not "bean", "ben" or "beeen".

Modifiers

Modifiers allow changes to the matching behavior from that point on. If the modifier is contained within a subexpression, it affects only that subexpression. Use (?i) and (?-i) to control the case sensitivity of matching.

Examples:

(?i)Beyond Compare | matches both "Beyond Compare" and "beyond compare"
(?i)Beyond (?-i)Compare | matches "Beyond Compare" and "bEyOnD Compare", but not "beyond compare"

See also

Sample Regular Expressions


Glossary

Base folder

The top-most folder on either side of a folder view. Base folder names appear in the toolbar path edits above each pane of the comparison.

Child Session

A file session launched from a folder session.

Conflict

In a 3-way merge, a conflict occurs when the same section of text has changes on both left and right sides.

CRC

CRC (Cyclic Redundancy Check) is a numeric representation of the contents of a file. If the CRCs of two files are different, then the contents of those files must be different. If the CRCs match, then it is quite likely that the contents match.

CSV

CSV (Comma Separated Values) is a common file layout for representing row and column data.

File Format

Our term for the collection of settings that characterize a type of file. For example, the Java Source file format describes the Java grammar for syntax highlighting and rules-based comparisons, and stores your tab stop preference for Java source. File formats can also specify conversion routines to be run before and after comparisons.

Filter

A setting that limits what is displayed or processed, "filtering out" unneeded content.

Important text

Text that is important to the comparison.

Line ending style

The pattern of control characters that define the end of each line in a text file. Typically, it is CR+LF in Windows/DOS, LF only in Unix, and CR only in Macintosh.

Orphan

Our term for an item that is on one side and not the other in a comparison.

Plug-in

Software accessory that can be "plugged into" the program for more features.

Profile

A named collection of settings and credentials for remote services such as FTP, WebDAV, Dropbox and Subversion.

Regular Expressions

Formulas for matching strings that follow a pattern.

Rules

Our term for the session settings that control how a comparison is performed.

Section

A contiguous range of lines with differences.

Session

Our term for a comparison task, such as comparing folders or files. Each session view is in its own top-level window, or tab on a window.

Skew tolerance

The number of lines Beyond Compare will search forward and backward for a matching section.

Snapshot

A custom Beyond Compare file that contains folder tree information. Like a camera capturing reality at a moment in time, a snapshot file captures the state of a folder so that the user can compare it to the live folder at some later time, and find what has changed.

Thumbnail

In file comparison windows, the (optional) panel on the left with the color-coded summary of differences.

Timestamp

A timestamp is a file or folder's last modified time.

Tolerance

In Table Compare and Picture Compare, the amount that two cells (or pixels) can differ before being considered an important difference. Differences less than or equal to the tolerance are unimportant differences.

Touch/Touching

The action of setting the timestamp of a file to a specific value.

Unimportant differences

Differences in text that are defined to be unimportant to the comparison. They may include whitespace or character case differences, comments or line numbers.

View

An open session (or the Home view) as it appears as a window or on a tab.

Whitespace

The blank space at the beginning and end of lines and between words. Whitespace is generally made up of any combination of the "space" and "tab" characters.

Workspace

The collection of all open sessions, including the size and position of windows and tabs.


Support, Ordering and License

For the latest version of Beyond Compare and for other news about the program, visit our web site at: www.scootersoftware.com

Technical Support

Please send any comments, suggestions or bug reports to: support@scootersoftware.com

Visit our support forums to share problems and ideas: www.scootersoftware.com/forum

Access our online FAQ and Knowledge Base articles at: www.scootersoftware.com/kb

Customer Support

The single user license fee for Beyond Compare is $30 (US dollars) for the Standard edition and $60 for the Pro edition. For current information on multi-user discounts and upgrade policy, please visit our on-line shop at: www.scootersoftware.com/shop

If you need help ordering Beyond Compare, contact us at: sales@scootersoftware.com

For our mailing address and other contact information, visit: www.scootersoftware.com/contact

License Agreement

Our License Agreement allows each licensed user to install and use Beyond Compare on any number of computers. Read the agreement to understand your rights and obligations concerning the use of the software.

Third-Party Software

Beyond Compare has been created with the help of a number of open source libraries. Source code is available on their respective websites, and any customizations by Scooter Software can be requested by emailing us at: support@scootersoftware.com

License Agreement | Website
7-zip | www.7-zip.org
Abbrevia | tpabbrevia.sourceforge.net
ChsDet | chsdet.sourceforge.net
dspack | code.google.com/p/dspack
FastcodePatch | fastcode.sourceforge.net
FastMM4 | www.sourceforge.net/projects/fastmm
Free Pascal | www.freepascal.org
GnuWin32 (patch.exe) | gnuwin32.sourceforge.net
GraphicEx | www.delphi-gems.com/index.php/libs/graphicex-library
HtmlViewer | code.google.com/p/thtmlviewer
HTTPGet | www.utilmind.com
Indy | indyproject.org/index.en.aspx
Inno Setup | jrsoftware.org/isinfo.php
IntLck64 | cc.embarcadero.com/Item/22917
Jedi Code Library | jcl.sourceforge.net
Lazarus | lazarus.freepascal.org
LetsMove | github.com/potionfactory/LetsMove
PCRE | www.pcre.org
PerlRegEx | www.regular-expressions.info/delphi.html
RegExpr | regexpstudio.com
TextDiff | www.angusj.com/delphi/textdiff.html
WavPack | wavpack.com
WiX | wixtoolset.org
Xpdf (PdfToText.exe) | www.foolabs.com/xpdf/home.html
ZLib | www.zlib.org www.base2ti.com

Beyond Compare was also created with these commercial libraries and applications:

Software | Website
cMicroThreads | www.eternallines.com/microthreads/index.html
Delphi | www.embarcadero.com
FinalBuilder | www.finalbuilder.com
madExcept | www.madshi.net
Plasmatech Shell Control Pack | www.plasmatech.com
SecureBlackBox | www.eldos.com
SMWord | www.scalabium.com
TMS FlexCel | www.tmssoftware.com
Toolbar 2000 | jrsoftware.org/tb2k.php
ZipForge | www.componentace.com


3-way Merge Concepts

A merge session helps you combine separate sets of changes into a new version of the data, accommodating both sets of changes.

Consider first a simple 2-sided comparison, where an item is on one side and not the other. The software can't tell if the item was newly added on one side, or if its pair was deleted from the other side:

However, when there is an older copy of the data available there is more information to base merge decisions on. For example, to decide whether an item was added on one side or deleted on the other, we can refer to an older copy of the data:

In this situation, the program can help you quickly and accurately combine independent modifications. This is called a 3-way merge.

However, not all changes can be safely merged without careful review. If the same line has been independently changed on both sides (and the changes are different from each other) the line will be flagged as a conflict requiring manual review.


Clipboard Compare Options

These options control the behavior of Clipboard Compare.

Run on Windows startup

Automatically runs Clipboard Compare when Windows starts.

Enable keyboard shortcut

Enables the Ctrl+Alt+C keyboard shortcut for comparing the two most recent clipboard entries.

Associated file format mask

Sets a simple file mask, such as *.java, to be used to select an appropriate file format for text comparisons. If it is left empty, the default file format will be used.

Minimum clip length

Sets the minimum number of characters the text must contain to be remembered. Can be used to prevent saving passwords or other short text. Set to 0 to remember all copies.

Storage limits (clips)

Sets the maximum number of entries to be retained.

Storage limits (MB)

Sets the maximum amount of memory to be used for all entries.

Note Clipboard Compare will try to retain the two most recent clipboard entries, even if the memory usage limit will be exceeded.


Display Filters

Display filters limit the view to certain comparison results. For example, you can pick Show Differences [image] to hide all the matching files so that you can concentrate on the mismatches. The current display filter choice will be saved whenever you leave a session, unless that session is locked.

Most of the session types have some sort of display filter implementation. The examples below are from a Folder Compare session.

Right-click on the toolbar to pick one of three built-in ways to show display filters on the toolbar: DropDown, Favorites or Toggles. Or, pick Toolbar Options to create your own custom layout.

DropDown layout

DropDown is the default style for the toolbar, designed for simplicity and to save space on the toolbar.

The buttons represent Show All [image], Show Differences [image] and Show Same [image]. The dropdown on the middle button lets you pick a different combination display filter.

Favorites layout

The Favorites style includes various filter combinations on the toolbar.

Toggles layout

Toggles represent the individual comparison states.

Pick this mode when you want combinations that are not available with the other display filters. For example, the Toggles shown above will display Left Orphans and Right Newer, and nothing else.


Selecting a Remote Registry

If the remote computer you want to connect with does not appear in the list, you may need to do the following:

Turn on network discovery and file sharing

1.In Windows Control Panel, pick Network and Internet > Network and Sharing Center > Advanced sharing settings.

2.Pick Turn on network discovery and Turn on file and printer sharing.

3.Click Save changes.

Enable the Remote Registry service

1.In Windows Computer Management, pick Services and Applications > Services.

2.In the services list, double-click on Remote Registry.

3.Click Start and wait for the status to update.

4.Change the Startup type to Automatic.

5.Click OK.

Allow connections through Windows Firewall

1.In Windows Control Panel, pick System and Security > Windows Firewall >Allowed Programs.

2.In the allowed programs list, check Windows Remote Management.

3.Click OK.


Editing a Column Definition

The Column Handling dialog allows you to set options for each comparison column. A subset of this dialog is used to set default handling for all columns.

Specify the Name to be displayed in the header of the comparison column. If none is specified, an automatic one may be used.

Mark the Key checkbox to make data in this column control sorting and alignment. If you have more than one key column, the priority for sorting is granted to the top-most columns in the list.

Mark the Use Default checkbox to use the default column handling as defined for this session.

Pick the appropriate Type for the column:

Detected | Automatically determine the column type based on the data in the files.
Boolean | Column values are either "True" or "False", or numeric. Zero is equivalent to False and any non-zero value is True.
Date | Column contains date-time values in any common format. The comparison ignores differences in formatting.
Numeric | Column values are interpreted as real number values. The comparison ignores differences in formatting. For example, 0.00 and 0 are considered the same.
Text | Column contains textual data.

Mark the Unimportant checkbox to indicate that this column is not important to the comparison. (Unimportant differences are colored blue instead of red, or are ignored altogether using the Ignore Unimportant Differences [image] feature.)

Use Date tolerance to allow date-time values in this column to differ by the given amount before being considered an important difference.

Set the Numeric tolerance value to allow numbers to differ by the given amount before being considered an important difference.

The Text important, except for options govern columns that are defined or detected as Text. Mark the Character case (ABC = abc) checkbox if differences in case (i.e., capitalization) are unimportant. Mark the Whitespace checkbox to consider differences in whitespace (the number of blanks before, after or between words) unimportant.


Editing an Alignment Override

Fill in the Align left file (or folder) and with right file (or folder) edits.

Mark the Regular expression checkbox to interpret them as replacement-style regular expressions. If you used DOS wildcards like * and ?, leave it unmarked.

Fill in the Limit to this folder edit to specify a relative path for the alignment.

Examples

Align left file (or folder) | with right file (or folder) | Description
x.txt | x.csv | Lines up "x.txt" with "x.csv".
*.gif | *.png | Lines up all GIF files with PNG files of the same name.
x*.jpg | y*.jpg | Lines up files such as "x1.jpg" with "y1.jpg" and "x2.jpg" with "y2.jpg".


Finding Filenames

Search > Find Filename

To locate a specific file in a folder view, pick Search > Find Filename [image].

Text to find

Enter the text to search for.

Match character case

Match only text with the same uppercase and lowercase characters.

Whole words only

Match on the whole words but not parts of words.

Regular expression

Indicates the search string is a PCRE regular expression. Click on the Insert Regular Expression Element [image] button to pick from a list of common regular expression terms. Click the RE Examples button for more info.

Wrap search

When one end of the file is reached, continue searching at the other end.

Search up

Searches backwards, towards the top of the comparison.

Sides

Specify the side(s) of the comparison to search.

Use the Search menu's Find Next Filename [image] and Find Previous Filename [image] commands for finding additional occurrences of the search string.


Editing an Other Filter Item

To filter by date

1.Pick Older than or Newer than.

2.If the Day(s) ago checkbox is marked, this filter will be the number of whole days relative to 12:00AM on the date when the comparison is run. If it is disabled, this filter will use an absolute date and time.

To filter by size

1.Pick Smaller than or Larger than.

2.Specify the size in bytes, KB, MB, or GB.

To filter by text content

1.Pick Not containing or Containing.

2.Define the search.

To filter by DOS attributes

1.Pick If DOS attribute.

2.Pick the attribute. Pick Is set if you want to exclude files that have this attribute. Otherwise, pick Is not set.

To filter by source control status

1.Pick If source control status.

2.Pick the status. Pick Is set if you want to exclude files that have this status. Otherwise, pick Is not set.


Exporting Settings

Tools > Export Settings

You can selectively save your program settings, in order to transfer them to another computer, upgrade to a newer version, or share them with another Beyond Compare user.

To export your settings

1.Pick Tools > Export Settings.

2.Pick the types of settings you wish to export:

Program Options include most of your preferences set in the Options dialog.

Colors, Fonts include all of your preferences set on its page of the Options dialog.

Toolbars, Shortcuts, Menus include your preferences set on its page of the Options dialog.

Program State includes things like window positions and MRU lists.

Sessions include some or all of your named sessions.

File Formats include some or all of your customized file formats.

Profiles include some or all of your named profiles, containing settings for FTP, etc.

System Info includes information about your computer and your Beyond Compare installation. It is useful for support purposes, to help us debug problems.

3.If you are exporting sessions, file formats, or profiles, click Next to pick the specific named items to be included.

4.Click Finish to export the settings. A settings package (.bcpkg) will be created.


Importing Settings

Tools > Import Settings

You can import settings that were previously exported from Beyond Compare, even an older version like Beyond Compare 2.

To import settings

1.Pick Tools > Import Settings.

2.Pick the file containing the settings to import. It can be a Beyond Compare settings package (.bcpkg) or XML file. It can also be a Beyond Compare 2 export file (zip or XML file).

3.If the file contains different kinds of settings, mark the checkboxes for the types of settings you wish to import:

Program Options include most of your preferences set in the Options dialog.

Colors, Fonts include all of your preferences set on its page of the Options dialog.

Toolbars, Shortcuts, Menus include your preferences set on its page of the Options dialog.

Program State includes things like window positions and MRU lists.

Sessions include some or all of your named sessions.

File Formats include some or all of your customized file formats.

Profiles include some or all of your named profiles, containing settings for FTP, etc.

4.If you are importing sessions, file formats, or profiles, click Next to pick the specific named items to be included.

Warning An item is colored red if its name is the same as one in your stored settings. If you import a red item, it will replace your existing session, file format, or profile!

Mark the Delete all existing sessions checkbox to erase all of your stored sessions before importing those in the file. Likewise, mark the Delete all existing file formats or Delete all existing profiles checkboxes if you wish.

5.Click Finish to import the settings.


How to Register

Step 1 - Try It

You can use the program free for 30 days to see if it suits your needs. If you use it beyond 30 days you are obliged to pay the license fee. Please read the License Agreement for details. If you do not obtain a license key for the program, it will stop functioning after 30 days of use (rather than 30 days from installation).

Step 2 - Buy It

The single user license fee for the Standard Edition is US$30, and US$60 for the Pro Edition. We have discounted pricing for multi-user site licenses. For complete instructions and links for on-line ordering, please visit our web site at:

www.scootersoftware.com

Step 3 - Unlock It

Once we receive your order, we email you back with your license key that unlocks the program. When you receive your license key, copy it from the email message to the clipboard. Then start up your copy of Beyond Compare and pick Enter Key from the popup window that first appears, or, pick Help > Enter Key.

The license key disables the "nag" screen and removes the 30 day limitation. Your license key will work with all language versions of Beyond Compare 4, as well as all subsequent minor version updates.


Editing an Open With Item

Enter a name in the Description edit to appear on the Open With menu.

To define a keyboard shortcut for the application, focus on the Shortcut edit and press the desired keystroke. Click the Remove button to remove an assigned shortcut.

Enter a suitable Command line specification for launching the application. It can include command line switches appropriate to that application. The following variables will be replaced with the indicated information:

%f | Absolute path and filename
%l | (lowercase L) Current line number in file view
%n | Filename only
%p | Absolute path
%x | Extension (includes ".")
%b | Filename without extension
%F | Path and filename relative to the working folder
%P | Path relative to the working folder

"1" and "2" can be appended to the end of variables to refer to the left/first or right/second file (e.g. "BCompare %F2 %F1"). In all cases except for a second %f or %l (for backwards compatibility), leaving a number off will refer to the first file no matter how many times it's listed on the command line.

The Working folder edit allows you to change where the program executes (the "Start in" folder). If it is blank, the program is executed in the same working folder as Beyond Compare. You can specify a specific folder, or pick the special values <parent folder> and <base folder> from the dropdown list. <parent folder> will use the selected file's parent folder, while <base folder> will use the base folder of the selected side (or the parent folder in a file view).

Use the Path delimiter edit to replace all path delimiters with the given string. If left blank, the normal delimiters will be used (e.g. backslash (\) under Windows).

The Accepts files and Accepts folders checkboxes control whether the application should be available for files, folders, or both. Tip: You can configure Beyond Compare itself as an additional application for folders. That way, you can select folders and compare them in another instance of Beyond Compare.

Refresh when finished performs a Fast Refresh when Beyond Compare is done processing the Open With list.

When the Multiple instances checkbox is marked, you can select multiple files or file pairs, and execute the operation on all of them once per file or pair of lined up files. With this option, Beyond Compare checks to see if a second file would be given on the command line (e.g. "%x2"). If it is, the application will execute on pairs at a time, otherwise it will break the pair up and execute once for each selected item in the pair.

Wait for previous instance to finish makes Beyond Compare wait until the previous command finishes executing before running the next command.


Browsing Using Profiles

Session > Browse for Folder

In general, wherever folders can be used in Beyond Compare, profiles can be used as well.

In the Browse for Folder [image] dropdown, pick Browse Using Profile to open a dialog. You can pick Local File System to browse for a local folder. In the Quick Connect folder, you can pick FTP Profile or Subversion Profile, enter the necessary login information, and click the Connect & Browse button to browse for a remote folder. You can also pick a named profile to browse for a remote folder.


How to Unlock Beyond Compare

Help > Enter Key

Beyond Compare is distributed in evaluation mode, allowing you to see if it suits your needs. Unless you purchase a license, the program will stop running after 30 days of use.

When you purchase a license to Beyond Compare, we send you an unlock key by email. It looks something like this:

--- BEGIN LICENSE KEY ---

CUgJWTb0eQVybpezCYu9CSqDLCtvx6g63hp-hrKHXiNL144KP4FTWHl9I

q4+F5RWwcpzSyX98tlDzSsJm5xvnjuvunNrAG16sjP8Dp4as1gP3M1Pkj

dmDVZXXLlyHoIrMd-Ptl0wpWPU654xu8kc7iYPl5LhOfXJG64V12vJnOm

--- END LICENSE KEY -----

1.From your email program, select the key and copy it to the clipboard. It's ok if you include some of the message before and after the key, but be sure to include the entire key.

2.Then, run Beyond Compare and pick the Enter Key option. (Click the Enter Key button on any of the "Evaluation" dialogs, or pick Help > Enter Key.)

3.In the "Register Beyond Compare" dialog, your key should automatically appear in the text box. If not, try copying and pasting again.

Unless you are running a portable install of Beyond Compare, you can mark the Register for all users checkbox to store the license key in the program folder, so that all users on this computer will be registered.


Restoring Factory Defaults

Tools > Restore Factory Defaults

You can restore settings to their factory defaults.

To restore settings

1.Pick Tools > Restore Factory Defaults.

2.Mark the checkboxes for the types of settings you wish to restore:

Program Options include most of your preferences set in the Options dialog.

Colors, Fonts include all of your preferences set on its page of the Options dialog.

Toolbars, Shortcuts, Menus include your preferences set on its page of the Options dialog.

Program State includes things like window positions and MRU lists.

Sessions include some or all of your named sessions.

File Formats include some or all of your customized file formats.

Profiles include some or all of your named profiles, containing settings for FTP, etc.

3.If you are restoring sessions, file formats, or profiles, click Next to pick the specific named items to be included.

Mark the Delete all existing sessions checkbox to erase all of your stored sessions. Likewise, mark the Delete all existing file formats or Delete all existing profiles checkboxes if you wish.

4.Click Finish to restore the settings.


Saving Snapshots

Tools > Save Snapshot

To save a snapshot

1.Pick Tools > Save Snapshot [image].

2.Enter the path of the folder tree to be saved. If you are currently in a folder view, you will also have the option of picking its Left base folder or Right base folder.

3.Mark the appropriate checkboxes to also include CRCs computed from each file's contents, version data, or expanded archive file contents. These options will make it take longer to create the snapshot, but the results will be more thorough.

CRCs Includes CRC32 calculations in the snapshot.

Exe versions Includes file version, typically found in application files such as .exe, .dll, .ocx, etc.

Archive contents Includes expanded listing of archive file contents in the snapshot.

4.Mark the Empty folders checkbox to include empty folders, or folders whose entire contents have been filtered out.

5.Mark the Symbolic link targets checkbox to include files and folders pointed to by symbolic links.

6.If you are currently in a folder view, you will also have the option to include the Items excluded by file filters. If this checkbox is unmarked, the snapshot will use the folder session's file filters.

7.Click OK and a dialog will prompt for the filename and location to save the snapshot to.


Reporting Problems

Help > Support

If you have found a problem with Beyond Compare, we would like to hear from you!

From any top-level window, pick Help > Support, and follow the instructions to produce a package containing your program and system settings. Attach the settings package to an email including a description of the problem and send it to us at support@scootersoftware.com.

You may want to include a screenshot that illustrates the problem. If you do, follow these steps to make one small enough to email:

1.Press Alt+PrintScreen to place a snapshot of the current window on the clipboard.

2.Open the Microsoft Paint program (Start > Programs > Accessories > Paint) and press Ctrl+V to paste the image.

3.Select the part of the image that you would like to send.

4.Pick Edit > Copy To, change Save as Type to PNG (*.png) or GIF (*.gif), and enter a filename. (If PNG and GIF types are not available, select 256 Color Bitmap and compress the image file with a zip utility.)

5.Attach the image file to your email to us.


Finding Text in Files

Search > Find in Files

To locate specific text in multiple files, pick Search > Find in Files [image].

Text to find

Enter the text to search for.

Folder

Enter the name of the folder to search in.

File mask

Enter the mask of files to include in the search.

Match character case

Match only text with the same uppercase and lowercase characters.

Whole words only

Match on the whole words but not parts of words.

Regular expression

Indicates the search string is a PCRE regular expression. Click on the Insert Regular Expression Element [image] button to pick from a list of common regular expression terms. Click the RE Examples button for more info.

Search subfolders

Recursively searches folders within the main one.


Editing a Grammar Item

Pick an existing Element name from the dropdown list or enter your own new name.

To define a simple grammar element

Pick the Basic category. Enter a Text matching string and specify if the string should exactly Match character case and whether the string is a Regular expression.

For an element that is defined by delimiters

Pick the Delimited category. Specify starting and ending delimiters, or a starting delimiter and the Stop at end of line option. Specify if the delimiters should exactly Match character case and whether they are Regular expressions.

An Escape character can be specified that allows the ending delimiter character to be embedded in the element.

For example, the colored literal string in the following code is delimited by apostrophes ('), with backslash (\) as the escape character:

s = 'I can\'t see straight'

To define a list of grammar tokens

Pick the List category and type the tokens into the memo control. Specify if the tokens should exactly Match character case and whether they are Regular expressions.

To define an element as a column range

Pick the Columns category. Specify the starting and ending column numbers, or a starting column and the to end of line option.

To match on repeating page headings in your data

When comparing report output, a single change can shift all subsequent page headings, causing many additional differences. You can define a page heading grammar item in order to ignore these differences. Pick the Lines category. Enter a Text matching string that will match the heading at the top of each page in your data. Typically this would be the Form Feed character. Mark the or line 1 checkbox if the first page doesn't start with the Form Feed character. Specify the number of lines in the heading. Specify if the match string should exactly Match character case and whether the string is a Regular expression.

To define case-sensitivity

Mark the This element is case sensitive checkbox to indicate that changes in character case are important differences during comparison.


Editing a Text Replacement Item

Specify the Text to find and the Replace with text.

Mark the Match character case checkbox to only match on text with the same uppercase and lowercase characters.

Mark the Whole words only checkbox to prevent matching on parts of words.

Mark the Regular expression checkbox to interpret them as replacement-style regular expressions. Click on the Insert Regular Expression Element [image] button to pick from a list of common regular expression terms. Click the RE Examples button for more info.

Specify the Side of the editor pane that should be searched.


Managing Workspaces

Session > Load Workspace > Manage Workspaces

To save your current workspace configuration

1.Pick Session > Save Workspace As.

2.Enter a unique name or pick a saved workspace to be replaced from the dropdown list.

To reload a saved workspace

Pick Session > Load Workspace and pick a saved workspace from the submenu. This will close all current sessions and reopen the saved configuration.

To delete or rename saved workspaces

1.Pick Session > Load Workspace > Manage Workspaces.

2.Pick a saved workspace and press F2 to rename it, or DEL to delete it.

To automatically load or save workspaces

In the Manage Workspaces dialog, you can click the Shortcut edit and press a key combination to be used to quickly load the selected workspace from within Beyond Compare.

You can specify a workspace name in On startup, load and/or in On exit, save as. The Options dialog also has these options on its Startup page.

You can also load a workspace by specifying it on the command line.


File Masks

A file mask is a pattern of characters and wildcards used to match folder and file names.

Example: *.* would match any filename. For historical reasons, it even matches files that don't have an extension.

Example: *.html would match any HTML filename.

Wildcards

Wildcards allow a file mask to match multiple folder or file names.

? | Matches any single character.
* | Matches zero or any other amount of characters.
[az] | Matches any single character in the set (a or z).
[a-z] | Matches any single character in the range (from a to z).
[!az] | Matches any single character not in the set (not a and not z).
[[] | Matches a single [ character.

Example: A? would match A followed by any single character.

Example: A* would match A followed by any amount of characters.

Example: [a-z0-9] would match any number or letter.

Example: [!ac-g] would match any character except for a, c, d, e, f, and g.

Simple file masks

Simple file masks will affect any files or folders whose parent folder is included. The base folder is always included. All folders which contain included files are also included.

To exclude rather than include the specified items, add a minus sign (-) in front of a file mask in the Filters edit. In the File Filters dialog, place the file mask in the Exclude edit rather than using the minus sign.

If the last character in the file mask is a period (.) then ? and * wildcards do not match periods to allow filtering of files that don't have an extension.

f | Include any file named f.
p\ | Include any folder named p.
-f | Exclude any file named f.
-p\ | Exclude any folder named p.

Example: *.pas;*.dfm;*.dpr would include only files with extensions pas, dfm, or dpr.

Example: Source\ would include only folders named Source and their subfolders.

Example: -*.dcu;-*.ddp would exclude files with extensions dcu, or ddp.

Example: -Backup\ would exclude folders named Backup.

Example: *. would include only files without an extension.

Relative file masks

Relative file masks affect files or folders in specific locations.

p\f | f must be in folder p.
.\f | f must be in the base folder.
...\f | f may have zero or more parent folders.

Example: Windows\*.txt would affect any text file in any included folder named Windows.

Example: ...\Windows\*.txt would affect any text file in any folder named Windows.

Example: .\Windows\*.txt would affect any text file in a folder named Windows that is in the base folder.


License Agreement

Help > About Beyond Compare > License

Your use of Beyond Compare is governed by the following Terms and Conditions:

Acceptance of License Agreement

You should carefully read the following terms and conditions before using Beyond Compare 4 (the "Software"). Unless you have a different license agreement signed by Scooter Software, your use of this software indicates your agreement to these terms and conditions. If you do not accept all of these terms and conditions, you must cease using the Software immediately.

Copyright

Customer acknowledges that the Software, License Key and accompanying user documentation ("Documentation") are copyrighted works owned by Scooter Software and that Customer has no rights in the foregoing except as expressly granted herein.

Free 30-Day Trial

This is not free software. Scooter Software hereby grants you a non-exclusive, non-transferable, limited license to use the Software free of charge for a period of thirty (30) days. Use of the Software beyond the thirty-day (30-day) trial period requires the purchase of a License Key as described below. Use of the Software beyond the thirty-day (30-day) trial period without purchase of a License Key is a violation of U.S. and international copyright laws.

License Key

A unique key that will allow you to use the Software beyond the thirty-day (30-day) free trial period ("License Key") may be purchased from the Scooter Software website, which is currently http://www.scootersoftware.com. A License Key may be purchased for single or multiple users, all users at a named site, or an entire enterprise. A License Key is further categorized by feature set (Standard Edition or Pro Edition), and operating system platform (Windows Platform, Mac Platform, Linux Platform, or Multi Platform). A price list on the Scooter Software website details pricing for all license options. Upon purchase of a License Key, Scooter Software hereby grants you a non-exclusive, non-transferable license to use the Software with the applicable feature set on the applicable operating system platform as follows:

Per-User License Key: A Per-User License Key may be purchased for a specific quantity of users. Each user of the total quantity may be either (a) a person who has access to the Software on any number of computers, or (b) a computer on which the Software will be installed for use by any number of persons, one at a time, while physically present at the computer. Each person so licensed must be the Customer, an employee of the Customer, an employee of a Customer's subsidiary company, or a third party consultant retained by the Customer to perform information technology functions (each, a "Third Party") to use the Software solely for Customer's internal business operations and benefit, and for no other purpose whatsoever. Customer shall ensure that such Third Party complies with the terms of this License Agreement and will be responsible for any breach by such Third Party.

Site License Key: An unlimited user, single-location License Key may be used at Customer locations within a 100-mile radius of the site identified in the License Key (the "Site"), by any and all of Customer's employees while personally present at the Site. This license is likewise granted to Customer's employees who typically work at the Site, while performing Customer work at other locations such as client locations or home. Customer shall have the right to sublicense its rights under this License Agreement to third party consultants that it retains to perform information technology functions (each, an "Onsite Consultant"), while personally present at the Site to use the Software solely for Customer's internal business operations and benefit, and for no other purpose whatsoever. Customer shall ensure that such Onsite Consultant complies with the terms of this License Agreement and will be responsible for any breach by such Onsite Consultant.

Enterprise License Key: An enterprise-wide ("Enterprise") License Key may be used world-wide, by any and all of Customer's employees. Customer shall have the right to sublicense its rights under this License Agreement to third party consultants that it retains to perform information technology functions (each, an "Enterprise Consultant"), while personally present at any Customer location to use the Software solely for Customer's internal business operations and benefit, and for no other purpose whatsoever. Customer shall ensure that such Enterprise Consultant complies with the terms of this License Agreement and will be responsible for any breach by such Enterprise Consultant.

You shall be responsible for maintaining the License Key in a safe location and are specifically prohibited from distributing the License Key, intentionally or unintentionally, to any third party not authorized by this License Agreement. Upon loss or distribution of the License Key, Customer shall be required to pay a reinstatement fee at Scooter Software's discretion.

Distribution of the Software

Provided that you do not copy or distribute the License Key, and you include a copy of this License Agreement, you may (a) make copies of the Software; (b) give exact, unmodified copies of the Software to anyone; and (c) distribute the Software in its unmodified form via electronic means. You are specifically prohibited from charging any fees for any such copies or distributions.

Term and Termination

You may continue to use the Software for as long as you comply with the terms and conditions of this License Agreement. Scooter Software may terminate this License Agreement immediately upon notice to you in the event that Scooter Software has reason to believe you have breached this License Agreement. Upon termination, you shall immediately cease all use of the Software, License Key and Documentation and shall not be entitled to a refund of any fees paid.

Warranties

Scooter Software warrants and represents that: (a) it has all right, title and interest in the Software, the right to enter into and provide the license rights granted by this Agreement, and is not party to and will not enter into any agreement, covenant or encumbrance that conflicts with this Agreement; (b) the Software does not, to the best of Scooter Software’s knowledge, infringe upon or violate any patent, copyright, or trade secret or other proprietary right of any third party; (c) the advent of any date or year shall not adversely affect the performance of the Software; and (d) the Software is not contaminated by harmful code (e.g., self-propagating program instructions commonly called viruses, worms or Trojans).

General Disclaimer

Except for the limited warranties set forth herein, THE SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS". TO THE MAXIMUM EXTENT PERMITTED BY APPLICABLE LAW, SCOOTER SOFTWARE DISCLAIMS ALL WARRANTIES, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO IMPLIED WARRANTIES OF MERCHANTABILITY, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE. ANY LIABILITY OF SCOOTER SOFTWARE WILL BE LIMITED EXCLUSIVELY TO REFUND OF THE PURCHASE PRICE.

Miscellaneous Provisions

The validity and interpretation of this Agreement shall be governed by the laws of the United States of America and the State of Wisconsin. Customer agrees that the state and federal courts located in the State of Wisconsin, Dane County, shall be the appropriate site of venue for actions relating to this Agreement, and hereby consents to the exclusive jurisdiction and venue of such courts. If any provision of this Agreement is declared by a court of competent jurisdiction to be invalid, illegal or unenforceable, such provision or part thereof will be severed from the Agreement and the remaining provisions will remain in full force and effect.


License Agreement: 7-Zip

7-Zip

License for use and distribution

7-Zip Copyright (C) 1999-2010 Igor Pavlov.

Licenses for files are:

1) 7z.dll: GNU LGPL + unRAR restriction

2) All other files: GNU LGPL

The GNU LGPL + unRAR restriction means that you must follow both GNU LGPL rules and unRAR restriction rules.

Note:

You can use 7-Zip on any computer, including a computer in a commercial organization. You don't need to register or pay for 7-Zip.

GNU LGPL information

This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.

You can receive a copy of the GNU Lesser General Public License from http://www.gnu.org

unRAR restriction

The decompression engine for RAR archives was developed using source code of unRAR program.

All copyrights to original unRAR code are owned by Alexander Roshal.

The license for original unRAR code has the following restriction:

The unRAR sources cannot be used to re-create the RAR compression algorithm, which is proprietary. Distribution of modified unRAR sources in separate form or as a part of other software is permitted, provided that it is clearly stated in the documentation and source comments that the code may not be used to develop a RAR (WinRAR) compatible archiver.

Igor Pavlov


License Agreement: FPC

FPC LICENSE

This is the file COPYING.FPC, it applies to the Free Pascal Run-Time Library (RTL) and packages (packages) distributed by members of the Free Pascal Development Team and several units in the Lazarus sources distributed by members of the Lazarus Development Team.

These files are distributed under the Library GNU General Public License (see the file COPYING.LGPL) with the following modification:

As a special exception, the copyright holders of this library give you permission to link this library with independent modules to produce an executable, regardless of the license terms of these independent modules, and to copy and distribute the resulting executable under terms of your choice, provided that you also meet, for each linked independent module, the terms and conditions of the license of that module. An independent module is a module which is not derived from or based on this library. If you modify this library, you may extend this exception to your version of the library, but you are not obligated to do so. If you do not wish to do so, delete this exception statement from your version.

If you didn't receive a copy of the file COPYING.LGPL, contact:

Free Software Foundation, Inc.,

675 Mass Ave

Cambridge, MA 02139

USA


License Agreement: GPL3

GNU GENERAL PUBLIC LICENSE

Version 3, 29 June 2007

Copyright © 2007 Free Software Foundation, Inc. <http://fsf.org/>

Everyone is permitted to copy and distribute verbatim copies of this license document, but changing it is not allowed.

Preamble

The GNU General Public License is a free, copyleft license for software and other kinds of works.

The licenses for most software and other practical works are designed to take away your freedom to share and change the works. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change all versions of a program--to make sure it remains free software for all its users. We, the Free Software Foundation, use the GNU General Public License for most of our software; it applies also to any other work released this way by its authors. You can apply it to your programs, too.

When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for them if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs, and that you know you can do these things.

To protect your rights, we need to prevent others from denying you these rights or asking you to surrender the rights. Therefore, you have certain responsibilities if you distribute copies of the software, or if you modify it: responsibilities to respect the freedom of others.

For example, if you distribute copies of such a program, whether gratis or for a fee, you must pass on to the recipients the same freedoms that you received. You must make sure that they, too, receive or can get the source code. And you must show them these terms so they know their rights.

Developers that use the GNU GPL protect your rights with two steps: (1) assert copyright on the software, and (2) offer you this License giving you legal permission to copy, distribute and/or modify it.

For the developers' and authors' protection, the GPL clearly explains that there is no warranty for this free software. For both users' and authors' sake, the GPL requires that modified versions be marked as changed, so that their problems will not be attributed erroneously to authors of previous versions.

Some devices are designed to deny users access to install or run modified versions of the software inside them, although the manufacturer can do so. This is fundamentally incompatible with the aim of protecting users' freedom to change the software. The systematic pattern of such abuse occurs in the area of products for individuals to use, which is precisely where it is most unacceptable. Therefore, we have designed this version of the GPL to prohibit the practice for those products. If such problems arise substantially in other domains, we stand ready to extend this provision to those domains in future versions of the GPL, as needed to protect the freedom of users.

Finally, every program is threatened constantly by software patents. States should not allow patents to restrict development and use of software on general-purpose computers, but in those that do, we wish to avoid the special danger that patents applied to a free program could make it effectively proprietary. To prevent this, the GPL assures that patents cannot be used to render the program non-free.

The precise terms and conditions for copying, distribution and modification follow.

TERMS AND CONDITIONS

0. Definitions.

"This License" refers to version 3 of the GNU General Public License.

"Copyright" also means copyright-like laws that apply to other kinds of works, such as semiconductor masks.

"The Program" refers to any copyrightable work licensed under this License. Each licensee is addressed as "you". "Licensees" and "recipients" may be individuals or organizations.

To "modify" a work means to copy from or adapt all or part of the work in a fashion requiring copyright permission, other than the making of an exact copy. The resulting work is called a "modified version" of the earlier work or a work "based on" the earlier work.

A "covered work" means either the unmodified Program or a work based on the Program.

To "propagate" a work means to do anything with it that, without permission, would make you directly or secondarily liable for infringement under applicable copyright law, except executing it on a computer or modifying a private copy. Propagation includes copying, distribution (with or without modification), making available to the public, and in some countries other activities as well.

To "convey" a work means any kind of propagation that enables other parties to make or receive copies. Mere interaction with a user through a computer network, with no transfer of a copy, is not conveying.

An interactive user interface displays "Appropriate Legal Notices" to the extent that it includes a convenient and prominently visible feature that (1) displays an appropriate copyright notice, and (2) tells the user that there is no warranty for the work (except to the extent that warranties are provided), that licensees may convey the work under this License, and how to view a copy of this License. If the interface presents a list of user commands or options, such as a menu, a prominent item in the list meets this criterion.

1. Source Code.

The "source code" for a work means the preferred form of the work for making modifications to it. "Object code" means any non-source form of a work.

A "Standard Interface" means an interface that either is an official standard defined by a recognized standards body, or, in the case of interfaces specified for a particular programming language, one that is widely used among developers working in that language.

The "System Libraries" of an executable work include anything, other than the work as a whole, that (a) is included in the normal form of packaging a Major Component, but which is not part of that Major Component, and (b) serves only to enable use of the work with that Major Component, or to implement a Standard Interface for which an implementation is available to the public in source code form. A "Major Component", in this context, means a major essential component (kernel, window system, and so on) of the specific operating system (if any) on which the executable work runs, or a compiler used to produce the work, or an object code interpreter used to run it.

The "Corresponding Source" for a work in object code form means all the source code needed to generate, install, and (for an executable work) run the object code and to modify the work, including scripts to control those activities. However, it does not include the work's System Libraries, or general-purpose tools or generally available free programs which are used unmodified in performing those activities but which are not part of the work. For example, Corresponding Source includes interface definition files associated with source files for the work, and the source code for shared libraries and dynamically linked subprograms that the work is specifically designed to require, such as by intimate data communication or control flow between those subprograms and other parts of the work.

The Corresponding Source need not include anything that users can regenerate automatically from other parts of the Corresponding Source.

The Corresponding Source for a work in source code form is that same work.

2. Basic Permissions.

All rights granted under this License are granted for the term of copyright on the Program, and are irrevocable provided the stated conditions are met. This License explicitly affirms your unlimited permission to run the unmodified Program. The output from running a covered work is covered by this License only if the output, given its content, constitutes a covered work. This License acknowledges your rights of fair use or other equivalent, as provided by copyright law.

You may make, run and propagate covered works that you do not convey, without conditions so long as your license otherwise remains in force. You may convey covered works to others for the sole purpose of having them make modifications exclusively for you, or provide you with facilities for running those works, provided that you comply with the terms of this License in conveying all material for which you do not control copyright. Those thus making or running the covered works for you must do so exclusively on your behalf, under your direction and control, on terms that prohibit them from making any copies of your copyrighted material outside their relationship with you.

Conveying under any other circumstances is permitted solely under the conditions stated below. Sublicensing is not allowed; section 10 makes it unnecessary.

3. Protecting Users' Legal Rights From Anti-Circumvention Law.

No covered work shall be deemed part of an effective technological measure under any applicable law fulfilling obligations under article 11 of the WIPO copyright treaty adopted on 20 December 1996, or similar laws prohibiting or restricting circumvention of such measures.

When you convey a covered work, you waive any legal power to forbid circumvention of technological measures to the extent such circumvention is effected by exercising rights under this License with respect to the covered work, and you disclaim any intention to limit operation or modification of the work as a means of enforcing, against the work's users, your or third parties' legal rights to forbid circumvention of technological measures.

4. Conveying Verbatim Copies.

You may convey verbatim copies of the Program's source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice; keep intact all notices stating that this License and any non-permissive terms added in accord with section 7 apply to the code; keep intact all notices of the absence of any warranty; and give all recipients a copy of this License along with the Program.

You may charge any price or no price for each copy that you convey, and you may offer support or warranty protection for a fee.

5. Conveying Modified Source Versions.

You may convey a work based on the Program, or the modifications to produce it from the Program, in the form of source code under the terms of section 4, provided that you also meet all of these conditions:

a) The work must carry prominent notices stating that you modified it, and giving a relevant date.

b) The work must carry prominent notices stating that it is released under this License and any conditions added under section 7. This requirement modifies the requirement in section 4 to "keep intact all notices".

c) You must license the entire work, as a whole, under this License to anyone who comes into possession of a copy. This License will therefore apply, along with any applicable section 7 additional terms, to the whole of the work, and all its parts, regardless of how they are packaged. This License gives no permission to license the work in any other way, but it does not invalidate such permission if you have separately received it.

d) If the work has interactive user interfaces, each must display Appropriate Legal Notices; however, if the Program has interactive interfaces that do not display Appropriate Legal Notices, your work need not make them do so.

A compilation of a covered work with other separate and independent works, which are not by their nature extensions of the covered work, and which are not combined with it such as to form a larger program, in or on a volume of a storage or distribution medium, is called an "aggregate" if the compilation and its resulting copyright are not used to limit the access or legal rights of the compilation's users beyond what the individual works permit. Inclusion of a covered work in an aggregate does not cause this License to apply to the other parts of the aggregate.

6. Conveying Non-Source Forms.

You may convey a covered work in object code form under the terms of sections 4 and 5, provided that you also convey the machine-readable Corresponding Source under the terms of this License, in one of these ways:

a) Convey the object code in, or embodied in, a physical product (including a physical distribution medium), accompanied by the Corresponding Source fixed on a durable physical medium customarily used for software interchange.

b) Convey the object code in, or embodied in, a physical product (including a physical distribution medium), accompanied by a written offer, valid for at least three years and valid for as long as you offer spare parts or customer support for that product model, to give anyone who possesses the object code either (1) a copy of the Corresponding Source for all the software in the product that is covered by this License, on a durable physical medium customarily used for software interchange, for a price no more than your reasonable cost of physically performing this conveying of source, or (2) access to copy the Corresponding Source from a network server at no charge.

c) Convey individual copies of the object code with a copy of the written offer to provide the Corresponding Source. This alternative is allowed only occasionally and noncommercially, and only if you received the object code with such an offer, in accord with subsection 6b.

d) Convey the object code by offering access from a designated place (gratis or for a charge), and offer equivalent access to the Corresponding Source in the same way through the same place at no further charge. You need not require recipients to copy the Corresponding Source along with the object code. If the place to copy the object code is a network server, the Corresponding Source may be on a different server (operated by you or a third party) that supports equivalent copying facilities, provided you maintain clear directions next to the object code saying where to find the Corresponding Source. Regardless of what server hosts the Corresponding Source, you remain obligated to ensure that it is available for as long as needed to satisfy these requirements.

e) Convey the object code using peer-to-peer transmission, provided you inform other peers where the object code and Corresponding Source of the work are being offered to the general public at no charge under subsection 6d.

A separable portion of the object code, whose source code is excluded from the Corresponding Source as a System Library, need not be included in conveying the object code work.

A "User Product" is either (1) a "consumer product", which means any tangible personal property which is normally used for personal, family, or household purposes, or (2) anything designed or sold for incorporation into a dwelling. In determining whether a product is a consumer product, doubtful cases shall be resolved in favor of coverage. For a particular product received by a particular user, "normally used" refers to a typical or common use of that class of product, regardless of the status of the particular user or of the way in which the particular user actually uses, or expects or is expected to use, the product. A product is a consumer product regardless of whether the product has substantial commercial, industrial or non-consumer uses, unless such uses represent the only significant mode of use of the product.

"Installation Information" for a User Product means any methods, procedures, authorization keys, or other information required to install and execute modified versions of a covered work in that User Product from a modified version of its Corresponding Source. The information must suffice to ensure that the continued functioning of the modified object code is in no case prevented or interfered with solely because modification has been made.

If you convey an object code work under this section in, or with, or specifically for use in, a User Product, and the conveying occurs as part of a transaction in which the right of possession and use of the User Product is transferred to the recipient in perpetuity or for a fixed term (regardless of how the transaction is characterized), the Corresponding Source conveyed under this section must be accompanied by the Installation Information. But this requirement does not apply if neither you nor any third party retains the ability to install modified object code on the User Product (for example, the work has been installed in ROM).

The requirement to provide Installation Information does not include a requirement to continue to provide support service, warranty, or updates for a work that has been modified or installed by the recipient, or for the User Product in which it has been modified or installed. Access to a network may be denied when the modification itself materially and adversely affects the operation of the network or violates the rules and protocols for communication across the network.

Corresponding Source conveyed, and Installation Information provided, in accord with this section must be in a format that is publicly documented (and with an implementation available to the public in source code form), and must require no special password or key for unpacking, reading or copying.

7. Additional Terms.

"Additional permissions" are terms that supplement the terms of this License by making exceptions from one or more of its conditions. Additional permissions that are applicable to the entire Program shall be treated as though they were included in this License, to the extent that they are valid under applicable law. If additional permissions apply only to part of the Program, that part may be used separately under those permissions, but the entire Program remains governed by this License without regard to the additional permissions.

When you convey a copy of a covered work, you may at your option remove any additional permissions from that copy, or from any part of it. (Additional permissions may be written to require their own removal in certain cases when you modify the work.) You may place additional permissions on material, added by you to a covered work, for which you have or can give appropriate copyright permission.

Notwithstanding any other provision of this License, for material you add to a covered work, you may (if authorized by the copyright holders of that material) supplement the terms of this License with terms:

a) Disclaiming warranty or limiting liability differently from the terms of sections 15 and 16 of this License; or

b) Requiring preservation of specified reasonable legal notices or author attributions in that material or in the Appropriate Legal Notices displayed by works containing it; or

c) Prohibiting misrepresentation of the origin of that material, or requiring that modified versions of such material be marked in reasonable ways as different from the original version; or

d) Limiting the use for publicity purposes of names of licensors or authors of the material; or

e) Declining to grant rights under trademark law for use of some trade names, trademarks, or service marks; or

f) Requiring indemnification of licensors and authors of that material by anyone who conveys the material (or modified versions of it) with contractual assumptions of liability to the recipient, for any liability that these contractual assumptions directly impose on those licensors and authors.

All other non-permissive additional terms are considered "further restrictions" within the meaning of section 10. If the Program as you received it, or any part of it, contains a notice stating that it is governed by this License along with a term that is a further restriction, you may remove that term. If a license document contains a further restriction but permits relicensing or conveying under this License, you may add to a covered work material governed by the terms of that license document, provided that the further restriction does not survive such relicensing or conveying.

If you add terms to a covered work in accord with this section, you must place, in the relevant source files, a statement of the additional terms that apply to those files, or a notice indicating where to find the applicable terms.

Additional terms, permissive or non-permissive, may be stated in the form of a separately written license, or stated as exceptions; the above requirements apply either way.

8. Termination.

You may not propagate or modify a covered work except as expressly provided under this License. Any attempt otherwise to propagate or modify it is void, and will automatically terminate your rights under this License (including any patent licenses granted under the third paragraph of section 11).

However, if you cease all violation of this License, then your license from a particular copyright holder is reinstated (a) provisionally, unless and until the copyright holder explicitly and finally terminates your license, and (b) permanently, if the copyright holder fails to notify you of the violation by some reasonable means prior to 60 days after the cessation.

Moreover, your license from a particular copyright holder is reinstated permanently if the copyright holder notifies you of the violation by some reasonable means, this is the first time you have received notice of violation of this License (for any work) from that copyright holder, and you cure the violation prior to 30 days after your receipt of the notice.

Termination of your rights under this section does not terminate the licenses of parties who have received copies or rights from you under this License. If your rights have been terminated and not permanently reinstated, you do not qualify to receive new licenses for the same material under section 10.

9. Acceptance Not Required for Having Copies.

You are not required to accept this License in order to receive or run a copy of the Program. Ancillary propagation of a covered work occurring solely as a consequence of using peer-to-peer transmission to receive a copy likewise does not require acceptance. However, nothing other than this License grants you permission to propagate or modify any covered work. These actions infringe copyright if you do not accept this License. Therefore, by modifying or propagating a covered work, you indicate your acceptance of this License to do so.

10. Automatic Licensing of Downstream Recipients.

Each time you convey a covered work, the recipient automatically receives a license from the original licensors, to run, modify and propagate that work, subject to this License. You are not responsible for enforcing compliance by third parties with this License.

An "entity transaction" is a transaction transferring control of an organization, or substantially all assets of one, or subdividing an organization, or merging organizations. If propagation of a covered work results from an entity transaction, each party to that transaction who receives a copy of the work also receives whatever licenses to the work the party's predecessor in interest had or could give under the previous paragraph, plus a right to possession of the Corresponding Source of the work from the predecessor in interest, if the predecessor has it or can get it with reasonable efforts.

You may not impose any further restrictions on the exercise of the rights granted or affirmed under this License. For example, you may not impose a license fee, royalty, or other charge for exercise of rights granted under this License, and you may not initiate litigation (including a cross-claim or counterclaim in a lawsuit) alleging that any patent claim is infringed by making, using, selling, offering for sale, or importing the Program or any portion of it.

11. Patents.

A "contributor" is a copyright holder who authorizes use under this License of the Program or a work on which the Program is based. The work thus licensed is called the contributor's "contributor version".

A contributor's "essential patent claims" are all patent claims owned or controlled by the contributor, whether already acquired or hereafter acquired, that would be infringed by some manner, permitted by this License, of making, using, or selling its contributor version, but do not include claims that would be infringed only as a consequence of further modification of the contributor version. For purposes of this definition, "control" includes the right to grant patent sublicenses in a manner consistent with the requirements of this License.

Each contributor grants you a non-exclusive, worldwide, royalty-free patent license under the contributor's essential patent claims, to make, use, sell, offer for sale, import and otherwise run, modify and propagate the contents of its contributor version.

In the following three paragraphs, a "patent license" is any express agreement or commitment, however denominated, not to enforce a patent (such as an express permission to practice a patent or covenant not to sue for patent infringement). To "grant" such a patent license to a party means to make such an agreement or commitment not to enforce a patent against the party.

If you convey a covered work, knowingly relying on a patent license, and the Corresponding Source of the work is not available for anyone to copy, free of charge and under the terms of this License, through a publicly available network server or other readily accessible means, then you must either (1) cause the Corresponding Source to be so available, or (2) arrange to deprive yourself of the benefit of the patent license for this particular work, or (3) arrange, in a manner consistent with the requirements of this License, to extend the patent license to downstream recipients. "Knowingly relying" means you have actual knowledge that, but for the patent license, your conveying the covered work in a country, or your recipient's use of the covered work in a country, would infringe one or more identifiable patents in that country that you have reason to believe are valid.

If, pursuant to or in connection with a single transaction or arrangement, you convey, or propagate by procuring conveyance of, a covered work, and grant a patent license to some of the parties receiving the covered work authorizing them to use, propagate, modify or convey a specific copy of the covered work, then the patent license you grant is automatically extended to all recipients of the covered work and works based on it.

A patent license is "discriminatory" if it does not include within the scope of its coverage, prohibits the exercise of, or is conditioned on the non-exercise of one or more of the rights that are specifically granted under this License. You may not convey a covered work if you are a party to an arrangement with a third party that is in the business of distributing software, under which you make payment to the third party based on the extent of your activity of conveying the work, and under which the third party grants, to any of the parties who would receive the covered work from you, a discriminatory patent license (a) in connection with copies of the covered work conveyed by you (or copies made from those copies), or (b) primarily for and in connection with specific products or compilations that contain the covered work, unless you entered into that arrangement, or that patent license was granted, prior to 28 March 2007.

Nothing in this License shall be construed as excluding or limiting any implied license or other defenses to infringement that may otherwise be available to you under applicable patent law.

12. No Surrender of Others' Freedom.

If conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot convey a covered work so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not convey it at all. For example, if you agree to terms that obligate you to collect a royalty for further conveying from those to whom you convey the Program, the only way you could satisfy both those terms and this License would be to refrain entirely from conveying the Program.

13. Use with the GNU Affero General Public License.

Notwithstanding any other provision of this License, you have permission to link or combine any covered work with a work licensed under version 3 of the GNU Affero General Public License into a single combined work, and to convey the resulting work. The terms of this License will continue to apply to the part which is the covered work, but the special requirements of the GNU Affero General Public License, section 13, concerning interaction through a network will apply to the combination as such.

14. Revised Versions of this License.

The Free Software Foundation may publish revised and/or new versions of the GNU General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.

Each version is given a distinguishing version number. If the Program specifies that a certain numbered version of the GNU General Public License "or any later version" applies to it, you have the option of following the terms and conditions either of that numbered version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of the GNU General Public License, you may choose any version ever published by the Free Software Foundation.

If the Program specifies that a proxy can decide which future versions of the GNU General Public License can be used, that proxy's public statement of acceptance of a version permanently authorizes you to choose that version for the Program.

Later license versions may give you additional or different permissions. However, no additional obligations are imposed on any author or copyright holder as a result of your choosing to follow a later version.

15. Disclaimer of Warranty.

THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

16. Limitation of Liability.

IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MODIFIES AND/OR CONVEYS THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.

17. Interpretation of Sections 15 and 16.

If the disclaimer of warranty and limitation of liability provided above cannot be given local legal effect according to their terms, reviewing courts shall apply local law that most closely approximates an absolute waiver of all civil liability in connection with the Program, unless a warranty or assumption of liability accompanies a copy of the Program in return for a fee.


License Agreement: HtmlViewer

HtmlViewer License

Copyright (c) 1995 - 2008 by L. David Baldwin

Copyright (c) 1995 - 2008 by Anders Melander (DitherUnit.pas)

Copyright (c) 1995 - 2008 by Ron Collins (HtmlGif1.pas)

Copyright (c) 2008 - 2009 by Sebastian Zierer (Delphi 2009 Port)

Copyright (c) 2008 - 2010 by Arvid Winkelsdorf (Fixes)

Copyright (c) 2009 - 2011 by Bernd Gabriel (Fixes, Enhancements)

Copyright (C) 2000 by R. Collins (TGif.pas)

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Note that the source modules, HTMLGIF1.PAS and DITHERUNIT.PAS are covered by separate copyright notices located in those modules.


License Agreement: HTTPGet

HTTPGet License

This software is provided 'as-is', without any express or implied warranty. In no event will the author be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial applications, and to alter it and redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented, you must not claim that you wrote the original software. If you use this software in a product, an acknowledgment in the product documentation would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source distribution.


License Agreement: InnoSetup

Inno Setup License

Except where otherwise noted, all of the documentation and software included in the Inno Setup package is copyrighted by Jordan Russell.

Copyright (C) 1997-2013 Jordan Russell. All rights reserved.

Portions Copyright (C) 2000-2013 Martijn Laan. All rights reserved.

This software is provided "as-is," without any express or implied warranty. In no event shall the author be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial applications, and to alter and redistribute it, provided that the following conditions are met:

1. All redistributions of source code files must retain all copyright notices that are currently in place, and this list of conditions without modification.

2. All redistributions in binary form must retain all occurrences of the above copyright notice and web site addresses that are currently in place (for example, in the About boxes).

3. The origin of this software must not be misrepresented; you must not claim that you wrote the original software. If you use this software to distribute a product, an acknowledgment in the product documentation would be appreciated but is not required.

4. Modified versions in source or binary form must be plainly marked as such, and must not be misrepresented as being the original software.

Jordan Russell

jr-2010 AT jrsoftware.org

http://www.jrsoftware.org/


License Agreement: IntLck64

IntLck64 License

Copyright (C) 2005 Will DeWitt Jr. <edge@icehouse.net>

This software is provided 'as-is', without any express or implied warranty. In no event will the authors be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial applications, and to alter it and redistribute it freely, subject to the following restrictions:

1. The origin of this software must not be misrepresented; you must not claim that you wrote the original software. If you use this software in a product, an acknowledgment in the product documentation would be appreciated but is not required.

2. Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.

3. This notice may not be removed or altered from any source distribution.

Thanks to Les Pawelczyk for a small tip that sped this up a bit.


License Agreement: LGPL

GNU LIBRARY GENERAL PUBLIC LICENSE

Version 2, June 1991

Copyright (C) 1991 Free Software Foundation, Inc.

51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA

Everyone is permitted to copy and distribute verbatim copies of this license document, but changing it is not allowed.

[This is the first released version of the library GPL. It is numbered 2 because it goes with version 2 of the ordinary GPL.]

Preamble

The licenses for most software are designed to take away your freedom to share and change it. By contrast, the GNU General Public Licenses are intended to guarantee your freedom to share and change free software--to make sure the software is free for all its users.

This license, the Library General Public License, applies to some specially designated Free Software Foundation software, and to any other libraries whose authors decide to use it. You can use it for your libraries, too.

When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for this service if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs; and that you know you can do these things.

To protect your rights, we need to make restrictions that forbid anyone to deny you these rights or to ask you to surrender the rights. These restrictions translate to certain responsibilities for you if you distribute copies of the library, or if you modify it.

For example, if you distribute copies of the library, whether gratis or for a fee, you must give the recipients all the rights that we gave you. You must make sure that they, too, receive or can get the source code. If you link a program with the library, you must provide complete object files to the recipients so that they can relink them with the library, after making changes to the library and recompiling it. And you must show them these terms so they know their rights.

Our method of protecting your rights has two steps: (1) copyright the library, and (2) offer you this license which gives you legal permission to copy, distribute and/or modify the library.

Also, for each distributor's protection, we want to make certain that everyone understands that there is no warranty for this free library. If the library is modified by someone else and passed on, we want its recipients to know that what they have is not the original version, so that any problems introduced by others will not reflect on the original authors' reputations.

Finally, any free program is threatened constantly by software patents. We wish to avoid the danger that companies distributing free software will individually obtain patent licenses, thus in effect transforming the program into proprietary software. To prevent this, we have made it clear that any patent must be licensed for everyone's free use or not licensed at all.

Most GNU software, including some libraries, is covered by the ordinary GNU General Public License, which was designed for utility programs. This license, the GNU Library General Public License, applies to certain designated libraries. This license is quite different from the ordinary one; be sure to read it in full, and don't assume that anything in it is the same as in the ordinary license.

The reason we have a separate public license for some libraries is that they blur the distinction we usually make between modifying or adding to a program and simply using it. Linking a program with a library, without changing the library, is in some sense simply using the library, and is analogous to running a utility program or application program. However, in a textual and legal sense, the linked executable is a combined work, a derivative of the original library, and the ordinary General Public License treats it as such.

Because of this blurred distinction, using the ordinary General Public License for libraries did not effectively promote software sharing, because most developers did not use the libraries. We concluded that weaker conditions might promote sharing better.

However, unrestricted linking of non-free programs would deprive the users of those programs of all benefit from the free status of the libraries themselves. This Library General Public License is intended to permit developers of non-free programs to use free libraries, while preserving your freedom as a user of such programs to change the free libraries that are incorporated in them. (We have not seen how to achieve this as regards changes in header files, but we have achieved it as regards changes in the actual functions of the Library.) The hope is that this will lead to faster development of free libraries.

The precise terms and conditions for copying, distribution and modification follow. Pay close attention to the difference between a "work based on the library" and a "work that uses the library". The former contains code derived from the library, while the latter only works together with the library.

Note that it is possible for a library to be covered by the ordinary General Public License rather than by this special one.

TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

0. This License Agreement applies to any software library which contains a notice placed by the copyright holder or other authorized party saying it may be distributed under the terms of this Library General Public License (also called "this License"). Each licensee is addressed as "you".

A "library" means a collection of software functions and/or data prepared so as to be conveniently linked with application programs (which use some of those functions and data) to form executables.

The "Library", below, refers to any such software library or work which has been distributed under these terms. A "work based on the Library" means either the Library or any derivative work under copyright law: that is to say, a work containing the Library or a portion of it, either verbatim or with modifications and/or translated straightforwardly into another language. (Hereinafter, translation is included without limitation in the term "modification".)

"Source code" for a work means the preferred form of the work for making modifications to it. For a library, complete source code means all the source code for all modules it contains, plus any associated interface definition files, plus the scripts used to control compilation and installation of the library.

Activities other than copying, distribution and modification are not covered by this License; they are outside its scope. The act of running a program using the Library is not restricted, and output from such a program is covered only if its contents constitute a work based on the Library (independent of the use of the Library in a tool for writing it). Whether that is true depends on what the Library does and what the program that uses the Library does.

1. You may copy and distribute verbatim copies of the Library's complete source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice and disclaimer of warranty; keep intact all the notices that refer to this License and to the absence of any warranty; and distribute a copy of this License along with the Library.

You may charge a fee for the physical act of transferring a copy, and you may at your option offer warranty protection in exchange for a fee.

2. You may modify your copy or copies of the Library or any portion of it, thus forming a work based on the Library, and copy and distribute such modifications or work under the terms of Section 1 above, provided that you also meet all of these conditions:

a) The modified work must itself be a software library.

b) You must cause the files modified to carry prominent notices stating that you changed the files and the date of any change.

c) You must cause the whole of the work to be licensed at no charge to all third parties under the terms of this License.

d) If a facility in the modified Library refers to a function or a table of data to be supplied by an application program that uses the facility, other than as an argument passed when the facility is invoked, then you must make a good faith effort to ensure that, in the event an application does not supply such function or table, the facility still operates, and performs whatever part of its purpose remains meaningful.

(For example, a function in a library to compute square roots has a purpose that is entirely well-defined independent of the application. Therefore, Subsection 2d requires that any application-supplied function or table used by this function must be optional: if the application does not supply it, the square root function must still compute square roots.)

These requirements apply to the modified work as a whole. If identifiable sections of that work are not derived from the Library, and can be reasonably considered independent and separate works in themselves, then this License, and its terms, do not apply to those sections when you distribute them as separate works. But when you distribute the same sections as part of a whole which is a work based on the Library, the distribution of the whole must be on the terms of this License, whose permissions for other licensees extend to the entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest your rights to work written entirely by you; rather, the intent is to exercise the right to control the distribution of derivative or collective works based on the Library.

In addition, mere aggregation of another work not based on the Library with the Library (or with a work based on the Library) on a volume of a storage or distribution medium does not bring the other work under the scope of this License.

3. You may opt to apply the terms of the ordinary GNU General Public License instead of this License to a given copy of the Library. To do this, you must alter all the notices that refer to this License, so that they refer to the ordinary GNU General Public License, version 2, instead of to this License. (If a newer version than version 2 of the ordinary GNU General Public License has appeared, then you can specify that version instead if you wish.) Do not make any other change in these notices.

Once this change is made in a given copy, it is irreversible for that copy, so the ordinary GNU General Public License applies to all subsequent copies and derivative works made from that copy.

This option is useful when you wish to copy part of the code of the Library into a program that is not a library.

4. You may copy and distribute the Library (or a portion or derivative of it, under Section 2) in object code or executable form under the terms of Sections 1 and 2 above provided that you accompany it with the complete corresponding machine-readable source code, which must be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange.

If distribution of object code is made by offering access to copy from a designated place, then offering equivalent access to copy the source code from the same place satisfies the requirement to distribute the source code, even though third parties are not compelled to copy the source along with the object code.

5. A program that contains no derivative of any portion of the Library, but is designed to work with the Library by being compiled or linked with it, is called a "work that uses the Library". Such a work, in isolation, is not a derivative work of the Library, and therefore falls outside the scope of this License.

However, linking a "work that uses the Library" with the Library creates an executable that is a derivative of the Library (because it contains portions of the Library), rather than a "work that uses the library". The executable is therefore covered by this License. Section 6 states terms for distribution of such executables.

When a "work that uses the Library" uses material from a header file that is part of the Library, the object code for the work may be a derivative work of the Library even though the source code is not. Whether this is true is especially significant if the work can be linked without the Library, or if the work is itself a library. The threshold for this to be true is not precisely defined by law.

If such an object file uses only numerical parameters, data structure layouts and accessors, and small macros and small inline functions (ten lines or less in length), then the use of the object file is unrestricted, regardless of whether it is legally a derivative work. (Executables containing this object code plus portions of the Library will still fall under Section 6.)

Otherwise, if the work is a derivative of the Library, you may distribute the object code for the work under the terms of Section 6. Any executables containing that work also fall under Section 6, whether or not they are linked directly with the Library itself.

6. As an exception to the Sections above, you may also compile or link a "work that uses the Library" with the Library to produce a work containing portions of the Library, and distribute that work under terms of your choice, provided that the terms permit modification of the work for the customer's own use and reverse engineering for debugging such modifications.

You must give prominent notice with each copy of the work that the Library is used in it and that the Library and its use are covered by this License. You must supply a copy of this License. If the work during execution displays copyright notices, you must include the copyright notice for the Library among them, as well as a reference directing the user to the copy of this License. Also, you must do one of these things:

a) Accompany the work with the complete corresponding machine-readable source code for the Library including whatever changes were used in the work (which must be distributed under Sections 1 and 2 above); and, if the work is an executable linked with the Library, with the complete machine-readable "work that uses the Library", as object code and/or source code, so that the user can modify the Library and then relink to produce a modified executable containing the modified Library. (It is understood that the user who changes the contents of definitions files in the Library will not necessarily be able to recompile the application to use the modified definitions.)

b) Accompany the work with a written offer, valid for at least three years, to give the same user the materials specified in Subsection 6a, above, for a charge no more than the cost of performing this distribution.

c) If distribution of the work is made by offering access to copy from a designated place, offer equivalent access to copy the above specified materials from the same place.

d) Verify that the user has already received a copy of these materials or that you have already sent this user a copy.

For an executable, the required form of the "work that uses the Library" must include any data and utility programs needed for reproducing the executable from it. However, as a special exception, the source code distributed need not include anything that is normally distributed (in either source or binary form) with the major components (compiler, kernel, and so on) of the operating system on which the executable runs, unless that component itself accompanies the executable.

It may happen that this requirement contradicts the license restrictions of other proprietary libraries that do not normally accompany the operating system. Such a contradiction means you cannot use both them and the Library together in an executable that you distribute.

7. You may place library facilities that are a work based on the Library side-by-side in a single library together with other library facilities not covered by this License, and distribute such a combined library, provided that the separate distribution of the work based on the Library and of the other library facilities is otherwise permitted, and provided that you do these two things:

a) Accompany the combined library with a copy of the same work based on the Library, uncombined with any other library facilities. This must be distributed under the terms of the Sections above.

b) Give prominent notice with the combined library of the fact that part of it is a work based on the Library, and explaining where to find the accompanying uncombined form of the same work.

8. You may not copy, modify, sublicense, link with, or distribute the Library except as expressly provided under this License. Any attempt otherwise to copy, modify, sublicense, link with, or distribute the Library is void, and will automatically terminate your rights under this License. However, parties who have received copies, or rights, from you under this License will not have their licenses terminated so long as such parties remain in full compliance.

9. You are not required to accept this License, since you have not signed it. However, nothing else grants you permission to modify or distribute the Library or its derivative works. These actions are prohibited by law if you do not accept this License. Therefore, by modifying or distributing the Library (or any work based on the Library), you indicate your acceptance of this License to do so, and all its terms and conditions for copying, distributing or modifying the Library or works based on it.

10. Each time you redistribute the Library (or any work based on the Library), the recipient automatically receives a license from the original licensor to copy, distribute, link with or modify the Library subject to these terms and conditions. You may not impose any further restrictions on the recipients' exercise of the rights granted herein. You are not responsible for enforcing compliance by third parties to this License.

11. If, as a consequence of a court judgment or allegation of patent infringement or for any other reason (not limited to patent issues), conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot distribute so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not distribute the Library at all. For example, if a patent license would not permit royalty-free redistribution of the Library by all those who receive copies directly or indirectly through you, then the only way you could satisfy both it and this License would be to refrain entirely from distribution of the Library.

If any portion of this section is held invalid or unenforceable under any particular circumstance, the balance of the section is intended to apply, and the section as a whole is intended to apply in other circumstances.

It is not the purpose of this section to induce you to infringe any patents or other property right claims or to contest validity of any such claims; this section has the sole purpose of protecting the integrity of the free software distribution system which is implemented by public license practices. Many people have made generous contributions to the wide range of software distributed through that system in reliance on consistent application of that system; it is up to the author/donor to decide if he or she is willing to distribute software through any other system and a licensee cannot impose that choice.

This section is intended to make thoroughly clear what is believed to be a consequence of the rest of this License.

12. If the distribution and/or use of the Library is restricted in certain countries either by patents or by copyrighted interfaces, the original copyright holder who places the Library under this License may add an explicit geographical distribution limitation excluding those countries, so that distribution is permitted only in or among countries not thus excluded. In such case, this License incorporates the limitation as if written in the body of this License.

13. The Free Software Foundation may publish revised and/or new versions of the Library General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.

Each version is given a distinguishing version number. If the Library specifies a version number of this License which applies to it and "any later version", you have the option of following the terms and conditions either of that version or of any later version published by the Free Software Foundation. If the Library does not specify a license version number, you may choose any version ever published by the Free Software Foundation.

14. If you wish to incorporate parts of the Library into other free programs whose distribution conditions are incompatible with these, write to the author to ask for permission. For software which is copyrighted by the Free Software Foundation, write to the Free Software Foundation; we sometimes make exceptions for this. Our decision will be guided by the two goals of preserving the free status of all derivatives of our free software and of promoting the sharing and reuse of software generally.

NO WARRANTY

15. BECAUSE THE LIBRARY IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE LIBRARY, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE LIBRARY "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE LIBRARY IS WITH YOU. SHOULD THE LIBRARY PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

16. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THE LIBRARY AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE LIBRARY (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE LIBRARY TO OPERATE WITH ANY OTHER SOFTWARE), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


License Agreement: MPL

Mozilla Public License Version 2.0

1. Definitions

1.1. "Contributor"

means each individual or legal entity that creates, contributes to the creation of, or owns Covered Software.

1.2. "Contributor Version"

means the combination of the Contributions of others (if any) used by a Contributor and that particular Contributor's Contribution.

1.3. "Contribution"

means Covered Software of a particular Contributor.

1.4. "Covered Software"

means Source Code Form to which the initial Contributor has attached the notice in Exhibit A, the Executable Form of such Source Code Form, and Modifications of such Source Code Form, in each case including portions thereof.

1.5. "Incompatible With Secondary Licenses"

means

a.that the initial Contributor has attached the notice described in Exhibit B to the Covered Software; or

b.that the Covered Software was made available under the terms of version 1.1 or earlier of the License, but not also under the terms of a Secondary License.

1.6. "Executable Form"

means any form of the work other than Source Code Form.

1.7. "Larger Work"

means a work that combines Covered Software with other material, in a separate file or files, that is not Covered Software.

1.8. "License"

means this document.

1.9. "Licensable"

means having the right to grant, to the maximum extent possible, whether at the time of the initial grant or subsequently, any and all of the rights conveyed by this License.

1.10. "Modifications"

means any of the following:

a.any file in Source Code Form that results from an addition to, deletion from, or modification of the contents of Covered Software; or

b.any new file in Source Code Form that contains any Covered Software.

1.11. "Patent Claims" of a Contributor

means any patent claim(s), including without limitation, method, process, and apparatus claims, in any patent Licensable by such Contributor that would be infringed, but for the grant of the License, by the making, using, selling, offering for sale, having made, import, or transfer of either its Contributions or its Contributor Version.

1.12. "Secondary License"

means either the GNU General Public License, Version 2.0, the GNU Lesser General Public License, Version 2.1, the GNU Affero General Public License, Version 3.0, or any later versions of those licenses.

1.13. "Source Code Form"

means the form of the work preferred for making modifications.

1.14. "You" (or "Your")

means an individual or a legal entity exercising rights under this License. For legal entities, "You" includes any entity that controls, is controlled by, or is under common control with You. For purposes of this definition, "control" means (a) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (b) ownership of more than fifty percent (50%) of the outstanding shares or beneficial ownership of such entity.

2. License Grants and Conditions

2.1. Grants

Each Contributor hereby grants You a world-wide, royalty-free, non-exclusive license:

a.under intellectual property rights (other than patent or trademark) Licensable by such Contributor to use, reproduce, make available, modify, display, perform, distribute, and otherwise exploit its Contributions, either on an unmodified basis, with Modifications, or as part of a Larger Work; and

b.under Patent Claims of such Contributor to make, use, sell, offer for sale, have made, import, and otherwise transfer either its Contributions or its Contributor Version.

2.2. Effective Date

The licenses granted in Section 2.1 with respect to any Contribution become effective for each Contribution on the date the Contributor first distributes such Contribution.

2.3. Limitations on Grant Scope

The licenses granted in this Section 2 are the only rights granted under this License. No additional rights or licenses will be implied from the distribution or licensing of Covered Software under this License. Notwithstanding Section 2.1(b) above, no patent license is granted by a Contributor:

a.for any code that a Contributor has removed from Covered Software; or

b.for infringements caused by: (i) Your and any other third party's modifications of Covered Software, or (ii) the combination of its Contributions with other software (except as part of its Contributor Version); or

c.under Patent Claims infringed by Covered Software in the absence of its Contributions.

This License does not grant any rights in the trademarks, service marks, or logos of any Contributor (except as may be necessary to comply with the notice requirements in Section 3.4).

2.4. Subsequent Licenses

No Contributor makes additional grants as a result of Your choice to distribute the Covered Software under a subsequent version of this License (see Section 10.2) or under the terms of a Secondary License (if permitted under the terms of Section 3.3).

2.5. Representation

Each Contributor represents that the Contributor believes its Contributions are its original creation(s) or it has sufficient rights to grant the rights to its Contributions conveyed by this License.

2.6. Fair Use

This License is not intended to limit any rights You have under applicable copyright doctrines of fair use, fair dealing, or other equivalents.

2.7. Conditions

Sections 3.1, 3.2, 3.3, and 3.4 are conditions of the licenses granted in Section 2.1.

3. Responsibilities

3.1. Distribution of Source Form

All distribution of Covered Software in Source Code Form, including any Modifications that You create or to which You contribute, must be under the terms of this License. You must inform recipients that the Source Code Form of the Covered Software is governed by the terms of this License, and how they can obtain a copy of this License. You may not attempt to alter or restrict the recipients' rights in the Source Code Form.

3.2. Distribution of Executable Form

If You distribute Covered Software in Executable Form then:

a.such Covered Software must also be made available in Source Code Form, as described in Section 3.1, and You must inform recipients of the Executable Form how they can obtain a copy of such Source Code Form by reasonable means in a timely manner, at a charge no more than the cost of distribution to the recipient; and

b.You may distribute such Executable Form under the terms of this License, or sublicense it under different terms, provided that the license for the Executable Form does not attempt to limit or alter the recipients' rights in the Source Code Form under this License.

3.3. Distribution of a Larger Work

You may create and distribute a Larger Work under terms of Your choice, provided that You also comply with the requirements of this License for the Covered Software. If the Larger Work is a combination of Covered Software with a work governed by one or more Secondary Licenses, and the Covered Software is not Incompatible With Secondary Licenses, this License permits You to additionally distribute such Covered Software under the terms of such Secondary License(s), so that the recipient of the Larger Work may, at their option, further distribute the Covered Software under the terms of either this License or such Secondary License(s).

3.4. Notices

You may not remove or alter the substance of any license notices (including copyright notices, patent notices, disclaimers of warranty, or limitations of liability) contained within the Source Code Form of the Covered Software, except that You may alter any license notices to the extent required to remedy known factual inaccuracies.

3.5. Application of Additional Terms

You may choose to offer, and to charge a fee for, warranty, support, indemnity or liability obligations to one or more recipients of Covered Software. However, You may do so only on Your own behalf, and not on behalf of any Contributor. You must make it absolutely clear that any such warranty, support, indemnity, or liability obligation is offered by You alone, and You hereby agree to indemnify every Contributor for any liability incurred by such Contributor as a result of warranty, support, indemnity or liability terms You offer. You may include additional disclaimers of warranty and limitations of liability specific to any jurisdiction.

4. Inability to Comply Due to Statute or Regulation

If it is impossible for You to comply with any of the terms of this License with respect to some or all of the Covered Software due to statute, judicial order, or regulation then You must: (a) comply with the terms of this License to the maximum extent possible; and (b) describe the limitations and the code they affect. Such description must be placed in a text file included with all distributions of the Covered Software under this License. Except to the extent prohibited by statute or regulation, such description must be sufficiently detailed for a recipient of ordinary skill to be able to understand it.

5. Termination

5.1. The rights granted under this License will terminate automatically if You fail to comply with any of its terms. However, if You become compliant, then the rights granted under this License from a particular Contributor are reinstated (a) provisionally, unless and until such Contributor explicitly and finally terminates Your grants, and (b) on an ongoing basis, if such Contributor fails to notify You of the non-compliance by some reasonable means prior to 60 days after You have come back into compliance. Moreover, Your grants from a particular Contributor are reinstated on an ongoing basis if such Contributor notifies You of the non-compliance by some reasonable means, this is the first time You have received notice of non-compliance with this License from such Contributor, and You become compliant prior to 30 days after Your receipt of the notice.

5.2. If You initiate litigation against any entity by asserting a patent infringement claim (excluding declaratory judgment actions, counter-claims, and cross-claims) alleging that a Contributor Version directly or indirectly infringes any patent, then the rights granted to You by any and all Contributors for the Covered Software under Section 2.1 of this License shall terminate.

5.3. In the event of termination under Sections 5.1 or 5.2 above, all end user license agreements (excluding distributors and resellers) which have been validly granted by You or Your distributors under this License prior to termination shall survive termination.

6. Disclaimer of Warranty

Covered Software is provided under this License on an "as is" basis, without warranty of any kind, either expressed, implied, or statutory, including, without limitation, warranties that the Covered Software is free of defects, merchantable, fit for a particular purpose or non-infringing. The entire risk as to the quality and performance of the Covered Software is with You. Should any Covered Software prove defective in any respect, You (not any Contributor) assume the cost of any necessary servicing, repair, or correction. This disclaimer of warranty constitutes an essential part of this License. No use of any Covered Software is authorized under this License except under this disclaimer.

7. Limitation of Liability

Under no circumstances and under no legal theory, whether tort (including negligence), contract, or otherwise, shall any Contributor, or anyone who distributes Covered Software as permitted above, be liable to You for any direct, indirect, special, incidental, or consequential damages of any character including, without limitation, damages for lost profits, loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses, even if such party shall have been informed of the possibility of such damages. This limitation of liability shall not apply to liability for death or personal injury resulting from such party's negligence to the extent applicable law prohibits such limitation. Some jurisdictions do not allow the exclusion or limitation of incidental or consequential damages, so this exclusion and limitation may not apply to You.

8. Litigation

Any litigation relating to this License may be brought only in the courts of a jurisdiction where the defendant maintains its principal place of business and such litigation shall be governed by laws of that jurisdiction, without reference to its conflict-of-law provisions. Nothing in this Section shall prevent a party's ability to bring cross-claims or counter-claims.

9. Miscellaneous

This License represents the complete agreement concerning the subject matter hereof. If any provision of this License is held to be unenforceable, such provision shall be reformed only to the extent necessary to make it enforceable. Any law or regulation which provides that the language of a contract shall be construed against the drafter shall not be used to construe this License against a Contributor.

10. Versions of the License

10.1. New Versions

Mozilla Foundation is the license steward. Except as provided in Section 10.3, no one other than the license steward has the right to modify or publish new versions of this License. Each version will be given a distinguishing version number.

10.2. Effect of New Versions

You may distribute the Covered Software under the terms of the version of the License under which You originally received the Covered Software, or under the terms of any subsequent version published by the license steward.

10.3. Modified Versions

If you create software not governed by this License, and you want to create a new license for such software, you may create and use a modified version of this License if you rename the license and remove any references to the name of the license steward (except to note that such modified license differs from this License).

10.4. Distributing Source Code Form that is Incompatible With Secondary Licenses

If You choose to distribute Source Code Form that is Incompatible With Secondary Licenses under the terms of this version of the License, the notice described in Exhibit B of this License must be attached.

Exhibit A - Source Code Form License Notice

This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at http://mozilla.org/MPL/2.0/.

If it is not possible or desirable to put the notice in a particular file, then You may include the notice in a location (such as a LICENSE file in a relevant directory) where a recipient would be likely to look for such a notice.

You may add additional accurate notices of copyright ownership.

Exhibit B - "Incompatible With Secondary Licenses" Notice

This Source Code Form is "Incompatible With Secondary Licenses", as defined by the Mozilla Public License, v. 2.0.


License Agreement: PCRE

PCRE License

PCRE is a library of functions to support regular expressions whose syntax and semantics are as close as possible to those of the Perl 5 language.

Release 8 of PCRE is distributed under the terms of the "BSD" licence, as specified below. The documentation for PCRE, supplied in the "doc" directory, is distributed under the same terms as the software itself.

The basic library functions are written in C and are freestanding. Also included in the distribution is a set of C++ wrapper functions.

THE BASIC LIBRARY FUNCTIONS

Written by: Philip Hazel

Email local part: ph10

Email domain: cam.ac.uk

University of Cambridge Computing Service,

Cambridge, England.

Copyright (c) 1997-2010 University of Cambridge

All rights reserved.

THE C++ WRAPPER FUNCTIONS

Contributed by: Google Inc.

Copyright (c) 2007-2010, Google Inc.

All rights reserved.

THE "BSD" LICENCE

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

·Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

·Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

·Neither the name of the University of Cambridge nor the name of Google Inc. nor the names of their contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


License Agreement: RegExpr

RegExpr License

Author:

Andrey V. Sorokin

St-Petersburg

Russia

anso@mail.ru, anso@usa.net

http://anso.da.ru

http://anso.virtualave.net

This library is derived from Henry Spencer sources. I translated the C sources into Object Pascal, implemented object wrapper and some new features. Many features suggested or partially implemented by TRegExpr's users (see Gratitude below).

Legal issues

Copyright (c) 1999-00 by Andrey V. Sorokin <anso@mail.ru>

This software is provided as it is, without any kind of warranty given. Use it at your own risk.

You may use this software in any kind of development, including comercial, redistribute, and modify it freely, under the following restrictions:

1.The origin of this software may not be mispresented, you must not claim that you wrote the original software. If you use this software in any kind of product, it would be appreciated that there in a information box, or in the documentation would be an acknowledgmnent like this

Partial Copyright (c) 2000 by Andrey V. Sorokin

1.You may not have any income from distributing this source to other developers. When you use this product in a comercial package, the source may not be charged seperatly.

Legal issues for the original C sources

Copyright (c) 1986 by University of Toronto.

Written by Henry Spencer. Not derived from licensed software.

Permission is granted to anyone to use this software for any purpose on any computer system, and to redistribute it freely, subject to the following restrictions:

1.The author is not responsible for the consequences of use of this software, no matter how awful, even if they arise from defects in it.

2.The origin of this software must not be misrepresented, either by explicit claim or by omission.

3.Altered versions must be plainly marked as such, and must not be misrepresented as being the original software.


License Agreement: TextDiff

TextDiff License

Author: Angus Johnson - angusj-AT-myrealbox-DOT-com

Copyright: © 2001-2005 Angus Johnson

Licence to use, terms and conditions

The code in the TDiff component is released as freeware provided you agree to the following terms & conditions:

1.the copyright notice, terms and conditions are left unchanged

2.modifications to the code by other authors must be clearly documented and accompanied by the modifier's name.

3.the TDiff component may be freely compiled into binary format and no acknowledgement is required. However, a discrete acknowledgement would be appreciated (eg. in a program's 'About Box').

Acknowledgements

The key algorithm in this component is based on:

"An O(ND) Difference Algorithm and its Variations"

By E Myers - Algorithmica Vol. 1 No. 2, 1986, pp. 251-266

http://www.cs.arizona.edu/people/gene/

http://www.cs.arizona.edu/people/gene/PAPERS/diff.ps


License Agreement: WavPack

WavPack License

Copyright (c) 1998 - 2009 Conifer Software

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:

·Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.

·Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

·Neither the name of Conifer Software nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


License Agreement: WiX

WiX License

Copyright (c) 2004, Outercurve Foundation.

This software is released under the Microsoft Reciprocal License (MS-RL) (the "License"); you may not use the software except in compliance with the License.

The text of the Microsoft Reciprocal License (MS-RL) can be found online at:

http://opensource.org/licenses/ms-rl

Microsoft Reciprocal License (MS-RL)

This license governs use of the accompanying software. If you use the software, you accept this license. If you do not accept the license, do not use the software.

1. Definitions

The terms "reproduce," "reproduction," "derivative works," and "distribution" have the same meaning here as under U.S. copyright law.

A "contribution" is the original software, or any additions or changes to the software.

A "contributor" is any person that distributes its contribution under this license.

"Licensed patents" are a contributor's patent claims that read directly on its contribution.

2. Grant of Rights

(A) Copyright Grant- Subject to the terms of this license, including the license conditions and limitations in section 3, each contributor grants you a non-exclusive, worldwide, royalty-free copyright license to reproduce its contribution, prepare derivative works of its contribution, and distribute its contribution or any derivative works that you create.

(B) Patent Grant- Subject to the terms of this license, including the license conditions and limitations in section 3, each contributor grants you a non-exclusive, worldwide, royalty-free license under its licensed patents to make, have made, use, sell, offer for sale, import, and/or otherwise dispose of its contribution in the software or derivative works of the contribution in the software.

3. Conditions and Limitations

(A) Reciprocal Grants- For any file you distribute that contains code from the software (in source code or binary format), you must provide recipients the source code to that file along with a copy of this license, which license will govern that file. You may license other files that are entirely your own work and do not contain code from the software under any terms you choose.

(B) No Trademark License- This license does not grant you rights to use any contributors' name, logo, or trademarks.

(C) If you bring a patent claim against any contributor over patents that you claim are infringed by the software, your patent license from such contributor to the software ends automatically.

(D) If you distribute any portion of the software, you must retain all copyright, patent, trademark, and attribution notices that are present in the software.

(E) If you distribute any portion of the software in source code form, you may do so only under this license by including a complete copy of this license with your distribution. If you distribute any portion of the software in compiled or object code form, you may only do so under a license that complies with this license.

(F) The software is licensed "as-is." You bear the risk of using it. The contributors give no express warranties, guarantees or conditions. You may have additional consumer rights under your local laws which this license cannot change. To the extent permitted under your local laws, the contributors exclude the implied warranties of merchantability, fitness for a particular purpose and non-infringement.


License Agreement: Zlib

Zlib License

zlib.h -- interface of the 'zlib' general purpose compression library

version 1.2.3, July 18th, 2005

Copyright (C) 1995-2005 Jean-loup Gailly and Mark Adler

This software is provided 'as-is', without any express or implied warranty. In no event will the authors be held liable for any damages arising from the use of this software.

Permission is granted to anyone to use this software for any purpose, including commercial applications, and to alter it and redistribute it freely, subject to the following restrictions:

1.The origin of this software must not be misrepresented; you must not claim that you wrote the original software. If you use this software in a product, an acknowledgment in the product documentation would be appreciated but is not required.

2.Altered source versions must be plainly marked as such, and must not be misrepresented as being the original software.

3.This notice may not be removed or altered from any source distribution.

Jean-loup Gailly <jloup@gzip.org> Mark Adler <madler@alumni.caltech.edu>

The data format used by the zlib library is described by RFCs (Request for Comments) 1950 to 1952 in the files http://www.ietf.org/rfc/rfc1950.txt (zlib format), rfc1951.txt (deflate format) and rfc1952.txt (gzip format).

Pascal translation:

copyright (c) 2000-2005 base2 technologies

copyright (c) 1997 Borland International


Attributes

Actions > Attributes

In the Actions menu, the Attributes command modifies various operating system attributes of the selected files and folders.

For Windows file systems, the DOS attributes (Read-only, Hidden or Archive) are modified. You cannot modify the System attribute.

For Mac and Linux file systems, the owner and group access permissions are modified.

If a folder is selected, its attributes are modified but not those of its contents. To modify the attributes of folder contents, you need to expand the folder and select the contents.

The checkboxes initially show the current state of the selected items. If a checkbox is unmarked, that attribute is disabled on all the selected files. If a checkbox is marked, that attribute is enabled on all the selected files. If a checkbox is marked and gray, that attribute is only enabled on some of the selected files.

Unmark a checkbox to clear that attribute from all selected files, or mark it to set the attribute.


Content Comparisons

Actions > Compare Contents

In the Actions menu, the Compare Contents [image] command performs content comparisons on the selected pairs of files to determine if they match.

Content comparison methods

CRC comparison compares files using their CRC values.

Binary comparison compares files byte-by-byte.

Rules-based comparison compares files based on their file format associations. It allows you to define unimportant differences, such as changes in whitespace or source code comments. A rules-based comparison can also ignore differences in file encoding or line endings.

Results of content comparisons

CRC and Binary comparisons return one of these results:

Binary same | The files are exactly the same.
Binary differences | At least one byte is different between the files.

Rules-based comparisons have a built-in binary comparison and return one of these results:

Binary same | The files are exactly the same.
Rules-based same | The files have binary differences, such as character encoding, that can be ignored.
Unimportant differences | A rules-based comparison found only unimportant differences.
Important differences | A rules-based comparison found important differences.

When content comparisons are performed

Content comparisons are performed:

·when a folder session is loaded, and its session settings call for automatic content comparisons

·explicitly, when the Compare Contents [image] command is used

·when a pair of files is opened in a file session


Copy

Actions > Copy to Right / Copy to Left / Copy to Side

In the Actions menu, the Copy to Right, Copy to Left and Copy to Side commands copy the selected files and folders from one side of the view to the other, overwriting any existing files on the target side.

If a folder is selected, only its filtered contents will be copied (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be copied.

By default, a confirmation dialog appears before the copy. To skip the confirmation when the direction of the copy is unambiguous (Copy to Left, Copy to Right), pick Tools > Options [image], switch to the File Operations page, and unmark the Confirm file copy checkbox.


Copy to Folder

Actions > Copy to Folder

In the Actions menu, the Copy to Folder [image] command copies the selected files and folders to a given folder, optionally with the path intact. You can select items on one side of the Folder Compare view or the other, but not both.

If a folder is selected, only its filtered contents will be copied (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be copied.

When you pick Copy to Folder, you can make the target an archive file (such as .zip). If the archive file does not exist, Beyond Compare will create it for you.

Path options example

In this example, three items are selected: The file 10.txt, the folder Q and the file 30.txt.

The pictures below show how the items look in the target folder, using each of the three available path options.

Keep relative folder structure

Determines the minimum difference between all of the selected files' paths, and creates that in the target folder. In this example, folders D and P were not selected, but they were created in the target folder in order to keep the same relative structure.

Keep base folder structure

Creates the entire path (back to the base folder) in the target folder.

Don't keep folder structure

Ignores all path information and copies all selected files and folders into the target folder together. In this example, only the Q folder was created in the target folder, because it was specifically selected.


Copy to Output

Actions > Copy to Output

In the Actions menu, the Copy to Output [image] command copies the selected files and folders to the output side.

If a folder is selected, only its filtered contents will be copied (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be copied.

By default, a confirmation dialog appears before the copy. To skip the confirmation, pick Tools > Options [image], switch to the File Operations page, and unmark the Confirm file copy checkbox.


Delete

Actions > Delete

In the Actions menu, the Delete [image] command deletes the selected files and folders from one or both sides of the comparison.

If a folder is selected, only its filtered contents will be deleted (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be deleted.

Mark the Use recycle bin if possible checkbox to move files and folders stored on a local drive to the recycle bin instead of being completely removed. This option is ignored for deletions from network drives, remote services and within archive files.


Exchange

Actions > Exchange

In the Actions menu, the Exchange command moves the selected files and folders from one side of the view to the other.

If a folder is selected, only its filtered contents will be exchanged (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be exchanged.

By default, a confirmation dialog appears before the exchange. To skip the confirmation, pick Tools > Options [image], switch to the File Operations page, and unmark the Confirm file move checkbox.


Exclude

Actions > Exclude

In the Actions menu, the Exclude command filters out the selected files and folders from the current session. It is a handy alternative to opening the Session Settings dialog and entering file/folder exclusions on the Name Filters tab.

If you select one or more files of the same type, the Exclude command will offer to exclude all files of that type.

To remove an exclude, click the Filters [image] toolbar button and remove the entry from the Exclude files (or Exclude folders) list.


Merge

Actions > Merge

In the Actions menu, the Merge [image] command performs a merge of the selected files and folders.

If a folder is selected, only its filtered contents will be merged (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be merged.

By default, a confirmation dialog appears before the merge. To skip the confirmation, pick Tools > Options [image], switch to the File Operations page, and unmark the Confirm file merge checkbox.


Move

Actions > Move to Right / Move to Left / Move to Side

In the Actions menu, the Move to Right, Move to Left and Move to Side commands move the selected files and folders from one side of the view to the other, overwriting any existing files on the target side.

If a folder is selected, only its filtered contents will be moved (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be moved.

By default, a confirmation dialog appears before the move. To skip the confirmation when the direction of the move is unambiguous (Move to Left, Move to Right), pick Tools > Options [image], switch to the File Operations page, and unmark the Confirm file move checkbox.


Move to Folder

Actions > Move to Folder

In the Actions menu, the Move to Folder [image] command moves the selected files and folders to a given folder, optionally with the path intact. You can select items on one side of the Folder Compare view or the other, but not both.

If a folder is selected, only its filtered contents will be moved (same as if the folder was expanded and all visible contents selected). However, if an open folder is selected and any of its children are selected as well, then the folder's selection is ignored and only the selected children will be moved.

When you pick Move to Folder, you can make the target an archive file (such as .zip). If the archive file does not exist, Beyond Compare will create it for you.

Path options example

In this example, three items are selected: The file 10.txt, the folder Q and the file 30.txt.

The pictures below show how the items look in the target folder, using each of the three available path options.

Keep relative folder structure

Determines the minimum difference between all of the selected files' paths, and creates that in the target folder. In this example, folders D and P were not selected, but they were created in the target folder in order to keep the same relative structure.

Keep base folder structure

Creates the entire path (back to the base folder) in the target folder.

Don't keep folder structure

Ignores all path information and moves all selected files and folders into the target folder together. In this example, only the Q folder was created in the target folder, because it was specifically selected.


New Folder

Actions > New Folder

In the Actions menu, the New Folder [image] command lets you create a folder at the current position. If you have a file or closed folder selected, the new folder will be created with the same parent folder as the selected item. If you have an opened folder selected, the new folder will be created as a subfolder of the selected one.

If both sides are selected, a new folder will be created on both sides.

You can create an archive file by including an appropriate extension (such as .zip) in the name.

To create a new folder to use as a base folder, type the path for the new folder into the left or right edit controls, and press the Enter key. In the warning dialog that appears, click the Create button.


Rename

Actions > Rename

In the Actions menu, the Rename [image] command renames the selected files and folders.

In the Action subsection, you can pick either DOS compatible or Regular expressions rename.

DOS rename

To rename files using DOS wildcards, pick DOS compatible in the Rename dialog. In the New mask edit, enter the new name.

If multiple files or folders are selected, a base mask is computed which represents the overlap of all the names. An asterisk (*) is used to represent one or more characters, while a question mark (?) is used to represent a single character. Leave these characters alone, but change others to produce unique names for each of the selected files or folders.

Examples:

Assume that you've selected the following files to rename:

abc1.txt

abc2.txt

abc3.txt

If you enter "abc?.bak" as the new mask, the files will be renamed to:

abc1.bak

abc2.bak

abc3.bak

If you enter "xyz?.txt" as the new mask, the files will be renamed to:

xyz1.txt

xyz2.txt

xyz3.txt

Regular expression rename

To rename files using Perl compatible regular expressions, pick Regular expressions in the Rename dialog. In the Old mask edit, enter a regular expression that is matched against the original filename. In the New mask edit, enter a template used to generate a new filename.

Examples:

Assume that you've selected the following files to rename:

abc1.txt

abc2.txt

abc3.txt

If you enter "txt" as the old mask and "bak" as the new mask, the files will be renamed to:

abc1.bak

abc2.bak

abc3.bak

If you enter ".*(\d\.txt)" as the old mask and "xyz$1" as the new mask, the files will be renamed to:

xyz1.txt

xyz2.txt

xyz3.txt


Synchronize

Actions > Synchronize > Update Right / Update Left / Update Both / Mirror to Right / Mirror to Left

In the Actions menu, the Synchronize submenu has commands that synchronize the current selection.

Update Right | Copies newer and orphan items from left to right.
Update Left | Copies newer and orphan items from right to left.
Update Both | Copies newer and orphan items from left to right and from right to left.
Mirror to Right | Replaces all different items on right, deletes any right-side orphans, and copies any left-side orphans to the right.
Mirror to Left | Replaces all different items on left, deletes any left-side orphans, and copies any right-side orphans to the left.


Touch

Actions > Touch

In the Actions menu, the Touch [image] command modifies the timestamp (date/time last modified) of the selected files.

If Copy timestamps from other side is marked, then the timestamps of the selected files will be set to match those on the other side. If Set timestamps to --> is marked, then any date/time can be selected from the calendar.

The Default selection controls how the calendar is initialized. Mark Current system time to use the current time. Mark Last touch to use the timestamp from the last touch operation. The Default selection only initializes the calendar -- you can still change it to any date or time.

If a folder is selected, the Touch command will attempt to change the folder's timestamp but not that of its contents. This command will fail if the operating system does not allow changing folder timestamps.


Rules vs. File Formats

In Beyond Compare, file formats describe the syntax of specific kinds of files by defining elements. File formats are typically picked automatically, based on the filename extension.

A Text Compare session defines which elements are important to the comparison. Notice that the session settings deal with elements in a more abstract manner while the various file formats handle the syntax details.

To change the default importance of an element type

1.In the Home view's Sessions tree, under the New branch, right-click on Text Compare and pick Edit.

2.Switch to the Importance tab.

3.Mark or unmark the appropriate checkboxes.

4.Click Save.

To override importance only in the current Text Compare view

1.Open Sessions > Session Settings [image] and switch to the Importance tab.

2.Mark or unmark the appropriate checkboxes.

3.At the bottom of the dialog, pick Use for this view only from the dropdown list.

4.Click OK.

To override importance in a Folder Compare session

1.From the Folder Compare session, open a child Text Compare session.

2.Open Sessions > Session Settings [image] and switch to the Importance tab.

3.Mark or unmark the appropriate checkboxes.

4.At the bottom of the dialog, pick Use for all files within parent session from the dropdown list.

5.Click OK.


Sample Regular Expressions

Expression | Meaning
^abc | Match "abc" at beginning of line
abc$ | Match "abc" at end of line
^abc$ | Match the line "abc" exactly
^\s*abc | Match "abc" at beginning of line, but allow leading whitespace
^\s*end;?\s*$ | Match a line containing only "end" or "end;" with leading or trailing whitespace
abc|def | Matches either "abc" or "def"
a(b|c)d | Matches "abd" or "acd"
a(b|c)d\1 | Matches "abdb" or "acdc", but it does not match "abdc"

Control characters used in above samples

Character | Meaning
^ | Beginning of line
$ | End of line
\s | Whitespace (a tab or space)
* | Zero or more of the preceding character
? | Preceding character is optional
| | Alternative expression
( ) | Subexpressions
\1 | Back reference to 1st subexpression

See also

Regular Expression Reference